(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     67664,       1791]
NotebookOptionsPosition[     63585,       1655]
NotebookOutlinePosition[     64164,       1677]
CellTagsIndexPosition[     64059,       1672]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\Jamal\\\\Desktop\\\\main\\\\MyThesis\\\\Examples//\
TenReS.m\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694167372350441*^9, 3.694167385792696*^9}, {
   3.6993427658432713`*^9, 3.6993428272217827`*^9}, {3.7262326477393084`*^9, 
   3.726232661647654*^9}, {3.7467793339755573`*^9, 3.7467793935119624`*^9}, 
   3.749442490010894*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package TenReS version 0.2.4\\nwritten by Clemens G. \
Raab\\nCopyright 2016, RICAM, Austrian Academy of Sciences\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwdzn1MDHAcx/Hrqit1tQsVIUUrRl2skaQcx3owmecpPZGHK6RuPRyqtRuH
StZKS5Sb4Q/Sg0upNNeDQnlKUw5JcuvoYUW3nvh9vn9899p3e2/fr2PkqZ1R
XA6Hs5kN9DK56ygZ0In2H/lBDvgblsKo7A1kY0W8OJqpEJaSjeldiVB7eG4S
dF6pbKB9WkNOnHY/H8NsH5GQyrC+IigROhXDJ+oDBieYHW25ZLYg0wd++NtK
nhnPOQ6fm70mjVVD/FPMQcUqC+i5ymU5FPdGkbXWqmrIPzdKvrNKb4FNuloy
Y9vLNljTzWuHBdxIs1jmZP4N0srfwBFKyn3ID5Gc9fB+hjdp03T7UBbz0sOf
pLPfS9cr0F7gBkMmArdA89EL5L0vLRG5zPRyXiR0yDvYmkt9Phn4p6YTpnAn
yLEAw8A83LcUkREeuiBoZ+SyA4baSXdDbWUpmbDdNxgWuMvIgM8tUjg1rE6A
inuzFHBenJjcOLY2Gz7tiycTcqcLYFqh13Vo4vzC5hqz3sHYFsbqri6F/V3t
pHllcI2Fjv09WEi+UsuGoT6xhnRy1oxDjYOtHkqLsrTZ6FK7yeRlje/Dh3Qi
+wUmHZDnpU5KYe5btzgZPljN15ZN6kQxDRKyYPSJ/hHz5PxpUi7o/weNOpdw
VMwQO6EA2tZHkwkaew9YJwolW5zKAuDbFYNkkZeB6VdmiWQTed/TYx1s/R1L
CjPX7IEL+6RkVVDPMThjZn8cdl/mymBaui+5yO/NRXgxzOIS1IevmIYjntHk
2ZMbeD3wpoyMiQuaA5s/ZZDPguT6b0zTHjXJH7xg2cvs0DaTh0aPiqHc5S7p
XWWcBuPEW8k7lmly+IsXr4DK1FuFMHF2ZzEsLHlXCW9WCB7Dxl17e6G7LKcf
ytp+W39nutm52kDl5mKV0RTrqv+RlTN1pULmR5MZUq4K4LozNdLz5H/wE2+B

  "]],

Cell[BoxData[
 StyleBox["\<\"A few definitions need to be made by the user. Type ?CoeffQ, \
?Specialization, and ?CyclicModules for more information.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.7560975562627683`*^9},
 CellTags->"Info-4659baee-630c-42ef-b017-3e23d057bcf4"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic definitions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6400787807134733`*^9, 3.640078788888632*^9}, {
  3.659170131248847*^9, 3.659170137303594*^9}, {3.682830115630125*^9, 
  3.6828301266446743`*^9}}],

Cell[TextData[{
 "We want to compute in the tensor ring over ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodules. However, bimodules are not implemented, so the implementation \
uses the tensor algebra product over ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-modules. Consequently, the cyclic ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["M", "K"], TraditionalForm]]],
 " is not a cyclic ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-module."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Specialization", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"K", ",", 
        OverscriptBox["R", "~"]}], "}"}]}], ",", 
     RowBox[{"\[CapitalPhi]", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", 
        OverscriptBox["\[CapitalPhi]", "~"]}], "}"}]}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6398890163113747`*^9, 3.639889054043709*^9}, {
   3.639889737312602*^9, 3.639889744112504*^9}, {3.6398940881500607`*^9, 
   3.639894098174966*^9}, {3.659086827358851*^9, 3.659086831494749*^9}, {
   3.659088973275432*^9, 3.659088977842003*^9}, {3.6590976281633368`*^9, 
   3.659097642819615*^9}, {3.670244973878394*^9, 3.670245032387117*^9}, {
   3.670247219591683*^9, 3.670247222415421*^9}, 3.6871531306206007`*^9, {
   3.689592234536019*^9, 3.6895922372660227`*^9}, 3.755931738846939*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicModules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", "Eval"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "Diff"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", "Int"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.659096534797022*^9, 3.6590965352753773`*^9}, {
   3.659096673633688*^9, 3.659096675368188*^9}, {3.670245062107257*^9, 
   3.6702451117240057`*^9}, {3.670245295686005*^9, 3.67024532450555*^9}, {
   3.670247225231395*^9, 3.6702472253272943`*^9}, 3.687153154519842*^9, 
   3.75593174463027*^9}],

Cell[CellGroupData[{

Cell["Bimodule structure", "Subsection",
 CellChangeTimes->{{3.683001088920826*^9, 3.68300109299426*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b", ":", 
     RowBox[{"Diff", "|", "Int", "|", "Eval", "|", 
      RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", "b", ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"mul", "[", 
     RowBox[{"b", ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"b", ",", "c"}], "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", "f__"}], "]"}], ",", "b___"}], 
   "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{"mul", "[", "f", "]"}], ",", "b"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "*", "c_Plus"}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "*", "#"}], "&"}], ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.682838778862541*^9, 3.682838843044186*^9}, 
   3.68283887404455*^9, {3.682838905347752*^9, 3.682838945747851*^9}, {
   3.6828389863455553`*^9, 3.682839001603705*^9}, {3.682839064639946*^9, 
   3.682839067127886*^9}, {3.6829202148020077`*^9, 3.682920246908084*^9}, {
   3.6829202861393833`*^9, 3.682920383404994*^9}, {3.6829204540780697`*^9, 
   3.6829204543463497`*^9}, {3.682920550373654*^9, 3.682920568978134*^9}, {
   3.687153170837471*^9, 3.6871531990579205`*^9}, 3.6871532388223906`*^9, {
   3.6871532710520473`*^9, 3.687153299007296*^9}, {3.6871537992221746`*^9, 
   3.6871538033249817`*^9}, 3.6895922436960316`*^9, 3.755931754688845*^9, {
   3.755932176262958*^9, 3.7559321772710156`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Membership checks", "Subsection",
 CellChangeTimes->{{3.6591723429752007`*^9, 3.6591723786702147`*^9}, {
  3.670250652868689*^9, 3.6702506619234743`*^9}}],

Cell["Check for constants:", "Text",
 CellChangeTimes->{{3.659163098154707*^9, 3.659163115075246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "K"], "[", "f_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Diff", "[", "f", "]"}], "===", "0"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.638682699993037*^9, 3.638682727301762*^9}, 
   3.67024541657796*^9, {3.68715821445373*^9, 3.6871582755278373`*^9}, {
   3.6871584196564903`*^9, 3.6871584226048956`*^9}, {3.6895922571560507`*^9, 
   3.6895922587360525`*^9}}],

Cell["Check for membership in the function algebra:", "Text",
 CellChangeTimes->{{3.6591631194512157`*^9, 3.6591631291876383`*^9}, 
   3.659163217493614*^9, {3.6591724206231956`*^9, 3.659172422789729*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"F", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "A", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f_mul", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "[", "k_Integer", "]"}], ":=", 
  RowBox[{"F", "[", "k", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"F", "[", "1", "]"}], ":=", "A"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{{3.669455790328519*^9, 3.6694557970644712`*^9}, {
   3.669543619267727*^9, 3.669543632574329*^9}, {3.670245501045932*^9, 
   3.670245606567086*^9}, 3.670246245762525*^9, 3.682830172179517*^9, {
   3.6828355629428263`*^9, 3.682835600736021*^9}, {3.6871533509085875`*^9, 
   3.687153351704189*^9}, {3.689592274976075*^9, 3.689592324676145*^9}, {
   3.6895923885585527`*^9, 3.689592428534314*^9}, {3.698728886447846*^9, 
   3.698728918015327*^9}, {3.698730164873973*^9, 3.698730171312064*^9}, {
   3.698730495221025*^9, 3.6987304978995113`*^9}, {3.69873057212881*^9, 
   3.698730576040122*^9}, {3.7559321957820745`*^9, 3.755932196311105*^9}, {
   3.7559338015509195`*^9, 3.755933833014719*^9}}],

Cell["Check for functionals:", "Text",
 CellChangeTimes->{{3.670245973081357*^9, 3.670245977713456*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", "Eval", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", 
   RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.6702459832458897`*^9, 3.670246019832996*^9}, {
   3.687103716685647*^9, 3.687103749558527*^9}, {3.6871039884201894`*^9, 
   3.6871039890202236`*^9}, 3.687153387038251*^9}],

Cell["Check for membership in the other cyclic modules:", "Text",
 CellChangeTimes->{{3.6702458564563427`*^9, 3.670245866975058*^9}, {
  3.670245946760453*^9, 3.670245947584765*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "D"], "[", "Diff", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<I\>\""], "[", "Int", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<E\>\""], "[", "Eval", "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.7559322391505547`*^9, 3.7559322400066037`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function algebra", "Subsection",
 CellChangeTimes->{{3.638691610025188*^9, 3.638691614921186*^9}, {
  3.659165795915909*^9, 3.6591657979705772`*^9}}],

Cell[CellGroupData[{

Cell["Multiplication", "Subsubsection",
 CellChangeTimes->{{3.659165569776952*^9, 3.659165577588789*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Plus", ",", "c___"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"a", ",", "#", ",", "c"}], "]"}], "&"}], "/@", "b"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Integer", ",", "c__"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a__", ",", "b_Integer", ",", "c___"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"d_Integer", "*", "b_"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"d", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", "b__", "]"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", "a_", "]"}], ":=", "a"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.638684986800296*^9, 3.638685023740603*^9}, {
   3.638685085399458*^9, 3.6386851016267347`*^9}, {3.6386852559617443`*^9, 
   3.638685292086501*^9}, {3.638685328564872*^9, 3.63868533076567*^9}, {
   3.638685453632114*^9, 3.638685456591627*^9}, {3.638685773732319*^9, 
   3.63868577618708*^9}, 3.6386858741418343`*^9, {3.63869290635741*^9, 
   3.6386929232045727`*^9}, {3.6387824422362843`*^9, 3.638782493065415*^9}, {
   3.6388722777325487`*^9, 3.6388722903501*^9}, {3.639212523253624*^9, 
   3.639212586876335*^9}, 3.639980360207717*^9, {3.7559325279740744`*^9, 
   3.755932528956131*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiation", "Subsubsection",
 CellChangeTimes->{{3.659163141267557*^9, 3.6591631488521423`*^9}, 
   3.659165586346394*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", "NumericQ"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[CurlyPhi]_", "?", 
      SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ")"}], "[", "f_", "]"}], 
   "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "a_mul", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"MapAt", "[", 
     RowBox[{"Diff", ",", "a", ",", "i"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"inv", "[", "f", "]"}], ",", 
     RowBox[{"Diff", "[", "f", "]"}], ",", 
     RowBox[{"inv", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Diff", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.638682746051725*^9, 3.638682788960909*^9}, {
   3.638682825870358*^9, 3.638682962118843*^9}, {3.6386831317951612`*^9, 
   3.638683190849043*^9}, {3.638683239496002*^9, 3.638683300736999*^9}, {
   3.638683391426631*^9, 3.6386834461159897`*^9}, {3.638782252717188*^9, 
   3.638782253282292*^9}, {3.638782504556032*^9, 3.6387825049058027`*^9}, {
   3.639212762878365*^9, 3.639212788512412*^9}, {3.640058908518703*^9, 
   3.640058989848414*^9}, {3.6400590763931026`*^9, 3.640059144710424*^9}, {
   3.659159838349127*^9, 3.659159839787879*^9}, {3.659701295933262*^9, 
   3.6597012991698523`*^9}, {3.659701749337516*^9, 3.6597017541360083`*^9}, {
   3.659701785652364*^9, 3.6597017880263767`*^9}, {3.659701846596245*^9, 
   3.6597018492038803`*^9}, {3.670246185189465*^9, 3.670246215676208*^9}, {
   3.670246254518935*^9, 3.670246256356043*^9}, {3.670246334717093*^9, 
   3.670246369529475*^9}, 3.670246738163018*^9, {3.670249771073493*^9, 
   3.6702497719200172`*^9}, {3.68283571585677*^9, 3.682835730684732*^9}, {
   3.6829379750055523`*^9, 3.682937975485763*^9}, {3.6829429368147717`*^9, 
   3.68294293771128*^9}, {3.6871559666597815`*^9, 3.687155983913412*^9}, {
   3.6871561575257173`*^9, 3.6871561891167727`*^9}, {3.6871583790964193`*^9, 
   3.687158413042079*^9}, 3.6895924605543594`*^9, {3.7262066801423664`*^9, 
   3.726206691530386*^9}, {3.7262067287676516`*^9, 3.726206739937271*^9}, {
   3.7559322809769473`*^9, 3.7559322847511635`*^9}, {3.755932534150428*^9, 
   3.755932558447818*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Integration", "Subsubsection",
 CellChangeTimes->{{3.6591631541798153`*^9, 3.6591631569643307`*^9}, 
   3.6591655902493143`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"f_", "?", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["MemberQ", "K"], "[", "#", "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#", "=!=", "1"}], ")"}]}], "&"}], ")"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"f", ",", " ", 
    RowBox[{"Int", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f__", ",", 
     RowBox[{"c_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", 
     RowBox[{"mul", "[", "f", "]"}], "]"}], ",", "c"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"f", "-", 
   RowBox[{"Eval", "[", "f", "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "K"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Int", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.659162411432198*^9, 3.659162412408951*^9}, {
   3.659164197207127*^9, 3.659164197790752*^9}, {3.659171490362842*^9, 
   3.659171491487652*^9}, {3.6597013045303164`*^9, 3.6597013070497923`*^9}, {
   3.65970147718134*^9, 3.659701479851516*^9}, {3.670246390359516*^9, 
   3.670246410313141*^9}, {3.682835743292811*^9, 3.682835756499106*^9}, {
   3.682922363505677*^9, 3.6829223924145117`*^9}, {3.682926287313134*^9, 
   3.682926320109994*^9}, 3.6895924739343777`*^9, {3.723020749052878*^9, 
   3.723020756203888*^9}, {3.7559325694224453`*^9, 3.755932570262493*^9}, {
   3.75593398986069*^9, 3.75593399196881*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Induced evaluation", "Subsubsection",
 CellChangeTimes->{{3.6591631661642323`*^9, 3.659163171220705*^9}, 
   3.659165594273448*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.65916263319906*^9, 3.6591626335436068`*^9}, {
   3.670246424800674*^9, 3.670246429623632*^9}, {3.6828358313150043`*^9, 
   3.6828358410828857`*^9}, {3.6829210945837917`*^9, 3.682921099615996*^9}, {
   3.682922258911646*^9, 3.682922261329509*^9}, {3.6871018941824055`*^9, 
   3.687101922244011*^9}, 3.6871021395064373`*^9, 3.689592465414366*^9, {
   3.7468691954155674`*^9, 3.746869196190612*^9}, {3.7559325785899696`*^9, 
   3.7559325793570137`*^9}, {3.755933905621872*^9, 3.755933906958948*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functionals", "Subsubsection",
 CellChangeTimes->{{3.6591641415283527`*^9, 3.6591641443831253`*^9}, 
   3.6591656005776367`*^9}],

Cell[BoxData[{
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "1", "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "j_Integer", "]"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "j", "]"}], "[", "f", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871017707413454`*^9, 3.6871017750975943`*^9}, {
   3.6871018476607447`*^9, 3.687101848025766*^9}, 3.687102142485608*^9, {
   3.755932585022338*^9, 3.755932585958391*^9}, {3.7559399046069937`*^9, 
   3.755939994335126*^9}, {3.7559400312642384`*^9, 3.7559400353364716`*^9}, {
   3.7559453788342495`*^9, 3.7559453834225116`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Defining reduction system ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[CapitalSigma]", "0"], TraditionalForm]]],
 " for the ring of IDO "
}], "Section",
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.689581032213399*^9, 3.6895810467682247`*^9}, {3.68960443947054*^9, 
  3.689604448810074*^9}, {3.689604552973032*^9, 3.6896045552701635`*^9}, {
  3.7558614614959583`*^9, 3.7558614857443447`*^9}, {3.75592895198654*^9, 
  3.7559289777160115`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "K"], "[", "k_", "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"k", " ", 
    RowBox[{"Prod", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "RR"], "[", 
   RowBox[{"f_", ",", "g_"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]R"], "[", 
   RowBox[{"\[CurlyPhi]_", ",", "f_"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CurlyPhi]", "[", "f", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"], "[", 
   RowBox[{"\[CurlyPhi]_", ",", "\[Psi]_"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[Psi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DR"], "[", 
   RowBox[{"Diff", ",", "f_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"Diff", "[", "f", "]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{"f", ",", "Diff"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "D\[CapitalPhi]"], "[", 
   RowBox[{"Diff", ",", "\[CurlyPhi]_"}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DI"], "[", 
   RowBox[{"Diff", ",", "Int"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "ID"], "[", 
   RowBox[{"Int", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "]"}], "-", 
   RowBox[{"Prod", "[", "Eval", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830444156025*^9, 3.682830470225523*^9}, {
   3.682834198147834*^9, 3.682834214536252*^9}, {3.682851644402529*^9, 
   3.682851645428053*^9}, {3.6871003756050105`*^9, 3.68710039816265*^9}, {
   3.687151940149107*^9, 3.687151949961524*^9}, 3.6871521643059006`*^9, {
   3.687152270432887*^9, 3.687152272648091*^9}, {3.6895810173153725`*^9, 
   3.689581023352583*^9}, {3.6895810543342376`*^9, 3.689581093240706*^9}, {
   3.689581124085246*^9, 3.6895811380500445`*^9}, {3.6895811689058094`*^9, 
   3.689581169737857*^9}, {3.7559289704545965`*^9, 3.7559289730497446`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "K", "}"}], ",", 
       SubscriptBox["h", "K"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "RR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "DR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "DI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "ID"]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.682830530164171*^9, 3.682830552422223*^9}, {
   3.6828342194350443`*^9, 3.682834227304326*^9}, {3.68710040948827*^9, 
   3.6871004099094706`*^9}, 3.6871009848200808`*^9, {3.689581178634366*^9, 
   3.6895813073258944`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Completion ", "Section",
 CellChangeTimes->{{3.682830503896991*^9, 3.682830505456471*^9}, {
  3.755856067808457*^9, 3.7558561497441435`*^9}}],

Cell[TextData[{
 "In \[OpenCurlyDoubleQuote]Basic definitions\[CloseCurlyDoubleQuote], we \
have implemented the identities which correspond to the definition of an \
integro-differential ring, see ",
 StyleBox["Definition 4.1",
  FontWeight->"Bold"],
 ". Based on these defining identities, reduction rules in ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    SubscriptBox["\[CapitalSigma]", "0"],
    FontWeight->"Bold"], TraditionalForm]]],
 " encode the corresponding operator identities. \n\nUsing the function ",
 StyleBox["CheckResolvability, ",
  FontWeight->"Bold"],
 "we can check the confluence criterion for the given reduction system. The \
function generates  all the ambiguities and their S-polynomials. For each \
ambiguity, the function checks whether the S-polynomials are reduced to zero. \
The output contains non-resolvable ambiguities and a normal form of their \
corresponding S-polynomials.\n\nIn each completion step, based on the \
non-resolvable ambiguities, we add new rules to the reduction system. We also \
implement their corresponding identities in ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]]],
 ", see ",
 StyleBox["Remark 4.11. ",
  FontWeight->"Bold"]
}], "Text",
 CellChangeTimes->{{3.7558561421947117`*^9, 3.755856145207884*^9}, {
   3.755856196919842*^9, 3.7558563728959064`*^9}, {3.7558564582797904`*^9, 
   3.755856541751565*^9}, {3.7558616842647*^9, 3.755861724754016*^9}, {
   3.755861843808825*^9, 3.755861939952324*^9}, {3.7558622628737946`*^9, 
   3.7558622685451183`*^9}, {3.7558623012739906`*^9, 3.755862324185301*^9}, {
   3.7558653139293046`*^9, 3.75586534410503*^9}, 3.7559238409542055`*^9, {
   3.7559238981584773`*^9, 3.7559239282702*^9}, {3.7559246185746827`*^9, 
   3.7559246186706886`*^9}, {3.755929025871766*^9, 3.7559290285439186`*^9}, 
   3.755929933279667*^9, {3.7559299908309584`*^9, 3.7559299922770414`*^9}, {
   3.7559309547920938`*^9, 3.7559310473593884`*^9}, {3.755940060382904*^9, 
   3.755940176358537*^9}, {3.7559402687508216`*^9, 3.755940343511098*^9}, {
   3.755940393990985*^9, 3.7559405507039485`*^9}, {3.7559405924703374`*^9, 
   3.7559406310875463`*^9}, {3.7559407301432123`*^9, 3.755940795005922*^9}, {
   3.755940852111188*^9, 3.7559408787107096`*^9}, {3.7559409757992625`*^9, 
   3.7559410127353754`*^9}, {3.755941238196271*^9, 3.7559413263433123`*^9}, {
   3.7559413639604645`*^9, 3.7559414274150934`*^9}, {3.755941474607793*^9, 
   3.755941580663859*^9}, {3.755941655967166*^9, 3.7559416928152733`*^9}, {
   3.755941784527519*^9, 3.7559418023745403`*^9}, {3.755941839906687*^9, 
   3.755941841502778*^9}, {3.755941880143988*^9, 3.755941935912178*^9}, {
   3.75594197109419*^9, 3.755941992503415*^9}, {3.755942034803834*^9, 
   3.7559420537109156`*^9}, {3.7559421378257265`*^9, 
   3.7559421384717636`*^9}, {3.7559444102958517`*^9, 3.755944421816511*^9}, {
   3.755944460371716*^9, 3.7559445135477576`*^9}, {3.755944591368209*^9, 
   3.7559445916792264`*^9}, {3.755944673479905*^9, 3.7559446736559153`*^9}, {
   3.7559447402237225`*^9, 3.7559447408307576`*^9}, {3.7559447916466637`*^9, 
   3.755944819574261*^9}, {3.7559448812557893`*^9, 3.7559448960706367`*^9}, {
   3.7559449390630956`*^9, 3.755945082359292*^9}, {3.7559451735035048`*^9, 
   3.7559452715831146`*^9}, 3.755945326175237*^9, {3.7559462150800796`*^9, 
   3.75594638205563*^9}, {3.755946460849137*^9, 3.7559464613841677`*^9}, {
   3.7559464929669743`*^9, 3.75594649482408*^9}, {3.7559465400236654`*^9, 
   3.7559465536154428`*^9}, {3.755946590056527*^9, 3.755946662711683*^9}, 
   3.755947000576008*^9, {3.755947424504255*^9, 3.755947474608121*^9}, {
   3.755947642735737*^9, 3.755947643894803*^9}, {3.7559484814827104`*^9, 
   3.755948483712838*^9}, {3.75594866750535*^9, 3.7559487120929008`*^9}, {
   3.755948764274885*^9, 3.7559487980048146`*^9}, {3.755949211177447*^9, 
   3.7559493246689377`*^9}, {3.755949366987358*^9, 3.7559493712886047`*^9}, {
   3.755949412419957*^9, 3.755949416215174*^9}, {3.755949802795285*^9, 
   3.755949908056306*^9}, {3.75594998593476*^9, 3.7559501712503595`*^9}, {
   3.7559502556141853`*^9, 3.755950256157216*^9}, {3.75595057529847*^9, 
   3.755950576379532*^9}, {3.755950682239587*^9, 3.7559507205417776`*^9}, {
   3.7559510964812803`*^9, 3.7559511463221307`*^9}, {3.755951185310361*^9, 
   3.7559513369740353`*^9}, {3.756008767898015*^9, 3.756008781289781*^9}, 
   3.756112057691718*^9}],

Cell[CellGroupData[{

Cell["Step 1", "Subsection",
 CellChangeTimes->{{3.689581662101718*^9, 3.689581665190523*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"unresolvable", "=", 
  RowBox[{"CheckResolvability", "[", 
   RowBox[{"RedSys", ",", 
    RowBox[{"Count", "\[Rule]", " ", "True"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7288901544786987`*^9, 3.7288901786230803`*^9}, {
   3.728895491337925*^9, 3.7288955016963425`*^9}, {3.728895567265758*^9, 
   3.7288955718989663`*^9}, 3.7559291532380505`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"15", "\[InvisibleSpace]", "\<\" ambiguities in total\"\>"}],
  SequenceForm[15, " ambiguities in total"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.728890721521132*^9, 3.7288955125096617`*^9, 3.728895581711384*^9, 
   3.7288973460331078`*^9, 3.728899729743271*^9, 3.749442375392338*^9, 
   3.7558388012398653`*^9, 3.7559243207506485`*^9, 3.7559243743687153`*^9, 
   3.755924406827572*^9, 3.7559244694911556`*^9, 3.7559245152817745`*^9, 
   3.7559291654057465`*^9, 3.755930505104373*^9, 3.755933748080861*^9, 
   3.7559338526618423`*^9, 3.7559377344078655`*^9, 3.755937910561941*^9, 
   3.755938341528591*^9, 3.755938818495872*^9, {3.7559388542769184`*^9, 
   3.7559388838876123`*^9}, 3.7559390473139596`*^9, 3.755939078986771*^9, 
   3.7559392568149424`*^9, 3.755939604940854*^9, 3.755939636901682*^9, 
   3.7559400176834617`*^9, 3.756008880633463*^9, 3.7560969042754765`*^9, 
   3.7560975564287777`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "3", "\[InvisibleSpace]", "\<\" ambiguities have all S-polynomials equal to \
zero\"\>"}],
  SequenceForm[3, " ambiguities have all S-polynomials equal to zero"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.728890721521132*^9, 3.7288955125096617`*^9, 3.728895581711384*^9, 
   3.7288973460331078`*^9, 3.728899729743271*^9, 3.749442375392338*^9, 
   3.7558388012398653`*^9, 3.7559243207506485`*^9, 3.7559243743687153`*^9, 
   3.755924406827572*^9, 3.7559244694911556`*^9, 3.7559245152817745`*^9, 
   3.7559291654057465`*^9, 3.755930505104373*^9, 3.755933748080861*^9, 
   3.7559338526618423`*^9, 3.7559377344078655`*^9, 3.755937910561941*^9, 
   3.755938341528591*^9, 3.755938818495872*^9, {3.7559388542769184`*^9, 
   3.7559388838876123`*^9}, 3.7559390473139596`*^9, 3.755939078986771*^9, 
   3.7559392568149424`*^9, 3.755939604940854*^9, 3.755939636901682*^9, 
   3.7559400176834617`*^9, 3.756008880633463*^9, 3.7560969042754765`*^9, 
   3.756097556457779*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"13", "\[InvisibleSpace]", "\<\" ambiguities are resolvable\"\>"}],
  SequenceForm[13, " ambiguities are resolvable"],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.728890721521132*^9, 3.7288955125096617`*^9, 3.728895581711384*^9, 
   3.7288973460331078`*^9, 3.728899729743271*^9, 3.749442375392338*^9, 
   3.7558388012398653`*^9, 3.7559243207506485`*^9, 3.7559243743687153`*^9, 
   3.755924406827572*^9, 3.7559244694911556`*^9, 3.7559245152817745`*^9, 
   3.7559291654057465`*^9, 3.755930505104373*^9, 3.755933748080861*^9, 
   3.7559338526618423`*^9, 3.7559377344078655`*^9, 3.755937910561941*^9, 
   3.755938341528591*^9, 3.755938818495872*^9, {3.7559388542769184`*^9, 
   3.7559388838876123`*^9}, 3.7559390473139596`*^9, 3.755939078986771*^9, 
   3.7559392568149424`*^9, 3.755939604940854*^9, 3.755939636901682*^9, 
   3.7559400176834617`*^9, 3.756008880633463*^9, 3.7560969042754765`*^9, 
   3.7560975564617796`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Overlap", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "D", ",", "R"}], "}"}], ",", 
       RowBox[{"{", "R", "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"Prod", "[", "A", "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", 
        RowBox[{"Diff", "[", "A", "]"}]}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Eval", "[", "A", "]"}], " ", 
         RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", "A", ",", "Diff"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Overlap", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "D", ",", "\<\"I\"\>"}], "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Eval", ",", "Int"}], "]"}]}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.687104611861848*^9, 3.6871519643291492`*^9, 3.6871520539669065`*^9, 
   3.687152182698333*^9, 3.6871522901669216`*^9, 3.6895814126416793`*^9, 
   3.6895814933718214`*^9, 3.6895815684391527`*^9, 3.6895817857007346`*^9, 
   3.6895818390372286`*^9, 3.689592166705924*^9, 3.7288880592763777`*^9, 
   3.728888111146468*^9, {3.728890192147854*^9, 3.7288902117059727`*^9}, 
   3.7288907215811357`*^9, 3.728895512603262*^9, 3.728895581789384*^9, 
   3.728897346111108*^9, 3.7288997298056707`*^9, 3.7494423755973496`*^9, 
   3.7558388014188757`*^9, 3.755924320920658*^9, 3.7559243745847273`*^9, 
   3.755924407036584*^9, 3.7559244697281694`*^9, 3.755924515510788*^9, 
   3.7559291654177475`*^9, 3.755930505128374*^9, 3.7559337481098623`*^9, 
   3.755933852710845*^9, 3.7559377344318666`*^9, 3.7559379105869427`*^9, 
   3.7559383415515924`*^9, 3.755938818519873*^9, {3.7559388543009195`*^9, 
   3.755938883910613*^9}, 3.7559390473619623`*^9, 3.7559390790097723`*^9, 
   3.7559392568379436`*^9, 3.755939604971856*^9, 3.7559396369306836`*^9, 
   3.755940017714463*^9, 3.756008880647464*^9, 3.756096904286477*^9, 
   3.7560975564667797`*^9}]
}, Open  ]],

Cell[TextData[{
 "From the reduction rules ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "ID"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "DI"], TraditionalForm]]],
 ", we obtain a non-resolvable ambiguity which the corresponding S-polynomial \
induces the rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "EI"], TraditionalForm]]],
 ". In addition, from the  corresponding S-polynomial to overlap ambiguity \
between the reduction rules ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "ID"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "DR"], TraditionalForm]]],
 " we obtain the reduction rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRD"], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.755865407243642*^9, 3.7558654244016232`*^9}, {
   3.755923982618308*^9, 3.7559240039415283`*^9}, {3.7559240734145017`*^9, 
   3.7559240738215246`*^9}, {3.7559455988868356`*^9, 3.755945694806322*^9}, {
   3.755945727382185*^9, 3.7559457594550195`*^9}, {3.755945832387191*^9, 
   3.7559458644790263`*^9}, {3.755945917599065*^9, 3.755945947870796*^9}, {
   3.7559459794226007`*^9, 3.755946041527153*^9}, {3.755947237664568*^9, 
   3.7559472678312936`*^9}, 3.756121431785384*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "EI"], "[", 
   RowBox[{"Eval", ",", "Int"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRD"], "[", 
   RowBox[{"Int", ",", "f_", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "f", "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Eval", "[", "f", "]"}], " ", 
      RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Diff", "[", "f", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830634387086*^9, 3.682830639304961*^9}, {
   3.682830694698382*^9, 3.682830747166482*^9}, {3.68283078821445*^9, 
   3.682830805818577*^9}, {3.68283478162504*^9, 3.68283478285819*^9}, {
   3.682920973099743*^9, 3.6829209807736273`*^9}, 3.6871013187034903`*^9, {
   3.6871013654091616`*^9, 3.6871013716335173`*^9}, {3.687101534568837*^9, 
   3.6871015404691744`*^9}, 3.6871031475540943`*^9, 3.687103786721653*^9, 
   3.6895810771258774`*^9, 3.6895814340605173`*^9, 3.6895815756151657`*^9, {
   3.755938534691639*^9, 3.755938535742699*^9}, {3.7559395872568426`*^9, 
   3.7559396164145103`*^9}, {3.755945818277384*^9, 3.755945825471795*^9}, {
   3.755947273495618*^9, 3.755947277942872*^9}}],

Cell["\<\
We add these new rules to our reduction system and check the confluence \
criterion for the new reduction system.\
\>", "Text",
 CellChangeTimes->{{3.7558626717531805`*^9, 3.755862745632406*^9}, {
  3.7559240963568134`*^9, 3.755924123813384*^9}, {3.755946067638646*^9, 
  3.7559461034946976`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"RedSys", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<E\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
         SubscriptBox["h", "EI"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<I\>\"", ",", "R", ",", "D"}], "}"}], ",", 
         SubscriptBox["h", "IRD"]}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.682830828041789*^9, 3.6828308502723293`*^9}, 
   3.6828348299105062`*^9, {3.6895814400509276`*^9, 3.6895814507525463`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "corresponding identities in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"R", ":"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.756096668080967*^9, 3.756096696557596*^9}, 
   3.7560976914495*^9, 3.756121438850788*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ",", " ", 
     RowBox[{"Diff", "[", 
      RowBox[{"g_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}]}], "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "-", 
   RowBox[{"Int", "[", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"Diff", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], "-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"Eval", "[", "f", "]"}], ",", 
     RowBox[{"Eval", "[", "g", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.7559338869638042`*^9, 3.7559339147143917`*^9}, {
   3.7559340948936973`*^9, 3.7559341022231164`*^9}, {3.755937543965973*^9, 
   3.7559375959019437`*^9}, {3.755937642399603*^9, 3.7559377167748575`*^9}, {
   3.7559378916268578`*^9, 3.7559378962631235`*^9}, {3.755938285723399*^9, 
   3.7559382890625896`*^9}, {3.7559396204167395`*^9, 
   3.7559396239759426`*^9}, {3.7559453632423573`*^9, 3.755945370190755*^9}, 
   3.756008851080773*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 2", "Subsection",
 CellChangeTimes->{{3.689581619669643*^9, 3.689581632024865*^9}, 
   3.689581693535773*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"unresolvable", "=", 
  RowBox[{"CheckResolvability", "[", "RedSys", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Overlap", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "R", ",", "D", ",", "\[CapitalPhi]"}], 
        "}"}], ",", 
       RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"Prod", "[", 
       RowBox[{"A", ",", 
        RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Eval", "[", "A", "]"}], " ", 
         RowBox[{"Prod", "[", "]"}]}], ",", 
        RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", 
        RowBox[{"Diff", "[", "A", "]"}], ",", 
        RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Overlap", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "R", ",", "D", ",", "\<\"I\"\>"}], "}"}], 
       ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"Prod", "[", 
       RowBox[{"A", ",", "Int"}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", "A"}], "]"}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", 
        RowBox[{"Diff", "[", "A", "]"}], ",", "Int"}], "]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.682830871442047*^9, 3.6828348358911743`*^9, 3.682921165433907*^9, 
   3.6829219404086437`*^9, 3.682922120776589*^9, 3.682922268007895*^9, 
   3.6829269536275797`*^9, 3.682937724321272*^9, 3.682937828458033*^9, 
   3.682938001748227*^9, 3.682938289043845*^9, 3.682938481249756*^9, 
   3.6829395785196466`*^9, 3.68294001014357*^9, 3.682940598707843*^9, 
   3.687099682558193*^9, 3.687101016191736*^9, 3.6871014383793354`*^9, 
   3.6871015671977034`*^9, 3.6871021685460987`*^9, 3.6871023847774663`*^9, 
   3.687102431141118*^9, 3.687103803523614*^9, 3.6871041869315434`*^9, 
   3.6871043727271705`*^9, 3.6871045241108294`*^9, 3.687104611906851*^9, 
   3.687151964391549*^9, 3.6871520540137067`*^9, 3.687152182776333*^9, 
   3.6871522902293215`*^9, 3.68958141271968*^9, 3.6895814934342213`*^9, 
   3.6895815685015535`*^9, 3.689581785763135*^9, 3.6895818390996284`*^9, 
   3.6895921667759237`*^9, 3.7288880592919774`*^9, 3.7288881111776686`*^9, {
   3.728890192166855*^9, 3.728890211718973*^9}, 3.728890721623138*^9, 
   3.728895512681262*^9, 3.7288955818517838`*^9, 3.7288973461579075`*^9, 
   3.728899729836871*^9, 3.7494423757163563`*^9, 3.7558388015418825`*^9, 
   3.7559243210596657`*^9, 3.7559243746867332`*^9, 3.75592440714459*^9, 
   3.7559244698261747`*^9, 3.7559245156087933`*^9, 3.755929165499752*^9, 
   3.7559305052153797`*^9, 3.755933748198868*^9, 3.7559338527868495`*^9, 
   3.7559377345248723`*^9, 3.7559379106759477`*^9, 3.7559383416415977`*^9, 
   3.7559388186138787`*^9, {3.7559388543979254`*^9, 3.755938884002619*^9}, 
   3.755939047461968*^9, 3.7559390791017776`*^9, 3.755939256930949*^9, 
   3.755939605058861*^9, 3.7559396370126886`*^9, 3.755940017811469*^9, 
   3.756008880764471*^9, 3.7560969043614817`*^9, 3.756097556543784*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"unresolvable", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
    RowBox[{"unresolvable", "[", 
     RowBox[{"[", 
      RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "}"}], "/.", 
  RowBox[{"A", "\[Rule]", 
   RowBox[{"Int", "[", "A", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.682830959477819*^9, 3.682830960749062*^9}, {
  3.6895814572265577`*^9, 3.689581459706962*^9}, {3.7559523964926367`*^9, 
  3.7559524007608805`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{"Int", "[", "A", "]"}], ",", 
      RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}], "-", 
    RowBox[{"Prod", "[", 
     RowBox[{"Int", ",", "A", ",", 
      RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       RowBox[{"Int", "[", "A", "]"}]}], "]"}]}], "+", 
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{"Int", "[", "A", "]"}], ",", "Int"}], "]"}], "-", 
    RowBox[{"Prod", "[", 
     RowBox[{"Int", ",", "A", ",", "Int"}], "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.682830970617724*^9, 3.6828348684063177`*^9, 3.682922141039134*^9, 
   3.6829222703245068`*^9, 3.682926953672887*^9, 3.682937724364849*^9, 
   3.6829378284930563`*^9, 3.682938001800398*^9, 3.6829382890955677`*^9, 
   3.682938481279253*^9, 3.682939578548051*^9, 3.682940010195826*^9, 
   3.682940598740573*^9, 3.687099682558193*^9, 3.687101016207336*^9, 
   3.687101438387336*^9, 3.6871015672057037`*^9, 3.6871021685520988`*^9, 
   3.6871023847844667`*^9, 3.6871024311471186`*^9, 3.6871038035316143`*^9, 
   3.687104186940544*^9, 3.687104372734171*^9, 3.6871045241198297`*^9, 
   3.687104611915851*^9, 3.6871519644071493`*^9, 3.687152054029307*^9, 
   3.687152182776333*^9, 3.6871522902449217`*^9, 3.6895814127352796`*^9, 
   3.6895814934498215`*^9, 3.6895815685015535`*^9, 3.6895817857787347`*^9, 
   3.6895818390996284`*^9, 3.689592166785924*^9, 3.7288880593543777`*^9, 
   3.728888111193269*^9, {3.728890192228858*^9, 3.7288902117739763`*^9}, 
   3.728890721629138*^9, 3.728895512681262*^9, 3.728895581867384*^9, 
   3.7288973461579075`*^9, 3.728899729852471*^9, 3.749442375794361*^9, 
   3.755838801561884*^9, 3.755924321079667*^9, 3.7559243747057343`*^9, 
   3.755924407163591*^9, 3.7559244699091797`*^9, 3.7559245156857977`*^9, 
   3.755929165515753*^9, 3.7559305052313805`*^9, 3.7559337482128687`*^9, 
   3.75593385279785*^9, 3.7559377345408735`*^9, 3.7559379106919484`*^9, 
   3.7559383416575985`*^9, 3.7559388186308794`*^9, {3.7559388544149265`*^9, 
   3.7559388840176196`*^9}, 3.755939047478969*^9, 3.7559390791167784`*^9, 
   3.75593925694795*^9, 3.755939605092863*^9, 3.755939637027689*^9, 
   3.7559400178264694`*^9, 3.756008880780472*^9, 3.756096904371482*^9, 
   3.756097556556785*^9}]
}, Open  ]],

Cell[TextData[{
 "The rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRD"], TraditionalForm]]],
 " gives rise to a non-resolvable overlap ambiguity with ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "DI"], TraditionalForm]]],
 " among others.  By replacing ",
 Cell[BoxData[
  FormBox["A", TraditionalForm]]],
 " with ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Integral]", "A"}], TraditionalForm]]],
 " in the corresponding S-polynomial, we obtain the reduction rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRI"], TraditionalForm]]],
 ". After reducing the corresponding S-polynomial, we obtain the rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRI"], TraditionalForm]]],
 ". In addition, the corresponding S-polynomial to the overlap ambiguity of \
",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRD"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "D\[CapitalPhi]"], TraditionalForm]]],
 " induce the new rule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IR\[CapitalPhi]"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7558637346789765`*^9, 3.755863781541657*^9}, {
  3.7558644537941074`*^9, 3.7558645219450054`*^9}, {3.755864557792056*^9, 
  3.755864703081366*^9}, {3.7558647423366113`*^9, 3.7558647632158055`*^9}, {
  3.7559518400478096`*^9, 3.755951842310939*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRI"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "f", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IR\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", "\[CurlyPhi]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.68283100052915*^9, 3.682831006714603*^9}, {
   3.6828317988789053`*^9, 3.682831806846572*^9}, {3.682831954592883*^9, 
   3.682831979855525*^9}, {3.682834875028564*^9, 3.6828348958210583`*^9}, 
   3.6871024087158356`*^9, {3.6895814640281696`*^9, 3.689581467194975*^9}, {
   3.6895815185502653`*^9, 3.689581550233921*^9}, {3.75586467604982*^9, 
   3.755864694919899*^9}, {3.755938705367401*^9, 3.755938707518524*^9}, {
   3.755939013440022*^9, 3.755939033286157*^9}}],

Cell["\<\
We add these rules to the reduction system and check the confluence criterion.\
\>", "Text",
 CellChangeTimes->{{3.7559479098080125`*^9, 3.755947934302414*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"RedSys", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<I\>\"", ",", "R", ",", "\"\<I\>\""}], "}"}], ",", 
         SubscriptBox["h", "IRI"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<I\>\"", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
         SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.682832000329411*^9, 3.6828320121853657`*^9}, 
   3.682834878671586*^9, {3.682834930553689*^9, 3.682834936844318*^9}, {
   3.6895814709857817`*^9, 3.6895814792381964`*^9}, {3.755864684832322*^9, 
   3.7558646910486774`*^9}, {3.755924491050389*^9, 3.755924496600706*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "corresponding identities in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"R", ":"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.756096668080967*^9, 3.756096696557596*^9}, 
   3.75609769440967*^9, 3.7561214399918537`*^9}],

Cell[BoxData[{
 RowBox[{"Int", "/:", 
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Int", "[", 
     RowBox[{"g_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{
        RowBox[{"Int", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], ",", "b"}], 
    "]"}], "+", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{"f", ",", 
        RowBox[{"Int", "[", "g", "]"}]}], "]"}], "]"}], ",", "b"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Int", "/:", 
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ",", " ", 
     RowBox[{
      RowBox[{"\[CurlyPhi]_", "?", 
       SubscriptBox["MemberQ", "\[CapitalPhi]"]}], "[", 
      RowBox[{"g_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", 
    RowBox[{"\[CurlyPhi]", "[", "g", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.7559384400392256`*^9, {3.755938477972395*^9, 3.755938554838792*^9}, {
   3.755938597239217*^9, 3.7559386150472355`*^9}, {3.755938680150959*^9, 
   3.7559387978776927`*^9}, {3.7559388369479275`*^9, 3.75593886899076*^9}, {
   3.7559389655602837`*^9, 3.7559389680484257`*^9}, {3.755939019735382*^9, 
   3.7559390302309823`*^9}, 3.755939065781016*^9, {3.755939340293717*^9, 
   3.7559393463190613`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Step 3", "Subsection",
 CellChangeTimes->{{3.689581684862158*^9, 3.6895816898385663`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"unresolvable", "=", 
  RowBox[{"CheckResolvability", "[", "RedSys", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"SpecialInclusion", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "K", ",", "\<\"I\"\>"}], "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Prod", "[", 
        RowBox[{"Int", ",", "Int"}], "]"}]}], "-", 
      RowBox[{"Prod", "[", 
       RowBox[{"Int", ",", 
        RowBox[{"Int", "[", "1", "]"}]}], "]"}], "+", 
      RowBox[{"Prod", "[", 
       RowBox[{
        RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"SpecialInclusion", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\<\"I\"\>", ",", "K", ",", "\[CapitalPhi]"}], "}"}], ",", 
       RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
       RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Prod", "[", 
        RowBox[{"Int", ",", 
         RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}]}], "+", 
      RowBox[{"Prod", "[", 
       RowBox[{
        RowBox[{"Int", "[", "1", "]"}], ",", 
        RowBox[{"\[CapitalPhi]", "[", "1", "]"}]}], "]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.682832021477373*^9, 3.682834954833934*^9, 3.682922299745451*^9, 
   3.682922403744151*^9, 3.682922453430685*^9, 3.682926953818128*^9, 
   3.682937724470127*^9, 3.682937828625599*^9, 3.682938001986409*^9, 
   3.682938289240926*^9, 3.6829384813834743`*^9, 3.68293957870382*^9, 
   3.682940010343432*^9, 3.682940598883157*^9, 3.6870996826517935`*^9, 
   3.687101016316536*^9, 3.687101438509343*^9, 3.6871015672757077`*^9, 
   3.687102168620103*^9, 3.6871023848554707`*^9, 3.6871024312091217`*^9, 
   3.6871038035966177`*^9, 3.687104187010548*^9, 3.687104372804175*^9, 
   3.6871045241918335`*^9, 3.6871046119868555`*^9, 3.6871519645007496`*^9, 
   3.6871520541073065`*^9, 3.687152182869933*^9, 3.687152290338522*^9, 
   3.6895814128444796`*^9, 3.6895814935278215`*^9, 3.689581568595153*^9, 
   3.6895817858567348`*^9, 3.6895818391932287`*^9, 3.689592166865924*^9, 
   3.728888059369978*^9, 3.7288881112556686`*^9, {3.728890192242859*^9, 
   3.728890211789977*^9}, 3.7288907216901417`*^9, 3.7288955127904625`*^9, 
   3.728895581960984*^9, 3.728897346220308*^9, 3.728899729914871*^9, 
   3.749442375974371*^9, 3.755838801785897*^9, 3.755924321187673*^9, 
   3.755924374823741*^9, 3.755924407269597*^9, 3.7559244699581823`*^9, 
   3.7559245158708086`*^9, 3.75592916563776*^9, 3.7559305053553877`*^9, 
   3.7559337483218746`*^9, 3.7559338528978558`*^9, 3.75593773466788*^9, 
   3.755937910809955*^9, 3.7559383417806053`*^9, {3.75593883681692*^9, 
   3.7559388545379333`*^9}, 3.755938901906643*^9, 3.755939047600976*^9, 
   3.7559390792457857`*^9, 3.7559392570739574`*^9, 3.755939605235871*^9, 
   3.755939637158697*^9, 3.7559400179454765`*^9, 3.7560088809324803`*^9, 
   3.756096904530491*^9, 3.7560975566867924`*^9}]
}, Open  ]],

Cell[TextData[{
 "We consider the inclusion ambiguities (with specialization) of the new \
rules ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "IRI"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", 
    RowBox[{"IR\[CapitalPhi]", " "}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "with ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "K"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". After reducing the corresponding S-polynomials we get the rules ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "II"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["r", "I\[CapitalPhi]"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.7558648348029003`*^9, 3.7558651445126143`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "II"], "[", 
   RowBox[{"Int", ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "I\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", "\[CurlyPhi]_"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "1", "]"}], ",", "\[CurlyPhi]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.68283100052915*^9, 3.682831006714603*^9}, {
   3.6828317988789053`*^9, 3.682831806846572*^9}, {3.682831954592883*^9, 
   3.682831979855525*^9}, {3.682834875028564*^9, 3.6828348958210583`*^9}, {
   3.682834973990712*^9, 3.682834988174202*^9}, 3.6871023705686536`*^9, {
   3.755864927450199*^9, 3.7558649448321934`*^9}}],

Cell["\<\
By adjoining these new rules, all ambiguities will be reduced to zero, hence, \
we obtain a confluent reduction system.\
\>", "Text",
 CellChangeTimes->{{3.7558651604515257`*^9, 3.755865282112485*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"RedSys", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<I\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
         SubscriptBox["h", "II"]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\"\<I\>\"", ",", "\[CapitalPhi]"}], "}"}], ",", 
         SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.682832000329411*^9, 3.6828320121853657`*^9}, 
   3.682834878671586*^9, {3.682834930553689*^9, 3.682834936844318*^9}, {
   3.682835007034112*^9, 3.682835013424835*^9}, {3.755864935991688*^9, 
   3.7558649417440166`*^9}, {3.7559244420215845`*^9, 3.7559244552013383`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckResolvability", "[", "RedSys", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.755938854693942*^9, 3.7559389211597443`*^9, 
  3.755939047763985*^9, 3.755939079402795*^9, 3.755939257219966*^9, 
  3.7559396053928795`*^9, 3.755939637305705*^9, 3.755940018091485*^9, 
  3.756008881144492*^9, 3.7560969047485037`*^9, 3.7560975568238*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1904, 982},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>2. Inherited,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info-4659baee-630c-42ef-b017-3e23d057bcf4"->{
  Cell[2180, 56, 290, 5, 84, "Print",
   CellTags->"Info-4659baee-630c-42ef-b017-3e23d057bcf4"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info-4659baee-630c-42ef-b017-3e23d057bcf4", 63938, 1666}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 405, 8, 60, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1010, 34, 1167, 20, 112, "Print"],
Cell[2180, 56, 290, 5, 84, "Print",
 CellTags->"Info-4659baee-630c-42ef-b017-3e23d057bcf4"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2519, 67, 231, 4, 127, "Section",
 InitializationCell->True],
Cell[2753, 73, 763, 22, 100, "Text"],
Cell[3519, 97, 908, 20, 66, "Input"],
Cell[4430, 119, 698, 17, 60, "Input"],
Cell[CellGroupData[{
Cell[5153, 140, 105, 1, 85, "Subsection"],
Cell[5261, 143, 3023, 85, 213, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8321, 233, 160, 2, 85, "Subsection"],
Cell[8484, 237, 102, 1, 60, "Text"],
Cell[8589, 240, 436, 10, 60, "Input"],
Cell[9028, 252, 205, 2, 60, "Text"],
Cell[9236, 256, 2224, 60, 365, "Input"],
Cell[11463, 318, 104, 1, 60, "Text"],
Cell[11570, 321, 570, 13, 99, "Input"],
Cell[12143, 336, 182, 2, 60, "Text"],
Cell[12328, 340, 509, 14, 137, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12874, 359, 155, 2, 85, "Subsection"],
Cell[CellGroupData[{
Cell[13054, 365, 105, 1, 67, "Subsubsection"],
Cell[13162, 368, 2448, 63, 365, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15647, 436, 134, 2, 67, "Subsubsection"],
Cell[15784, 440, 3126, 72, 289, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18947, 517, 134, 2, 67, "Subsubsection"],
Cell[19084, 521, 2289, 63, 251, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21410, 589, 137, 2, 67, "Subsubsection"],
Cell[21550, 593, 1735, 43, 213, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23322, 641, 134, 2, 67, "Subsubsection"],
Cell[23459, 645, 1372, 32, 175, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24892, 684, 489, 11, 127, "Section"],
Cell[25384, 697, 2281, 61, 327, "Input"],
Cell[27668, 760, 1612, 47, 99, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29317, 812, 147, 2, 127, "Section"],
Cell[29467, 816, 4369, 70, 370, "Text"],
Cell[CellGroupData[{
Cell[33861, 890, 94, 1, 85, "Subsection"],
Cell[CellGroupData[{
Cell[33980, 895, 375, 7, 60, "Input"],
Cell[CellGroupData[{
Cell[34380, 906, 961, 16, 43, "Print"],
Cell[35344, 924, 1018, 18, 43, "Print"],
Cell[36365, 944, 973, 16, 43, "Print"]
}, Open  ]],
Cell[37353, 963, 2282, 50, 97, "Output"]
}, Open  ]],
Cell[39650, 1016, 1269, 35, 136, "Text"],
Cell[40922, 1053, 1299, 28, 99, "Input"],
Cell[42224, 1083, 307, 6, 60, "Text"],
Cell[42534, 1091, 667, 19, 60, "Input"],
Cell[CellGroupData[{
Cell[43226, 1114, 249, 7, 67, "Subsubsection"],
Cell[43478, 1123, 1265, 33, 99, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[44792, 1162, 120, 2, 85, "Subsection"],
Cell[CellGroupData[{
Cell[44937, 1168, 110, 2, 60, "Input"],
Cell[45050, 1172, 3301, 70, 97, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[48388, 1247, 515, 14, 60, "Input"],
Cell[48906, 1263, 2392, 45, 59, "Output"]
}, Open  ]],
Cell[51313, 1311, 1358, 42, 144, "Text"],
Cell[52674, 1355, 1280, 31, 99, "Input"],
Cell[53957, 1388, 170, 3, 60, "Text"],
Cell[54130, 1393, 848, 21, 60, "Input"],
Cell[CellGroupData[{
Cell[55003, 1418, 252, 7, 67, "Subsubsection"],
Cell[55258, 1427, 1693, 46, 137, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57000, 1479, 96, 1, 85, "Subsection"],
Cell[CellGroupData[{
Cell[57121, 1484, 110, 2, 60, "Input"],
Cell[57234, 1488, 3029, 63, 97, "Output"]
}, Open  ]],
Cell[60278, 1554, 868, 30, 100, "Text"],
Cell[61149, 1586, 929, 23, 99, "Input"],
Cell[62081, 1611, 211, 4, 60, "Text"],
Cell[62295, 1617, 826, 21, 60, "Input"],
Cell[CellGroupData[{
Cell[63146, 1642, 76, 1, 60, "Input"],
Cell[63225, 1645, 320, 5, 59, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
