(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[    129771,       3394]
NotebookOptionsPosition[    122843,       3180]
NotebookOutlinePosition[    123478,       3204]
CellTagsIndexPosition[    123372,       3199]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\Jamal\\\\Desktop\\\\main\\\\MyThesis\\\\Examples//\
TenReS.m\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694167372350441*^9, 3.694167385792696*^9}, {
   3.6993427658432713`*^9, 3.6993428272217827`*^9}, {3.7262326477393084`*^9, 
   3.726232661647654*^9}, {3.7467793339755573`*^9, 3.7467793935119624`*^9}, 
   3.749442490010894*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package TenReS version 0.2.4\\nwritten by Clemens G. \
Raab\\nCopyright 2016, RICAM, Austrian Academy of Sciences\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwdzl1I02EYBfC5tY3mDAXTmGAbyVZQfhVoK63BonRSUUHhR+ZqQctw5Zib
kcUuasWyRcxkGYYUeVG0FtrHpGBO2louKBWU5UVYDv+hxixlJvWe5+Lhx4ED
51Homw4Z+DweL58dVIsfK4wznObY6e/kTIXACw2uMjL4oll7luko8JJB+3gL
jJ/KtELl5p5ByisxMnm+8GojM/rLSPbUT3VDY0HeA/gmUJ1yjjky7CZd6TfL
4eifMHlx8c4Z+F7yiRT2zUmbmLOOojRYWqTaBLXfDOTA2r7XUHopQX7OsIfg
EDdAOqsiw9A/IYpCD18vMTGXO++TGRUpCmj0lZOjet4O+MS5k8waeniynXnj
2TSp3BfZcgvmpufD2qRuD0xNXCN7J0MNbqbdJ9JDeUdd2E39TlL32z8G2/hJ
cqFSoOvA/hoN2bCNOwBlq1QH4XGZ+QiM93tJy/5dNdBT2EpWfg2Z4d/5gAU6
elc74LoLWnL3QokLvp1qJi3uFQ+80qW+B8XKD1l3me/kwmxo4m5vgD/Go2Rq
f40/jWN/z3aRHwOt83CpxU/mKWOLMCbPXoLm7va4C73LE6RtY/DLiTlOk5sj
HoEidcDaxjy6fb0NPi2Wxp8vc5rGQSOZefhn8UtmYrpqK7QJq0vg2HUfKQ9H
aqEpoaqDgrK9DljqfERKXP9kr5iT1voc+B+l0qJE
  "]],

Cell[BoxData[
 StyleBox["\<\"A few definitions need to be made by the user. Type ?CoeffQ, \
?Specialization, and ?CyclicModules for more information.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.7558519950955105`*^9},
 CellTags->"Info-d97f53e1-020f-4eee-9e63-656f5e690c51"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic definitions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6400787807134733`*^9, 3.640078788888632*^9}, {
  3.659170131248847*^9, 3.659170137303594*^9}, {3.682830115630125*^9, 
  3.6828301266446743`*^9}}],

Cell[TextData[{
 "We want to compute in the tensor ring over ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodules. However, bimodules are not implemented, so the implementation \
uses the tensor algebra product over ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-modules. Consequently, the cyclic ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["M", "K"], TraditionalForm]]],
 " is not a cyclic ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-module."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Specialization", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"K", ",", 
        OverscriptBox["R", "~"]}], "}"}]}], ",", 
     RowBox[{"\[CapitalPhi]", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", 
        OverscriptBox["\[CapitalPhi]", "~"]}], "}"}]}], ",", 
     RowBox[{"G", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"N", ",", 
        OverscriptBox["G", "~"]}], "}"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6398890163113747`*^9, 3.639889054043709*^9}, {
   3.639889737312602*^9, 3.639889744112504*^9}, {3.6398940881500607`*^9, 
   3.639894098174966*^9}, {3.659086827358851*^9, 3.659086831494749*^9}, {
   3.659088973275432*^9, 3.659088977842003*^9}, {3.6590976281633368`*^9, 
   3.659097642819615*^9}, {3.670244973878394*^9, 3.670245032387117*^9}, {
   3.670247219591683*^9, 3.670247222415421*^9}, 3.6871531306206007`*^9, {
   3.689592234536019*^9, 3.6895922372660227`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicModules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", "Eval"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "Diff"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", "Int"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"N", ",", 
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "0"}], "]"}]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.659096534797022*^9, 3.6590965352753773`*^9}, {
   3.659096673633688*^9, 3.659096675368188*^9}, {3.670245062107257*^9, 
   3.6702451117240057`*^9}, {3.670245295686005*^9, 3.67024532450555*^9}, {
   3.670247225231395*^9, 3.6702472253272943`*^9}, 3.687153154519842*^9}],

Cell[CellGroupData[{

Cell["Bimodule structure", "Subsection",
 CellChangeTimes->{{3.683001088920826*^9, 3.68300109299426*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b", ":", 
     RowBox[{"Diff", "|", "Int", "|", "Eval", "|", 
      RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "|", 
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}], ",", 
        RowBox[{"_", "?", 
         SubscriptBox["MemberQ", "Z"]}]}], "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", "b", ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"mul", "[", 
     RowBox[{"b", ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"b", ",", "c"}], "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.682838778862541*^9, 3.682838843044186*^9}, 
   3.68283887404455*^9, {3.682838905347752*^9, 3.682838945747851*^9}, {
   3.6828389863455553`*^9, 3.682839001603705*^9}, {3.682839064639946*^9, 
   3.682839067127886*^9}, {3.6829202148020077`*^9, 3.682920246908084*^9}, {
   3.6829202861393833`*^9, 3.682920383404994*^9}, {3.6829204540780697`*^9, 
   3.6829204543463497`*^9}, {3.682920550373654*^9, 3.682920568978134*^9}, {
   3.687153170837471*^9, 3.6871531990579205`*^9}, 3.6871532388223906`*^9, {
   3.6871532710520473`*^9, 3.687153299007296*^9}, {3.6871537992221746`*^9, 
   3.6871538033249817`*^9}, 3.6895922436960316`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", "f__"}], "]"}], ",", "b___"}], 
   "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{"mul", "[", "f", "]"}], ",", "b"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6829267998681707`*^9, 3.68292683807716*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "*", "c_Plus"}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "*", "#"}], "&"}], ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6871575790948143`*^9, 3.687157637360916*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Membership checks", "Subsection",
 CellChangeTimes->{{3.6591723429752007`*^9, 3.6591723786702147`*^9}, {
  3.670250652868689*^9, 3.6702506619234743`*^9}}],

Cell["Check for constants:", "Text",
 CellChangeTimes->{{3.659163098154707*^9, 3.659163115075246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "K"], "[", "f_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Diff", "[", "f", "]"}], "===", "0"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.638682699993037*^9, 3.638682727301762*^9}, 
   3.67024541657796*^9, {3.68715821445373*^9, 3.6871582755278373`*^9}, {
   3.6871584196564903`*^9, 3.6871584226048956`*^9}, {3.6895922571560507`*^9, 
   3.6895922587360525`*^9}}],

Cell[TextData[{
 "We denote  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"K", "\[Intersection]", 
    RowBox[{"Z", 
     RowBox[{"(", "R", ")"}], " "}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "( intersection of constants ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " with the center of ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]],
  FormatType->"TraditionalForm"],
 ") by ",
 Cell[BoxData[
  FormBox["Z", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " ."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}, {3.689593404990744*^9, 3.689593572110978*^9}, {
  3.689593694373726*^9, 3.689593705262348*^9}, {3.689593735991106*^9, 
  3.689593739998335*^9}, {3.6895939396953936`*^9, 3.6895939510054097`*^9}, {
  3.6895939847354565`*^9, 3.6895940841055956`*^9}, {3.6896046549968677`*^9, 
  3.6896046575160117`*^9}, {3.690104488854461*^9, 3.690104489477497*^9}, {
  3.756035789318923*^9, 3.7560358018746414`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_Integer", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "f_Times", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"And", "@@", 
    RowBox[{"Map", "[", 
     RowBox[{
      SubscriptBox["MemberQ", "Z"], ",", 
      RowBox[{"List", "@@", "f"}]}], "]"}]}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", 
   RowBox[{"Power", "[", 
    RowBox[{
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", "_Integer"}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "_", "]"}], ":=", "False"}]}], "Input",
 CellChangeTimes->{{3.6871538216862144`*^9, 3.6871538556786737`*^9}, {
  3.6871539025411563`*^9, 3.6871539328676095`*^9}, {3.68715458797616*^9, 
  3.687154597492177*^9}, {3.6871546640262938`*^9, 3.6871547075035706`*^9}, {
  3.687154777220093*^9, 3.6871547861433086`*^9}, {3.6871555406854334`*^9, 
  3.6871555997939377`*^9}, {3.6871563694686894`*^9, 3.687156379515107*^9}, {
  3.687156456938043*^9, 3.687156473084071*^9}, {3.6871577340186863`*^9, 
  3.6871577500867147`*^9}, {3.687157862094911*^9, 3.687157864388115*^9}, {
  3.6871579003773785`*^9, 3.6871579124049997`*^9}, {3.687157944572256*^9, 
  3.6871579629802885`*^9}, {3.6895922636660595`*^9, 3.689592264856061*^9}}],

Cell["Check for membership in the function algebra:", "Text",
 CellChangeTimes->{{3.6591631194512157`*^9, 3.6591631291876383`*^9}, 
   3.659163217493614*^9, {3.6591724206231956`*^9, 3.659172422789729*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"F", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f_mul", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "[", "k_Integer", "]"}], ":=", 
  RowBox[{"F", "[", "k", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{{3.669455790328519*^9, 3.6694557970644712`*^9}, {
   3.669543619267727*^9, 3.669543632574329*^9}, {3.670245501045932*^9, 
   3.670245606567086*^9}, 3.670246245762525*^9, 3.682830172179517*^9, {
   3.6828355629428263`*^9, 3.682835600736021*^9}, {3.6871533509085875`*^9, 
   3.687153351704189*^9}, {3.689592274976075*^9, 3.689592324676145*^9}, {
   3.6895923885585527`*^9, 3.689592428534314*^9}, {3.698728886447846*^9, 
   3.698728918015327*^9}, {3.698730164873973*^9, 3.698730171312064*^9}, {
   3.698730495221025*^9, 3.6987304978995113`*^9}, {3.69873057212881*^9, 
   3.698730576040122*^9}}],

Cell["Check for functionals:", "Text",
 CellChangeTimes->{{3.670245973081357*^9, 3.670245977713456*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", "Eval", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", 
   RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.6702459832458897`*^9, 3.670246019832996*^9}, {
   3.687103716685647*^9, 3.687103749558527*^9}, {3.6871039884201894`*^9, 
   3.6871039890202236`*^9}, 3.687153387038251*^9}],

Cell["Check for substitutions:", "Text",
 CellChangeTimes->{{3.6871534023886776`*^9, 3.6871534127626963`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{"a", "=!=", "0"}], ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "G"], "[", 
   RowBox[{"G", "[", "_Integer", "]"}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{3.6871533833098445`*^9, 3.6871537713293257`*^9}],

Cell["Check for membership in the other cyclic modules:", "Text",
 CellChangeTimes->{{3.6702458564563427`*^9, 3.670245866975058*^9}, {
  3.670245946760453*^9, 3.670245947584765*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "D"], "[", "Diff", "]"}], ":=", "True"}]], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<I\>\""], "[", "Int", "]"}], ":=", 
  "True"}]], "Input",
 CellChangeTimes->{{3.67024588567362*^9, 3.670245887433428*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<E\>\""], "[", "Eval", "]"}], ":=", 
  "True"}]], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.670245875177434*^9, 3.6702458778879423`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "N"], "[", 
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "]"}], ":=", "True"}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function algebra", "Subsection",
 CellChangeTimes->{{3.638691610025188*^9, 3.638691614921186*^9}, {
  3.659165795915909*^9, 3.6591657979705772`*^9}}],

Cell[CellGroupData[{

Cell["Multiplication", "Subsubsection",
 CellChangeTimes->{{3.659165569776952*^9, 3.659165577588789*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Plus", ",", "c___"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"a", ",", "#", ",", "c"}], "]"}], "&"}], "/@", "b"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Integer", ",", "c__"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a__", ",", "b_Integer", ",", "c___"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"d_Integer", "*", "b_"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"d", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", "b__", "]"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", "a_", "]"}], ":=", "a"}]}], "Input",
 CellChangeTimes->{{3.638684986800296*^9, 3.638685023740603*^9}, {
   3.638685085399458*^9, 3.6386851016267347`*^9}, {3.6386852559617443`*^9, 
   3.638685292086501*^9}, {3.638685328564872*^9, 3.63868533076567*^9}, {
   3.638685453632114*^9, 3.638685456591627*^9}, {3.638685773732319*^9, 
   3.63868577618708*^9}, 3.6386858741418343`*^9, {3.63869290635741*^9, 
   3.6386929232045727`*^9}, {3.6387824422362843`*^9, 3.638782493065415*^9}, {
   3.6388722777325487`*^9, 3.6388722903501*^9}, {3.639212523253624*^9, 
   3.639212586876335*^9}, 3.639980360207717*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"b", "*", "c"}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox["MemberQ", "R"], "[", "#", "]"}], "&&", 
        RowBox[{"!", 
         RowBox[{
          SubscriptBox["MemberQ", "Z"], "[", "#", "]"}]}]}], "&"}], ")"}]}], 
    ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "Z"]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871539990117254`*^9, 3.6871541058719134`*^9}, {
   3.6871543308721085`*^9, 3.6871543619005632`*^9}, {3.6871556988385115`*^9, 
   3.6871557160453415`*^9}, 3.6895924539643497`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.698668531871706*^9, 3.698668592170611*^9}, {
  3.6986686728449717`*^9, 3.698668703420024*^9}, {3.698728970054511*^9, 
  3.698729007722953*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", "]"}], ":=", "1"}]], "Input",
 CellChangeTimes->{{3.7225944477289867`*^9, 3.722594452620298*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiation", "Subsubsection",
 CellChangeTimes->{{3.659163141267557*^9, 3.6591631488521423`*^9}, 
   3.659165586346394*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", "NumericQ"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[CurlyPhi]_", "?", 
      SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ")"}], "[", "f_", "]"}], 
   "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "Z"]}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "a_mul", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"MapAt", "[", 
     RowBox[{"Diff", ",", "a", ",", "i"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.638682746051725*^9, 3.638682788960909*^9}, {
   3.638682825870358*^9, 3.638682962118843*^9}, {3.6386831317951612`*^9, 
   3.638683190849043*^9}, {3.638683239496002*^9, 3.638683300736999*^9}, {
   3.638683391426631*^9, 3.6386834461159897`*^9}, {3.638782252717188*^9, 
   3.638782253282292*^9}, {3.638782504556032*^9, 3.6387825049058027`*^9}, {
   3.639212762878365*^9, 3.639212788512412*^9}, {3.640058908518703*^9, 
   3.640058989848414*^9}, {3.6400590763931026`*^9, 3.640059144710424*^9}, {
   3.659159838349127*^9, 3.659159839787879*^9}, {3.659701295933262*^9, 
   3.6597012991698523`*^9}, {3.659701749337516*^9, 3.6597017541360083`*^9}, {
   3.659701785652364*^9, 3.6597017880263767`*^9}, {3.659701846596245*^9, 
   3.6597018492038803`*^9}, {3.670246185189465*^9, 3.670246215676208*^9}, {
   3.670246254518935*^9, 3.670246256356043*^9}, {3.670246334717093*^9, 
   3.670246369529475*^9}, 3.670246738163018*^9, {3.670249771073493*^9, 
   3.6702497719200172`*^9}, {3.68283571585677*^9, 3.682835730684732*^9}, {
   3.6829379750055523`*^9, 3.682937975485763*^9}, {3.6829429368147717`*^9, 
   3.68294293771128*^9}, {3.6871559666597815`*^9, 3.687155983913412*^9}, {
   3.6871561575257173`*^9, 3.6871561891167727`*^9}, {3.6871583790964193`*^9, 
   3.687158413042079*^9}, 3.6895924605543594`*^9, {3.7262066801423664`*^9, 
   3.726206691530386*^9}, {3.7262067287676516`*^9, 3.726206739937271*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Diff", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "f"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.694171339899015*^9, 3.694171342654649*^9}, {
  3.721472665683461*^9, 3.7214726773366814`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"inv", "[", "f", "]"}], ",", 
     RowBox[{"Diff", "[", "f", "]"}], ",", 
     RowBox[{"inv", "[", "f", "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.698729235424279*^9, 3.6987292708991003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Diff", "[", "f", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7262067435408773`*^9, 3.7262067491412873`*^9}, {
  3.7262072860630302`*^9, 3.726207288527835*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Integration", "Subsubsection",
 CellChangeTimes->{{3.6591631541798153`*^9, 3.6591631569643307`*^9}, 
   3.6591655902493143`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"f_", "?", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["MemberQ", "K"], "[", "#", "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#", "=!=", "1"}], ")"}]}], "&"}], ")"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"f", ",", " ", 
    RowBox[{"Int", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f__", ",", 
     RowBox[{"c_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", 
     RowBox[{"mul", "[", "f", "]"}], "]"}], ",", "c"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"f", "-", 
   RowBox[{"Eval", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.659162411432198*^9, 3.659162412408951*^9}, {
   3.659164197207127*^9, 3.659164197790752*^9}, {3.659171490362842*^9, 
   3.659171491487652*^9}, {3.6597013045303164`*^9, 3.6597013070497923`*^9}, {
   3.65970147718134*^9, 3.659701479851516*^9}, {3.670246390359516*^9, 
   3.670246410313141*^9}, {3.682835743292811*^9, 3.682835756499106*^9}, {
   3.682922363505677*^9, 3.6829223924145117`*^9}, {3.682926287313134*^9, 
   3.682926320109994*^9}, 3.6895924739343777`*^9, {3.723020749052878*^9, 
   3.723020756203888*^9}}],

Cell[BoxData[
 RowBox[{"Int", "/:", 
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "f_", "]"}], ",", 
    RowBox[{"Int", "[", "g_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{
        RowBox[{"Int", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], ",", "b"}], 
    "]"}], "+", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{"f", ",", 
        RowBox[{"Int", "[", "g", "]"}]}], "]"}], "]"}], ",", "b"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.682835794664198*^9, 3.682835797615197*^9}, {
  3.682922443748539*^9, 3.682922445931324*^9}, {3.687100945172411*^9, 
  3.687100954758828*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "K"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", "b"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.682926324285439*^9, 3.682926353345174*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "f"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6941713298583403`*^9, 3.694171332583683*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Int", "[", "f", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7262068320554333`*^9, 3.7262068373438425`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Induced evaluation", "Subsubsection",
 CellChangeTimes->{{3.6591631661642323`*^9, 3.659163171220705*^9}, 
   3.659165594273448*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.65916263319906*^9, 3.6591626335436068`*^9}, {
   3.670246424800674*^9, 3.670246429623632*^9}, {3.6828358313150043`*^9, 
   3.6828358410828857`*^9}, {3.6829210945837917`*^9, 3.682921099615996*^9}, {
   3.682922258911646*^9, 3.682922261329509*^9}, {3.6871018941824055`*^9, 
   3.687101922244011*^9}, 3.6871021395064373`*^9, 3.689592465414366*^9, {
   3.7468691954155674`*^9, 3.746869196190612*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Eval", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.694171257902845*^9, 3.6941712731057587`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.726207541108878*^9, {3.746870286398968*^9, 3.74687030374296*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functionals", "Subsubsection",
 CellChangeTimes->{{3.6591641415283527`*^9, 3.6591641443831253`*^9}, 
   3.6591656005776367`*^9}],

Cell[BoxData[{
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "1", "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871017707413454`*^9, 3.6871017750975943`*^9}, {
   3.6871018476607447`*^9, 3.687101848025766*^9}, 3.687102142485608*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[CapitalPhi]", "/:", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_Plus", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.6941713964085484`*^9, 3.694171397764351*^9}, {
   3.746869711151066*^9, 3.746869731935255*^9}, {3.7468697947688484`*^9, 
   3.746869829015807*^9}, 3.7468698668439713`*^9, {3.7468699011419325`*^9, 
   3.746869911163506*^9}, 3.7468699672627144`*^9, 3.7468700202947483`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Substitutions", "Subsubsection",
 CellChangeTimes->{{3.687153558950553*^9, 3.687153562351359*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"G", "[", "i_Integer", "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"A", "[", "i", "]"}], ",", 
    RowBox[{"B", "[", "i", "]"}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"jac", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "]"}], ":=", "a"}], "\n", 
 RowBox[{
  RowBox[{"comp", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}], ",", 
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "Z"]}], ",", 
      RowBox[{"d_", "?", 
       SubscriptBox["MemberQ", "Z"]}]}], "]"}]}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"a", " ", "c"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"c", " ", "b"}], "+", "d"}], "//", "Expand"}], "//", 
     "Together"}]}], "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{"1", ",", "0"}], "]"}], "[", "f_", "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"t_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"comp", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], ",", "t"}], "]"}], "[", "f", 
   "]"}]}], "\n", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"c_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "c"}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"A", "|", "B"}], ")"}], "[", "_Integer", "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"s_", "?", 
      SubscriptBox["MemberQ", "G"]}], ")"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"jac", "[", "s", "]"}], ",", 
    RowBox[{"s", "[", 
     RowBox[{"Diff", "[", "f", "]"}], "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871536562323236`*^9, 3.6871536667623425`*^9}, {
   3.687153696854795*^9, 3.687153755760498*^9}, 3.6895924908244014`*^9}],

Cell[BoxData[
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"inv", "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"inv", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.698735493975955*^9, 3.698735527371812*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      RowBox[{"a_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}]}], "]"}], "[", "f_", "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    FractionBox["1", "a"], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{"a", ",", "b"}], "]"}], "[", 
      RowBox[{"Int", "[", "f", "]"}], "]"}], "-", 
     RowBox[{"Eval", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"a", ",", "b"}], "]"}], "[", 
       RowBox[{"Int", "[", "f", "]"}], "]"}], "]"}]}]}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"inv", "[", 
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "K"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"S", "[", 
   RowBox[{
    RowBox[{"1", "/", "a"}], ",", 
    RowBox[{
     RowBox[{"-", "b"}], "/", "a"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"Int", "[", "1", "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}], "+", 
   RowBox[{"Eval", "[", 
    RowBox[{
     RowBox[{"S", "[", 
      RowBox[{"a", ",", "b"}], "]"}], "[", 
     RowBox[{"Hold", "[", 
      RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"A", "[", "1", "]"}]], ",", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"B", "[", "1", "]"}], 
        RowBox[{"A", "[", "1", "]"}]]}]}], "]"}], "[", 
    RowBox[{"Hold", "[", 
     RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", 
      RowBox[{"A", "[", "1", "]"}]]}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{
      RowBox[{"S", "[", 
       RowBox[{
        RowBox[{"A", "[", "1", "]"}], ",", 
        RowBox[{"B", "[", "1", "]"}]}], "]"}], "[", 
      RowBox[{"Hold", "[", 
       RowBox[{"Int", "[", "1", "]"}], "]"}], "]"}], "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871607153495226`*^9, 3.6871607162543244`*^9}, 
   3.69873548187245*^9}],

Cell[BoxData[
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "f"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.694171377255641*^9, 3.694171378851736*^9}, 
   3.726207564087719*^9}],

Cell[BoxData[
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], "[", "f", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7262069636416645`*^9, 3.7262069657788677`*^9}, 
   3.726207566505723*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Matrix computations in the coefficient ring", "Subsection",
 CellChangeTimes->{{3.726207142324378*^9, 3.726207209466896*^9}, {
  3.726207556022505*^9, 3.726207559766511*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a___", ",", 
     RowBox[{"m1_", "?", "MatrixQ"}], ",", 
     RowBox[{"m2_", "?", "MatrixQ"}], ",", "b___"}], "]"}], "/;", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"m1", "[", 
      RowBox[{"[", "1", "]"}], "]"}], "]"}], "\[Equal]", 
    RowBox[{"Length", "[", "m2", "]"}]}]}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Inner", "[", 
     RowBox[{"mul", ",", "m1", ",", "m2"}], "]"}], ",", "b"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.722595602026443*^9, 3.7225956326258907`*^9}, {
  3.7225956932327414`*^9, 3.722595723506545*^9}, {3.72259582464373*^9, 
  3.7225958350193644`*^9}, {3.722595879486856*^9, 3.722595910485755*^9}, {
  3.7225966032515306`*^9, 3.72259661861121*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"S", "/:", 
  RowBox[{
   RowBox[{"S", "[", 
    RowBox[{
     RowBox[{"a_", "?", 
      SubscriptBox["MemberQ", "Z"]}], ",", 
     RowBox[{"b_", "?", 
      SubscriptBox["MemberQ", "Z"]}]}], "]"}], "[", 
   RowBox[{"m_", "?", "MatrixQ"}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"S", "[", 
     RowBox[{"a", ",", "b"}], "]"}], ",", "m", ",", 
    RowBox[{"{", "2", "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.7225959990524282`*^9, 3.722596034261569*^9}, {
  3.722596065881753*^9, 3.722596084166253*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reduction system for IDOLS", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.6895928521349087`*^9, 3.6895929344350233`*^9}, {3.6896046787532263`*^9, 
  3.689604682363433*^9}, {3.6941678932953777`*^9, 3.694167902694168*^9}, {
  3.7262066047006335`*^9, 3.726206607025038*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "K"], "[", "k_", "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"k", " ", 
    RowBox[{"Prod", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "RR"], "[", 
   RowBox[{
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"g_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]R"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CurlyPhi]", "[", "f", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"\[Psi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[Psi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "EI"], "[", 
   RowBox[{"Eval", ",", "Int"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DR"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"Diff", "[", "f", "]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{"f", ",", "Diff"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "D\[CapitalPhi]"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DI"], "[", 
   RowBox[{"Diff", ",", "Int"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "I\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "1", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "ID"], "[", 
   RowBox[{"Int", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "]"}], "-", 
   RowBox[{"Prod", "[", "Eval", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "II"], "[", 
   RowBox[{"Int", ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IR\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRD"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "f", "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Eval", "[", "f", "]"}], " ", 
      RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Diff", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRI"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "f", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "f", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830444156025*^9, 3.682830470225523*^9}, {
   3.682834198147834*^9, 3.682834214536252*^9}, {3.682851644402529*^9, 
   3.682851645428053*^9}, {3.6871003756050105`*^9, 3.68710039816265*^9}, {
   3.687151940149107*^9, 3.687151949961524*^9}, 3.6871521643059006`*^9, {
   3.687152270432887*^9, 3.687152272648091*^9}, {3.689592507214424*^9, 
   3.6895925166644373`*^9}, {3.6895925538644896`*^9, 3.689592565024505*^9}, {
   3.689592655624632*^9, 3.689592667544649*^9}, {3.6895927037147007`*^9, 
   3.6895928463249*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["h", "N"], "[", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "0"}], "]"}], "]"}], "=", 
   RowBox[{"Prod", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GR"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"s", "[", "f", "]"}], ",", "s"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "G\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[CurlyPhi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "GG"], "[", 
   RowBox[{
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}], ",", 
    RowBox[{"t_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"comp", "[", 
    RowBox[{"s", ",", "t"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DG"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"jac", "[", "s", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "s", ",", "Diff"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRG"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"s_", "?", 
     SubscriptBox["MemberQ", "G"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"jac", "[", "s", "]"}]], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"Prod", "[", "]"}], "-", "Eval"}], ",", "s", ",", "Int", ",", 
    RowBox[{
     RowBox[{"inv", "[", "s", "]"}], "[", "f", "]"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871549385087757`*^9, 3.6871549814868517`*^9}, {
  3.6895925316744585`*^9, 3.689592537664467*^9}, {3.689592953985051*^9, 
  3.6895929845850935`*^9}, {3.689593053670707*^9, 3.6895930626162186`*^9}, {
  3.6895931005383177`*^9, 3.6895931219283476`*^9}, {3.689593334838646*^9, 
  3.6895933369086485`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "K", "}"}], ",", 
       SubscriptBox["h", "K"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "RR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<E\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "EI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "DR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "DI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "ID"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "II"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "IRD"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "IRI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "N", "}"}], ",", 
       SubscriptBox["h", "N"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "GR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "G\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"G", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "GG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "DG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IG"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "G"}], "}"}], ",", 
       SubscriptBox["h", "IRG"]}], "}"}]}], "}"}]}], ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Auxiliary functions", "Section",
 InitializationCell->True,
 CellChangeTimes->{3.721113232148026*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{"f__", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", "f", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", "m___", "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"c_", "?", 
         SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
       RowBox[{"Prod", "[", "]"}]}], ",", 
      RowBox[{"f___", "?", 
       SubscriptBox["MemberQ", "R"]}], ",", "m___"}], "]"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"c", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"t_Prod", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{"a_Plus", ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["LeftCoeff", "R"], "[", 
      RowBox[{"#", ",", 
       RowBox[{"Prod", "[", "m", "]"}]}], "]"}], "&"}], ",", "a"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["LeftCoeff", "R"], "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], ",", 
    RowBox[{"Prod", "[", "m___", "]"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{
    SubscriptBox["LeftCoeff", "R"], "[", 
    RowBox[{"t", ",", 
     RowBox[{"Prod", "[", "m", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.699351620935052*^9, 3.699351696511311*^9}, {
  3.699351908345364*^9, 3.699351927169579*^9}, {3.699352268410995*^9, 
  3.699352290178299*^9}, {3.699352447548417*^9, 3.6993524573555326`*^9}, {
  3.6993526692301083`*^9, 3.699352709251622*^9}, {3.699354814919639*^9, 
  3.699354865959058*^9}, {3.699354915253944*^9, 3.699354973183589*^9}, {
  3.699355521691896*^9, 3.699355530261294*^9}, {3.6993556750764303`*^9, 
  3.699355721031934*^9}, {3.714809595722381*^9, 3.714809629225843*^9}, {
  3.714811743154192*^9, 3.714811745482112*^9}, {3.720959585700904*^9, 
  3.720959599730564*^9}, {3.722669438862779*^9, 3.7226694443383884`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"c_", "?", 
        SubscriptBox["MemberQ", "K"]}], ")"}], "*", 
      RowBox[{"Prod", "[", "]"}]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"f__", "?", 
      SubscriptBox["MemberQ", "R"]}], ",", "a___"}], "]"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a", "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{"Prod", "[", "a___", "]"}], "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{"Prod", "[", "a", "]"}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "a_Plus", "]"}], ":=", 
  RowBox[{"Union", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["Support", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "a"}], ")"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], "t_Prod"}], "]"}], ":=", 
  RowBox[{
   SubscriptBox["Support", "R"], "[", "t", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["Support", "R"], "[", "0", "]"}], ":=", 
  RowBox[{"{", "}"}]}]}], "Input",
 CellChangeTimes->{{3.6993554712616453`*^9, 3.699355478105356*^9}, {
   3.6993560904101*^9, 3.699356094134852*^9}, {3.6993561385524406`*^9, 
   3.699356314720628*^9}, {3.699356348766143*^9, 3.699356403307789*^9}, {
   3.699356610362338*^9, 3.699356656845377*^9}, {3.7148096428305798`*^9, 
   3.7148096609734297`*^9}, {3.7148877588489027`*^9, 3.714887760693915*^9}, {
   3.714888758065007*^9, 3.714888762910594*^9}, {3.720959601482885*^9, 
   3.7209596329851303`*^9}, 3.722669432451168*^9, {3.7262105839831095`*^9, 
   3.726210594107527*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Coefficients", "[", "expr_", "]"}], ":=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["LeftCoeff", "R"], "[", 
       RowBox[{"expr", ",", "m"}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"m", ",", 
      RowBox[{
       SubscriptBox["Support", "R"], "[", "expr", "]"}]}], "}"}]}], 
   "]"}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Examples for the ring of IDOLS:", "Section",
 CellChangeTimes->{{3.7262064656731896`*^9, 3.726206477810011*^9}, {
   3.7262065169660797`*^9, 3.7262065260140953`*^9}, {3.726208087222038*^9, 
   3.726208094897251*^9}, 3.726213154613912*^9, {3.755839511479489*^9, 
   3.7558395591752167`*^9}, {3.755844783168012*^9, 3.7558447921275244`*^9}}],

Cell[TextData[{
 "First we need to declare the coefficients ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["A", "0"], ",", 
    SubscriptBox["A", "1"], ",", 
    SubscriptBox["H", "1"], ",", 
    SubscriptBox["H", "2"], ",", "\[CapitalPhi]", ",", " ", "\[CapitalTheta]",
     " "}], TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 " which we use in the following examples to denote elements of the \
coefficient ring ",
 Cell[BoxData[
  FormBox["R", TraditionalForm]]],
 ". We also declare the parameter ",
 Cell[BoxData[
  FormBox["h", TraditionalForm]]],
 " and the notation ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Delta]", "=", 
    SubscriptBox["\[Sigma]", 
     RowBox[{"1", ",", "h"}]]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7262084976275587`*^9, 3.7262087354977765`*^9}, {
   3.726208812139111*^9, 3.7262088621215987`*^9}, {3.726208964754179*^9, 
   3.7262089854554157`*^9}, {3.72620903940031*^9, 3.7262090630655518`*^9}, {
   3.726209457905532*^9, 3.726209489183586*^9}, {3.726209824676776*^9, 
   3.726209944436986*^9}, {3.7262100416095567`*^9, 3.726210166055375*^9}, {
   3.726210205305044*^9, 3.7262102119038553`*^9}, {3.7262102668471518`*^9, 
   3.726210302165614*^9}, {3.7558523568212004`*^9, 3.755852361656477*^9}, 
   3.756035820704718*^9, {3.7561033373834295`*^9, 3.756103338878515*^9}, {
   3.7561078961991787`*^9, 3.7561079890104876`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{
    SubscriptBox["A", "0"], "|", 
    SubscriptBox["A", "1"], "|", 
    SubscriptBox["H", "1"], "|", 
    SubscriptBox["H", "2"], "|", "\[CapitalPhi]\[CapitalPhi]", "|", 
    "\[CapitalTheta]", "|", "\[CapitalTheta]\[CapitalTheta]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "Z"], "[", "h", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{"\[Delta]", ":=", 
  RowBox[{"S", "[", 
   RowBox[{"1", ",", "h"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.725277857882575*^9, 3.725277864840187*^9}, 
   3.726209072019967*^9, {3.7262094965624*^9, 3.7262094976544013`*^9}, {
   3.7262097905247154`*^9, 3.7262098068303447`*^9}, {3.72620985559483*^9, 
   3.7262098579972343`*^9}, {3.7262103255500555`*^9, 3.726210341430883*^9}}],

Cell[CellGroupData[{

Cell["\<\
(Example 4.21): Differential time-delay systems (method of steps)\
\>", "Subsection",
 CellChangeTimes->{{3.7229249255965047`*^9, 3.722924961060533*^9}, {
   3.723892834583496*^9, 3.7238928637399473`*^9}, 3.725257923396613*^9, {
   3.7252632089695635`*^9, 3.7252632204511833`*^9}, {3.725267289031663*^9, 
   3.7252672960828753`*^9}, 3.726212933670724*^9, {3.726230058331479*^9, 
   3.7262300683154964`*^9}, {3.755839100423978*^9, 3.755839102839116*^9}, {
   3.7558393920476575`*^9, 3.755839398335017*^9}}],

Cell["Consider the differential time-delay system ", "Text",
 CellChangeTimes->{{3.7252730136837816`*^9, 3.7252731166751623`*^9}, {
   3.7252731629448442`*^9, 3.7252731753780656`*^9}, {3.7252746992561426`*^9, 
   3.7252747117829647`*^9}, {3.755851432057307*^9, 3.7558514331513696`*^9}, 
   3.7561033906244745`*^9}],

Cell[BoxData[
 FormBox[
  RowBox[{
  "                                                                           \
                        ", 
   RowBox[{Cell[TextData[Cell[BoxData[Cell[TextData[Cell[BoxData[
      FormBox[
       RowBox[{
        RowBox[{
         RowBox[{
          OverscriptBox["x", "."], " ", 
          RowBox[{"(", "t", ")"}]}], " ", "-", " ", 
         RowBox[{
          RowBox[{
           SubscriptBox["A", "0"], "(", "t", ")"}], 
          RowBox[{"x", "(", "t", ")"}]}], "+", 
         RowBox[{
          SubscriptBox["A", "1"], " ", 
          RowBox[{"(", "t", ")"}], 
          RowBox[{"x", "(", 
           RowBox[{"t", "-", "h"}], ")"}]}]}], " ", "=", " ", 
        RowBox[{"f", "(", "t", ")"}]}], TraditionalForm]], "Text",
      CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
        3.7252732177945404`*^9, 3.725273330957139*^9}, {
        3.7252745364386563`*^9, 3.725274715745372*^9}, 3.7252764647091274`*^9,
         3.7252773100600123`*^9}]]]],
     CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
       3.7252732177945404`*^9, 3.725273330957139*^9}, {3.7252745364386563`*^9,
        3.725274715745372*^9}, 3.7252764647091274`*^9, 
       3.7252773100600123`*^9, {3.725277347422078*^9, 
       3.7252773750029263`*^9}, {3.725279951708315*^9, 
       3.7252799594771285`*^9}}]]], "."}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.725272619492689*^9, 3.7252726469955378`*^9}, {
   3.7252732177945404`*^9, 3.725273330957139*^9}, {3.7252745364386563`*^9, 
   3.725274715745372*^9}, 3.7252764647091274`*^9, 3.7252773100600123`*^9, {
   3.725277347422078*^9, 3.7252773750029263`*^9}, {3.725279951708315*^9, 
   3.7252800209352365`*^9}, {3.72621294855315*^9, 3.726212957585566*^9}, {
   3.7262129925452275`*^9, 3.72621299972124*^9}, {3.755846426673015*^9, 
   3.7558464749687777`*^9}, {3.7558465697441983`*^9, 3.755846603249115*^9}, {
   3.755849247527359*^9, 3.7558492746399097`*^9}, {3.7558493450239353`*^9, 
   3.755849414456907*^9}, 3.755849488552145*^9, {3.755849534152753*^9, 
   3.7558495403521075`*^9}, {3.7558496968170567`*^9, 3.755849808273432*^9}, {
   3.7558499974262505`*^9, 3.7558500759197407`*^9}, {3.755851017153576*^9, 
   3.755851088098634*^9}, {3.755851201056094*^9, 3.755851389608879*^9}, {
   3.755851506264551*^9, 3.7558515301279163`*^9}, {3.7558516353459344`*^9, 
   3.7558516819926023`*^9}, {3.755851967207916*^9, 3.755851969752061*^9}, {
   3.7560358368656425`*^9, 3.756035853208577*^9}, {3.756103400354031*^9, 
   3.756103440172309*^9}, {3.756107996964942*^9, 3.7561080047693887`*^9}}],

Cell[TextData[{
 "Our goal is to reproduce the \[OpenCurlyDoubleQuote]method of steps\
\[CloseCurlyDoubleQuote] for the general solution of this system. Let ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{Cell[TextData[{
       Cell[BoxData[
        FormBox["L", TraditionalForm]]],
       ":="
      }]], 
      RowBox[{"\[PartialD]", 
       RowBox[{"-", 
        SubscriptBox["A", "0"]}]}]}], TraditionalForm]]]]], TraditionalForm]]],
 " and let ",
 Cell[BoxData[
  FormBox["\[CapitalPhi]", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " be invertible such that \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[PartialD]", "\[CapitalPhi]"}], " ", "-", " ", 
     "A\[CapitalPhi]"}], "=", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". We have already seen in ",
 StyleBox["Example 4.9",
  FontWeight->"Bold"],
 " that the operator ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"H", "=", 
     RowBox[{"\[CapitalPhi]", "\[CenterDot]", 
      FormBox[
       RowBox[{"\[Integral]", 
        RowBox[{"\[CenterDot]", " ", 
         SuperscriptBox["\[CapitalPhi]", 
          RowBox[{"-", "1"}]]}]}],
       TraditionalForm]}]}], "Text"], TraditionalForm]]],
 " is a right inverse of ",
 Cell[BoxData[
  FormBox["L", TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.75610358093836*^9, 3.7561037622107277`*^9}}],

Cell[BoxData[{
 RowBox[{"L", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "Diff", "]"}], "-", 
   RowBox[{"Prod", "[", 
    SubscriptBox["A", "0"], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    SubscriptBox["A", "0"], ",", "\[CapitalPhi]\[CapitalPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"HH", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", "Int", ",", 
    RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.755848952359476*^9, 3.7558489564957128`*^9}, 
   3.7558492317514563`*^9, 3.7558501549932632`*^9, {3.755850802672308*^9, 
   3.7558508042003956`*^9}, {3.7558511677191877`*^9, 3.755851175535635*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
  "Note", " ", "that", " ", "the", "  ", "system", "  ", "above", " ", 
   "corresponds", " ", "to", " ", "the", " ", "operator", " ", Cell[TextData[
   Cell[BoxData[
    FormBox[
     RowBox[{"R", "=", 
      RowBox[{"L", "+", "S"}]}], TraditionalForm]]]]], "  ", "with", "   ", 
   RowBox[{Cell[TextData[Cell[BoxData[
     FormBox[
      RowBox[{Cell[TextData[Cell[BoxData[
        FormBox[
         StyleBox["S", "Text"], TraditionalForm]]]]], ":=", 
       RowBox[{
        RowBox[{"-", 
         SubscriptBox["A", "1"]}], "\[CenterDot]", "\[Delta]"}]}], 
      TraditionalForm]]]]], ".", "   "}]}], TraditionalForm]], "Text",
 CellChangeTimes->{{3.755851383274517*^9, 3.7558514226157665`*^9}, 
   3.7558514555836525`*^9, {3.755851714544464*^9, 3.755851721799879*^9}, 
   3.756103217823591*^9}],

Cell[BoxData[
 RowBox[{"SS", ":=", 
  RowBox[{"-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", "\[Delta]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.725260850156021*^9, 3.7252608712472577`*^9}, 
   3.7252610169359136`*^9, 3.725261047964368*^9, {3.725261080474825*^9, 
   3.7252610994600587`*^9}, {3.726213019470875*^9, 3.726213023573682*^9}}],

Cell[BoxData[
 RowBox[{"OR", ":=", 
  RowBox[{"L", "+", "SS"}]}]], "Input",
 CellChangeTimes->{{3.725260896956103*^9, 3.725261050085972*^9}, {
   3.7252610835324306`*^9, 3.725261131081314*^9}, {3.7252613728037386`*^9, 
   3.725261391336571*^9}, 3.725276533864049*^9, {3.725276624469008*^9, 
   3.72527662567021*^9}}],

Cell[TextData[{
 "We compute ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{"H", "\[CenterDot]", "R"}], TraditionalForm]]]]], 
   TraditionalForm]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.7252733828428297`*^9, 3.7252734115468807`*^9}, {
   3.725273446568942*^9, 3.725273474617791*^9}, {3.7252735050066447`*^9, 
   3.7252735653007507`*^9}, {3.725273640149682*^9, 3.7252736803509526`*^9}, {
   3.7252742990676394`*^9, 3.7252742996760406`*^9}, {3.7252743313128963`*^9, 
   3.7252743946802073`*^9}, {3.7252744989039907`*^9, 3.725274500760394*^9}, 
   3.7252773004815955`*^9, {3.725280026395246*^9, 3.7252800273624477`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"HH", ",", "OR"}], "]"}], ",", "RedSys", ",", 
   RowBox[{"Print", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.725259110686346*^9, 3.7252591388911953`*^9}, {
   3.725259171713653*^9, 3.725259197219698*^9}, 3.725259307309091*^9, {
   3.7252596513036957`*^9, 3.725259657122506*^9}, 3.7252599908226924`*^9, 
   3.7252600912594876`*^9, 3.725260288429234*^9, {3.725260342639329*^9, 
   3.725260351078944*^9}, {3.7252604771905656`*^9, 3.7252604956609983`*^9}, 
   3.725260558232708*^9, {3.7252606603348875`*^9, 3.725260688165336*^9}, {
   3.725260755635455*^9, 3.7252607727174845`*^9}, 3.72526081552396*^9, {
   3.725260857768834*^9, 3.7252608783920703`*^9}, {3.7252609092645245`*^9, 
   3.7252609140381327`*^9}, {3.725260974176238*^9, 3.7252609941130733`*^9}, {
   3.7252611115032797`*^9, 3.725261136213723*^9}, {3.7252613789345493`*^9, 
   3.725261394768577*^9}, 3.725265130522538*^9, 3.7252765417420626`*^9, {
   3.725276630085018*^9, 3.7252766309742193`*^9}, {3.725339821513886*^9, 
   3.7253398224654875`*^9}, {3.726296061045779*^9, 3.7262960628348923`*^9}, {
   3.747383084557598*^9, 3.7473830962772684`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.7558519962285757`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.755851996232576*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.7558519962395763`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.7558519962445765`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "G"}], "}"}], ",", 
   SubscriptBox["h", "IRG"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.755851996248577*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.7473831118251576`*^9, 3.749381793024106*^9, 
  3.7494425063248267`*^9, 3.7558393004074163`*^9, 3.7558501395143776`*^9, 
  3.7558501744953785`*^9, 3.755850474449535*^9, 3.755850822373435*^9, 
  3.755851996269578*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], "]"}]}], 
     "]"}], ",", "Eval"}], "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]\[CapitalPhi]", 
        "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "h"}]}], "]"}], "[", 
       SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", "Eval", ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"inv", "[", 
       RowBox[{
        RowBox[{"S", "[", 
         RowBox[{"1", ",", 
          RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]\[CapitalPhi]", 
        "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", 
         RowBox[{"-", "h"}]}], "]"}], "[", 
       SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252606890857377`*^9, {3.7252607281950064`*^9, 3.725260783512704*^9}, {
   3.7252608178795643`*^9, 3.7252608806696744`*^9}, {3.7252609247865515`*^9, 
   3.725260942476983*^9}, {3.725260985455058*^9, 3.725260994971075*^9}, {
   3.725261033534343*^9, 3.7252611371965246`*^9}, {3.72526138500296*^9, 
   3.725261426452233*^9}, 3.7252614660295024`*^9, 3.7252625083255324`*^9, 
   3.7252631054321814`*^9, 3.7252635565693736`*^9, 3.7252648750720897`*^9, 
   3.7252649290169845`*^9, {3.7252651002896852`*^9, 3.7252651512081747`*^9}, 
   3.725266051621402*^9, 3.7252664431206894`*^9, 3.725275024033113*^9, {
   3.7252765176556206`*^9, 3.7252765429120646`*^9}, 3.7252771496449304`*^9, 
   3.725280312764949*^9, 3.7253396743558273`*^9, 3.72533982352629*^9, 
   3.7253398551007447`*^9, 3.726206349390585*^9, 3.7262063951610656`*^9, 
   3.7262077699924803`*^9, 3.726208115676488*^9, 3.7262081997606354`*^9, 
   3.7262103665313272`*^9, 3.726210531613817*^9, 3.7262106128431597`*^9, 
   3.7262108379671555`*^9, 3.7262127601808195`*^9, 3.7262128195409236`*^9, 
   3.7262128724406166`*^9, 3.726213088890997*^9, 3.726213259492896*^9, 
   3.726213350035455*^9, 3.7262133954783354`*^9, 3.7262301367216167`*^9, 
   3.726296148108201*^9, 3.7467791499670324`*^9, 3.7467793526186233`*^9, 
   3.746779408005791*^9, 3.746780546769925*^9, 3.746781734354851*^9, 
   3.746782145498367*^9, 3.746782751742042*^9, 3.746784308199066*^9, 
   3.746784514271853*^9, 3.746785293439419*^9, 3.7467857831494284`*^9, 
   3.7467861272311087`*^9, 3.7467894827720346`*^9, 3.746789708032919*^9, 
   3.746790864494065*^9, 3.7467909827478285`*^9, 3.7467910249692435`*^9, 
   3.7467915097999744`*^9, 3.74679169085933*^9, 3.746791898806224*^9, 
   3.7468536641102276`*^9, 3.7468552814157324`*^9, 3.746855469010462*^9, 
   3.7468679850783405`*^9, 3.746868813631731*^9, 3.746868920777859*^9, 
   3.7468698509800634`*^9, 3.746869890163305*^9, 3.746869926414378*^9, 
   3.7468699808444915`*^9, {3.746870184661149*^9, 3.746870198872962*^9}, 
   3.7468703389939766`*^9, 3.7468704044727216`*^9, 3.7468704905806465`*^9, 
   3.7468714810893*^9, 3.74687158335715*^9, 3.7471144617991395`*^9, 
   3.747114886724444*^9, 3.747114945439802*^9, 3.7473831118571596`*^9, 
   3.749381793057108*^9, 3.7494425063628287`*^9, 3.755839300455419*^9, 
   3.7558501395563803`*^9, 3.7558501745453815`*^9, 3.7558504745125384`*^9, 
   3.755850822413437*^9, 3.7558519962785783`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "Coefficients"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.722925187781501*^9, 3.7229252237895603`*^9}, {
   3.7229253310726967`*^9, 3.722925333485834*^9}, {3.7229254079500933`*^9, 
   3.7229254113412876`*^9}, 3.7229255318941827`*^9, 3.72292564303854*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], "1"},
    {
     RowBox[{"Prod", "[", "Eval", "]"}], 
     RowBox[{"-", 
      RowBox[{"mul", "[", 
       RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
        RowBox[{"Eval", "[", 
         RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], "]"}]}], 
       "]"}]}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
       RowBox[{"mul", "[", 
        RowBox[{
         RowBox[{"inv", "[", 
          RowBox[{
           RowBox[{"S", "[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]\[CapitalPhi]", 
           "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"S", "[", 
           RowBox[{"1", ",", 
            RowBox[{"-", "h"}]}], "]"}], "[", 
          SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}], 
     RowBox[{"-", "\[CapitalPhi]\[CapitalPhi]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Eval", ",", 
       RowBox[{"S", "[", 
        RowBox[{"1", ",", "h"}], "]"}], ",", "Int", ",", 
       RowBox[{"mul", "[", 
        RowBox[{
         RowBox[{"inv", "[", 
          RowBox[{
           RowBox[{"S", "[", 
            RowBox[{"1", ",", 
             RowBox[{"-", "h"}]}], "]"}], "[", "\[CapitalPhi]\[CapitalPhi]", 
           "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"S", "[", 
           RowBox[{"1", ",", 
            RowBox[{"-", "h"}]}], "]"}], "[", 
          SubscriptBox["A", "1"], "]"}]}], "]"}]}], "]"}], 
     "\[CapitalPhi]\[CapitalPhi]"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7229252268177333`*^9, 3.72292534250535*^9, 3.7229253792574525`*^9, {
   3.722925546929043*^9, 3.722925568855297*^9}, 3.722925644239609*^9, 
   3.7229262646670523`*^9, 3.722926681749385*^9, 3.7230149566391*^9, 
   3.723015240497198*^9, 3.7230155897662115`*^9, 3.7230158073625937`*^9, 
   3.7230159563996553`*^9, 3.7230160631506424`*^9, 3.7230161143187323`*^9, 
   3.7230191519979286`*^9, 3.723020276051216*^9, 3.723020768243905*^9, 
   3.7230245292847137`*^9, 3.723028508223179*^9, 3.723028539685979*^9, 
   3.7230288185109262`*^9, 3.7230289203897533`*^9, 3.723030147649949*^9, 
   3.7230335160448847`*^9, {3.7230335502401447`*^9, 3.7230335762297897`*^9}, 
   3.72303410022871*^9, 3.723034182550055*^9, 3.7230342197249203`*^9, 
   3.7230343354303236`*^9, 3.7230343757251945`*^9, {3.723893296612508*^9, 
   3.7238933515870037`*^9}, 3.7240822352308435`*^9, 3.724082270206105*^9, {
   3.724082438592801*^9, 3.724082493879298*^9}, 3.7243964798756733`*^9, 
   3.724396536185752*^9, {3.724399514645934*^9, 3.7243995406959705`*^9}, {
   3.7243996714971533`*^9, 3.724399692707183*^9}, {3.724399752677267*^9, 
   3.724399776787301*^9}, 3.724399874677438*^9, 3.72439991183749*^9, 
   3.725258513394853*^9, 3.7252586951829724`*^9, 3.725258962474386*^9, 
   3.7252590682542715`*^9, 3.725259246640585*^9, 3.725259529919883*^9, 
   3.7252596889465623`*^9, 3.725259853854452*^9, 3.72525992098137*^9, 
   3.7252600188569417`*^9, {3.7252601071871157`*^9, 3.7252601365629673`*^9}, 
   3.725260261519187*^9, 3.725260517891037*^9, 3.7252606466380634`*^9, 
   3.7252607835439034`*^9, 3.7252608353047943`*^9, {3.7252609248021517`*^9, 
   3.7252609425081825`*^9}, 3.7252609854862585`*^9, 3.725261033659143*^9, {
   3.725261074905616*^9, 3.7252611245293026`*^9}, {3.725261426514633*^9, 
   3.7252614660607023`*^9}, 3.7252625083567324`*^9, 3.725263105447781*^9, 
   3.7252635565849733`*^9, 3.7252648751032896`*^9, 3.725264929032584*^9, 
   3.7252651003052855`*^9, 3.725265151223775*^9, 3.7252660516526017`*^9, 
   3.7252664431362896`*^9, 3.7252750240487127`*^9, 3.7252765176556206`*^9, 
   3.7252771496605306`*^9, 3.725280312780549*^9, 3.7253396743558273`*^9, 
   3.7253398551163445`*^9, 3.726206349406185*^9, 3.7262063951610656`*^9, 
   3.7262077700080805`*^9, 3.726208115676488*^9, 3.7262081997606354`*^9, 
   3.7262103665313272`*^9, 3.7262105316294174`*^9, 3.7262106128431597`*^9, 
   3.726210837982755*^9, 3.7262127601964192`*^9, 3.7262128195409236`*^9, 
   3.7262128724406166`*^9, 3.726213088906597*^9, 3.7262132595084963`*^9, 
   3.7262133500510554`*^9, 3.726213395493935*^9, 3.726230136799617*^9, 
   3.7262961481306667`*^9, 3.7467791500700383`*^9, 3.7467793526956277`*^9, 
   3.7467794080357933`*^9, 3.746780546802927*^9, 3.746781734390853*^9, 
   3.7467821455363693`*^9, 3.7467827517800446`*^9, 3.7467843082380686`*^9, 
   3.7467845143148556`*^9, 3.7467852935534253`*^9, 3.7467857831824303`*^9, 
   3.7467861273431153`*^9, 3.746789482824038*^9, 3.746789708065921*^9, 
   3.746790864526067*^9, 3.7467909827788305`*^9, 3.7467910250902505`*^9, 
   3.7467915098359766`*^9, 3.7467916908963327`*^9, 3.746791898849227*^9, 
   3.7468536641452293`*^9, 3.7468552814547343`*^9, 3.746855469112468*^9, 
   3.746867985109342*^9, 3.7468688136587324`*^9, 3.7468689208248615`*^9, 
   3.746869851010065*^9, 3.7468698901973066`*^9, 3.7468699264553804`*^9, 
   3.7468699808814936`*^9, {3.7468701846881504`*^9, 3.746870198975968*^9}, 
   3.746870339022978*^9, 3.7468704045017233`*^9, 3.7468704906916533`*^9, 
   3.7468714811263027`*^9, 3.7468715834011526`*^9, 3.747114461837142*^9, 
   3.747114886761446*^9, 3.747114945470804*^9, 3.747383111889161*^9, 
   3.7493817930991106`*^9, 3.749442506419832*^9, 3.7558393004984217`*^9, 
   3.755850139603383*^9, 3.755850174601384*^9, 3.7558504745815425`*^9, 
   3.75585082246244*^9, 3.7558519963295813`*^9}]
}, Open  ]],

Cell[TextData[{
 "We define ",
 Cell[BoxData[
  FormBox[
   RowBox[{"P", "=", 
    RowBox[{
     FormBox[
      RowBox[{"\[CapitalPhi]", " ", 
       SuperscriptBox["E\[CapitalPhi]", 
        RowBox[{"-", "1"}]]}],
      TraditionalForm], "\[CenterDot]", "E"}]}], TraditionalForm]]],
 " which is a projector."
}], "Text",
 CellChangeTimes->{{3.725272905559992*^9, 3.725272948990468*^9}, {
  3.72527299593095*^9, 3.7252730043237653`*^9}, {3.7252731024323378`*^9, 
  3.7252731067535453`*^9}, {3.7252799245330667`*^9, 3.725279942925499*^9}, {
  3.7262300139026012`*^9, 3.7262300202050123`*^9}, {3.7468713105345454`*^9, 
  3.746871350560835*^9}, {3.7558504560154805`*^9, 3.7558504577435794`*^9}, {
  3.755851810239938*^9, 3.755851916215999*^9}, {3.756103783533948*^9, 
  3.756103798770819*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"P", "=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], "]"}]}], 
     "]"}], ",", "Eval"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.723015357013803*^9, 3.723015370741827*^9}, {
   3.7230157885177603`*^9, 3.723015790124563*^9}, 3.7230159795500956`*^9, 
   3.7243995994460526`*^9, 3.725263082609341*^9}],

Cell[BoxData[
 RowBox[{"Prod", "[", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
     RowBox[{"Eval", "[", 
      RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], "]"}]}], "]"}],
    ",", "Eval"}], "]"}]], "Output",
 CellChangeTimes->{
  3.723015386575855*^9, 3.7230155898286123`*^9, 3.7230158074249935`*^9, {
   3.723015956462055*^9, 3.7230159809540977`*^9}, 3.723016063259843*^9, 
   3.723016114381132*^9, 3.72301661935802*^9, 3.7230191520759287`*^9, {
   3.72302025772119*^9, 3.723020276131216*^9}, 3.723020768303905*^9, 
   3.7230245293767185`*^9, 3.723028508283182*^9, 3.7230285398079853`*^9, 
   3.7230288185869308`*^9, 3.7230289204517574`*^9, 3.7230335161228848`*^9, {
   3.723033550271344*^9, 3.7230335762765903`*^9}, 3.7230341002599106`*^9, 
   3.723034182596855*^9, 3.7230342197717204`*^9, 3.7230343354927235`*^9, 
   3.7230344357228994`*^9, {3.723893296799708*^9, 3.7238933516494045`*^9}, 
   3.724082235293244*^9, 3.7240822703465056`*^9, {3.7240824679988527`*^9, 
   3.7240824939884987`*^9}, 3.724396479945673*^9, 3.7243965362457523`*^9, {
   3.724399514685934*^9, 3.7243995407859707`*^9}, 3.7243996010760546`*^9, {
   3.7243996715471535`*^9, 3.7243996928271837`*^9}, {3.724399752717267*^9, 
   3.724399776827301*^9}, 3.724399874727438*^9, 3.72439991191749*^9, 
   3.725258513566454*^9, 3.7252586952609725`*^9, 3.725258962558391*^9, 
   3.7252590683478713`*^9, 3.725259246718585*^9, 3.725259529997883*^9, 
   3.7252596890245624`*^9, 3.725259853979252*^9, 3.72525992105937*^9, 
   3.7252600188881416`*^9, {3.7252601072651157`*^9, 3.725260136625367*^9}, 
   3.725260261550387*^9, 3.725260517937837*^9, 3.725260646669263*^9, 
   3.7252607835751038`*^9, 3.725260835351595*^9, {3.725260924833352*^9, 
   3.725260942539383*^9}, 3.7252609855174584`*^9, 3.7252610337371435`*^9, {
   3.7252610749368153`*^9, 3.725261124560503*^9}, 3.725261426545833*^9, 
   3.7252614660763025`*^9, 3.7252625083567324`*^9, 3.7252631054633813`*^9, 
   3.7252635566005735`*^9, 3.7252648751032896`*^9, 3.725264929032584*^9, 
   3.7252651003052855`*^9, 3.725265151223775*^9, 3.7252660516526017`*^9, 
   3.7252664431362896`*^9, 3.725275023986313*^9, 3.7252765176088204`*^9, 
   3.7252771496137304`*^9, 3.725280312733749*^9, 3.7253396742934275`*^9, 
   3.725339855069545*^9, 3.726206349374985*^9, 3.7262063951298656`*^9, 
   3.7262077699612803`*^9, 3.7262081156452875`*^9, 3.726208199729436*^9, 
   3.726210366500127*^9, 3.7262105315826173`*^9, 3.7262106128119597`*^9, 
   3.7262108379515553`*^9, 3.726212760149619*^9, 3.7262128195097237`*^9, 
   3.726212872409416*^9, 3.7262130888597965`*^9, 3.7262132594460964`*^9, 
   3.726213349988655*^9, 3.726213395447135*^9, 3.7262301366436167`*^9, 
   3.726296147994824*^9, 3.746779149895028*^9, 3.74677935256462*^9, 
   3.7467794078677835`*^9, 3.7467805466209164`*^9, 3.7467817342168427`*^9, 
   3.746782145342358*^9, 3.7467827515990343`*^9, 3.7467843080580583`*^9, 
   3.7467845141418457`*^9, 3.7467852933704147`*^9, 3.7467857830054207`*^9, 
   3.746786127159105*^9, 3.746789482650028*^9, 3.746789707887911*^9, 
   3.746790864427061*^9, 3.746790982608821*^9, 3.7467910249042397`*^9, 
   3.746791509657966*^9, 3.7467916907923265`*^9, 3.74679189873522*^9, 
   3.746853664047224*^9, 3.746855281292725*^9, 3.746855468930457*^9, 
   3.7468679849433327`*^9, 3.746868813498723*^9, 3.7468689206918545`*^9, 
   3.74686985091206*^9, 3.7468698900893006`*^9, 3.746869926352375*^9, 
   3.746869980752486*^9, {3.7468701845931454`*^9, 3.7468701987789564`*^9}, 
   3.7468703388559685`*^9, 3.7468704043317137`*^9, 3.746870490517643*^9, 
   3.7468714810062957`*^9, 3.7468715832061415`*^9, 3.747114461737136*^9, 
   3.7471148866594405`*^9, 3.747114945379799*^9, 3.747383111763154*^9, 
   3.7493817929901037`*^9, 3.7494425062368217`*^9, 3.7558393003574133`*^9, 
   3.7558455766994*^9, 3.755845633740662*^9, 3.755845764011113*^9, 
   3.755846051576561*^9, 3.755846232095886*^9, 3.7558504746015434`*^9, 
   3.7558508224884415`*^9, 3.755851996352583*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"ApplyRules", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Prod", "[", 
      RowBox[{"P", ",", "P"}], "]"}], "-", "P"}], ",", "RedSys"}], "]"}], "//",
   "Expand"}]], "Input",
 CellChangeTimes->{{3.723033429667533*^9, 3.723033472645608*^9}, {
   3.7243996102260675`*^9, 3.7243996114360695`*^9}, {3.7252616096121545`*^9, 
   3.725261663229449*^9}, 3.7252617010127153`*^9, {3.7252764352094755`*^9, 
   3.7252764378614807`*^9}, {3.725339814244273*^9, 3.725339815242675*^9}, {
   3.726296052799885*^9, 3.726296054914707*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7230334735348096`*^9, 3.7230335161852846`*^9}, {
   3.7230335503181443`*^9, 3.72303357630779*^9}, 3.7230341002911105`*^9, 
   3.723034182659255*^9, 3.7230342198185205`*^9, 3.723034335523924*^9, {
   3.7238932969557085`*^9, 3.7238933517118044`*^9}, 3.724082235324444*^9, 
   3.724082270393306*^9, {3.7240824680612526`*^9, 3.7240824940508986`*^9}, 
   3.724396479985673*^9, 3.7243965362857523`*^9, {3.724399514715934*^9, 
   3.7243995408359704`*^9}, 3.7243996156160755`*^9, {3.7243996715571537`*^9, 
   3.7243996928371835`*^9}, {3.7243997527272673`*^9, 3.7243997768373013`*^9}, 
   3.724399874737438*^9, 3.72439991192749*^9, 3.725258513628854*^9, 
   3.7252586952609725`*^9, 3.7252589625743923`*^9, 3.7252590683634715`*^9, 
   3.7252592467341847`*^9, 3.725259530013483*^9, 3.7252596890557623`*^9, 
   3.725259853994852*^9, 3.7252599210749702`*^9, 3.725260018903742*^9, {
   3.725260107296316*^9, 3.7252601366409674`*^9}, 3.7252602615659866`*^9, 
   3.725260517953437*^9, 3.7252606467004633`*^9, 3.725260783590704*^9, 
   3.725260835367195*^9, {3.725260924864552*^9, 3.725260942554983*^9}, 
   3.725260985533058*^9, 3.7252610337527432`*^9, {3.7252610749524155`*^9, 
   3.7252611245761027`*^9}, 3.7252614265614333`*^9, 3.7252614660919027`*^9, {
   3.7252616413582106`*^9, 3.725261653619832*^9}, {3.7252616850070868`*^9, 
   3.725261702229517*^9}, 3.7252625083723326`*^9, 3.7252631054633813`*^9, 
   3.7252635566161737`*^9, 3.72526487511889*^9, 3.7252649290481844`*^9, 
   3.7252651003208857`*^9, 3.725265151254975*^9, 3.7252660516682014`*^9, 
   3.7252664431518893`*^9, 3.725275024001913*^9, 3.72527651762442*^9, 
   3.7252771496137304`*^9, 3.7252803127493486`*^9, 3.7253396742934275`*^9, 
   3.725339816584277*^9, 3.725339855069545*^9, 3.726206349374985*^9, 
   3.726206395145466*^9, 3.72620776997688*^9, 3.7262081156452875`*^9, 
   3.7262081997450356`*^9, 3.726210366500127*^9, 3.726210531598217*^9, 
   3.7262106128119597`*^9, 3.7262108379515553`*^9, 3.7262127601652193`*^9, 
   3.726212819525324*^9, 3.726212872409416*^9, 3.7262130888597965`*^9, 
   3.7262132594616966`*^9, 3.7262133500042553`*^9, 3.726213395447135*^9, 
   3.726230136659217*^9, 3.726296148017026*^9, 3.7467791499200296`*^9, 
   3.746779352583621*^9, 3.7467794078817844`*^9, 3.746780546632917*^9, 
   3.7467817342278433`*^9, 3.7467821453533583`*^9, 3.7467827516110344`*^9, 
   3.746784308069059*^9, 3.746784514181848*^9, 3.7467852933814154`*^9, 
   3.746785783018421*^9, 3.746786127172106*^9, 3.746789482668029*^9, 
   3.7467897079009113`*^9, 3.7467908644380617`*^9, 3.7467909826198215`*^9, 
   3.7467910249142404`*^9, 3.7467915097449713`*^9, 3.746791690804327*^9, 
   3.746791898747221*^9, 3.7468536640572243`*^9, 3.746855281324727*^9, 
   3.7468554689404583`*^9, 3.746867985027337*^9, 3.7468688135797276`*^9, 
   3.746868920702855*^9, 3.7468698509250603`*^9, 3.746869890102301*^9, 
   3.746869926363375*^9, 3.7468699807794876`*^9, {3.746870184609146*^9, 
   3.7468701987909575`*^9}, 3.746870338868969*^9, 3.7468704043457146`*^9, 
   3.7468704905286436`*^9, 3.7468714810212965`*^9, 3.746871583293146*^9, 
   3.747114461747137*^9, 3.7471148866704407`*^9, 3.7471149453897996`*^9, 
   3.7473831117761545`*^9, 3.7493817929991045`*^9, 3.749442506252823*^9, 
   3.755839300371414*^9, 3.7558455767104*^9, 3.755845633753663*^9, 
   3.755845764022114*^9, 3.7558460515885615`*^9, 3.7558462321088867`*^9, 
   3.755850474624545*^9, 3.7558508225434446`*^9, 3.755851996376584*^9}]
}, Open  ]],

Cell[TextData[{
 "We have ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"H", "\[CenterDot]", "R"}], "=", 
    RowBox[{
     RowBox[{
      RowBox[{"H", "\[CenterDot]", "L"}], "+", 
      RowBox[{"H", "\[CenterDot]", "S"}]}], "=", 
     RowBox[{
      RowBox[{"1", "-", "P", "+", 
       RowBox[{"H", "\[CenterDot]", "S"}]}], "=", 
      RowBox[{"1", "-", 
       RowBox[{"(", 
        RowBox[{"P", "-", 
         RowBox[{"H", "\[CenterDot]", "S"}]}], ")"}]}]}]}]}], 
   TraditionalForm]]],
 ".  Now we take ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{"G", "=", 
      RowBox[{"P", "-", 
       RowBox[{"H", "\[CenterDot]", "S"}]}]}], TraditionalForm]]]]], 
   TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{{3.725273613567235*^9, 3.7252736256104565`*^9}, {
  3.725274399032615*^9, 3.725274508623808*^9}, {3.725274746742626*^9, 
  3.72527476619586*^9}, {3.725277286800371*^9, 3.7252772954271865`*^9}, {
  3.725280033368458*^9, 3.7252800337896585`*^9}, {3.7561038083703685`*^9, 
  3.7561038303876276`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"G", "=", 
  RowBox[{"P", "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"HH", ",", "SS"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7252625449855967`*^9, 3.7252625691188393`*^9}, 
   3.725265168368205*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", 
      RowBox[{"Eval", "[", 
       RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], "]"}]}], 
     "]"}], ",", "Eval"}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{"\[CapitalPhi]\[CapitalPhi]", ",", "Int", ",", 
    RowBox[{"inv", "[", "\[CapitalPhi]\[CapitalPhi]", "]"}], ",", 
    SubscriptBox["A", "1"], ",", 
    RowBox[{"S", "[", 
     RowBox[{"1", ",", "h"}], "]"}]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252625700236406`*^9, 3.7252631054789815`*^9, 3.7252635566161737`*^9, 
   3.72526487511889*^9, 3.7252649290481844`*^9, 3.7252651003208857`*^9, {
   3.725265151254975*^9, 3.725265173064813*^9}, 3.7252660516682014`*^9, 
   3.7252664431518893`*^9, 3.7252750240487127`*^9, 3.7252765176712203`*^9, 
   3.7252771496605306`*^9, 3.725280312780549*^9, 3.7253396743714275`*^9, 
   3.7253398551163445`*^9, 3.726206349406185*^9, 3.7262063951766653`*^9, 
   3.7262077700080805`*^9, 3.726208115676488*^9, 3.7262081997762356`*^9, 
   3.7262103665313272`*^9, 3.7262105316294174`*^9, 3.72621061285876*^9, 
   3.726210837982755*^9, 3.7262127601964192`*^9, 3.7262128195565233`*^9, 
   3.7262128724562163`*^9, 3.726213088906597*^9, 3.7262132595240965`*^9, 
   3.7262133500510554`*^9, 3.7262133955095353`*^9, 3.726230136815217*^9, 
   3.7262961481836653`*^9, 3.7467791500880394`*^9, 3.7467793527086287`*^9, 
   3.7467794080497937`*^9, 3.7467805468159275`*^9, 3.746781734404854*^9, 
   3.74678214555037*^9, 3.746782751793045*^9, 3.7467843082520695`*^9, 
   3.7467845143298564`*^9, 3.746785293567426*^9, 3.746785783195431*^9, 
   3.7467861273561163`*^9, 3.7467894828410387`*^9, 3.7467897080799217`*^9, 
   3.7467908645390673`*^9, 3.746790982791831*^9, 3.746791025104251*^9, 
   3.746791509850977*^9, 3.746791690910333*^9, 3.7467918988642273`*^9, 
   3.7468536641582303`*^9, 3.746855281466735*^9, 3.7468554691234684`*^9, 
   3.7468679851213427`*^9, 3.746868813671733*^9, 3.7468689208378625`*^9, 
   3.746869851024066*^9, 3.7468698902093077`*^9, 3.7468699264673815`*^9, 
   3.746869980894494*^9, {3.7468701847051516`*^9, 3.7468701989869685`*^9}, 
   3.746870339037979*^9, 3.746870404514724*^9, 3.7468704907036533`*^9, 
   3.7468714811403036`*^9, 3.746871583414153*^9, 3.7471144618501425`*^9, 
   3.747114886773447*^9, 3.747114945556809*^9, 3.747383111901162*^9, 
   3.7493817931101108`*^9, 3.749442506438833*^9, 3.7558393005144224`*^9, 
   3.7558501396203833`*^9, 3.7558501746163855`*^9, 3.755850474660547*^9, 
   3.755850822569446*^9, 3.7558519964005857`*^9}]
}, Open  ]],

Cell[TextData[{
 "and check the identity",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"H", "\[CenterDot]", "R"}], " ", "=", " ", 
     RowBox[{"1", "-", "G"}]}]}], TraditionalForm]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.7252747705482674`*^9, 3.725274803027525*^9}, {
   3.7252748407171907`*^9, 3.7252748536652136`*^9}, {3.7252772434790955`*^9, 
   3.725277245444699*^9}, 3.7252800381420665`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"HH", ",", "OR"}], "]"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Prod", "[", "]"}], "-", "G"}], ")"}]}], ",", "RedSys"}], 
  "]"}]], "Input",
 CellChangeTimes->{
  3.72526517128541*^9, {3.7252770704269915`*^9, 3.725277123514885*^9}, {
   3.7253398295167*^9, 3.7253398302187014`*^9}, {3.726296069685801*^9, 
   3.726296071767366*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.725262772231196*^9, 3.725263105494581*^9, 3.725263556631774*^9, 
   3.72526487513449*^9, 3.725264929079385*^9, 3.7252651003364854`*^9, {
   3.7252651512705746`*^9, 3.725265174749616*^9}, 3.725266051699402*^9, 
   3.7252664431830893`*^9, 3.725275024064313*^9, 3.7252765176868205`*^9, {
   3.7252771274928913`*^9, 3.7252771496917305`*^9}, 3.725280312796149*^9, 
   3.7253396743870273`*^9, {3.7253398319815044`*^9, 3.725339855147545*^9}, 
   3.7262063494373856`*^9, 3.7262063951922655`*^9, 3.7262077700236807`*^9, 
   3.726208115692088*^9, 3.7262081998074355`*^9, 3.726210366562527*^9, 
   3.726210531645017*^9, 3.72621061287436*^9, 3.726210838013955*^9, 
   3.726212760212019*^9, 3.7262128195721235`*^9, 3.7262128724562163`*^9, 
   3.7262130889377966`*^9, 3.7262132595396967`*^9, 3.726213350066655*^9, 
   3.726213395525135*^9, 3.7262301368464165`*^9, 3.72629614823351*^9, 
   3.7467791501280413`*^9, 3.746779352790633*^9, 3.7467794080807953`*^9, 
   3.746780546845929*^9, 3.746781734433855*^9, 3.7467821455813713`*^9, 
   3.746782751828047*^9, 3.7467843082860713`*^9, 3.746784514372859*^9, 
   3.7467852935974283`*^9, 3.746785783224433*^9, 3.746786127386118*^9, 
   3.7467894828840413`*^9, 3.7467897081119237`*^9, 3.746790864565069*^9, 
   3.7467909828208327`*^9, 3.746791025134253*^9, 3.7467915098829794`*^9, 
   3.7467916909463353`*^9, 3.7467918989022293`*^9, 3.7468536641932325`*^9, 
   3.7468552814947367`*^9, 3.74685546915047*^9, 3.7468679851523447`*^9, 
   3.7468688136977344`*^9, 3.746868920877865*^9, 3.7468698510490675`*^9, 
   3.7468698902393093`*^9, 3.7468699264933825`*^9, 3.7468699809234962`*^9, {
   3.7468701847211523`*^9, 3.74687019901397*^9}, 3.7468703390689807`*^9, 
   3.7468704045437255`*^9, 3.7468704907376556`*^9, 3.7468714811663046`*^9, 
   3.746871583447155*^9, 3.747114461880144*^9, 3.7471148868014483`*^9, 
   3.7471149455848103`*^9, 3.7473831119281635`*^9, 3.749381793140113*^9, 
   3.7494425065848417`*^9, 3.7558393005554247`*^9, 3.7558501396643867`*^9, 
   3.755850174661388*^9, 3.75585047471655*^9, 3.7558508226244493`*^9, 
   3.755851996571595*^9}]
}, Open  ]],

Cell[TextData[{
 "This implies that \:200ewe can rewrite ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"H", "\[CenterDot]", "R"}], ")"}], "x"}], " ", "=", " ", 
    RowBox[{"H", " ", "f"}]}], TraditionalForm]]],
 " as the recurrence equation ",
 Cell[BoxData[
  FormBox[
   RowBox[{"x", " ", "=", " ", 
    RowBox[{
     RowBox[{"G", " ", "x"}], " ", "+", " ", 
     RowBox[{"H", " ", "f"}]}]}], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.725274883414466*^9, 3.72527499950987*^9}, 
   3.7252769527871847`*^9, {3.7252771917962046`*^9, 3.725277235164281*^9}, {
   3.7252800441012774`*^9, 3.725280048640885*^9}, {3.726296079651155*^9, 
   3.726296086972534*^9}, {3.7468713688738823`*^9, 3.7468713732151303`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
(Example 5.6): Variation of constants with rectangular coefficients \
\>", "Subsection",
 CellChangeTimes->{{3.7229249255965047`*^9, 3.722924961060533*^9}, {
   3.723892834583496*^9, 3.7238928637399473`*^9}, 3.725257923396613*^9, {
   3.725263302195327*^9, 3.7252633191369567`*^9}, {3.7252652895034175`*^9, 
   3.7252652910790205`*^9}, {3.725265717154814*^9, 3.725265790084942*^9}, {
   3.7262131349110775`*^9, 3.726213135987479*^9}, {3.755839223967044*^9, 
   3.7558392444952183`*^9}}],

Cell[TextData[{
 "Consider the inhomogeneous differential system \n\n                         \
                               ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["A", "1"], "(", "t", ")"}], 
      OverscriptBox["x", "."], " ", 
      RowBox[{"(", "t", ")"}]}], " ", "-", " ", 
     RowBox[{
      RowBox[{
       SubscriptBox["A", "0"], "(", "t", ")"}], 
      RowBox[{"x", "(", "t", ")"}]}]}], " ", "=", 
    RowBox[{"f", "(", "t", ")"}]}], TraditionalForm]]],
 "\n            \nwhich corresponds to the operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"L", ":=", 
    RowBox[{
     SubscriptBox["A", "1"], 
     RowBox[{"\[PartialD]", 
      RowBox[{"-", 
       SubscriptBox["A", "0"]}]}]}]}], TraditionalForm]]],
 " with rectangular coefficients ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["A", "0"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["A", "1"], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.725262124525859*^9, 3.725262336647231*^9}, {
  3.7252633340349827`*^9, 3.725263336983388*^9}, {3.7252659611568427`*^9, 
  3.7252659703296585`*^9}, {3.7252673376101484`*^9, 3.7252673678274016`*^9}, {
  3.725267407913184*^9, 3.725267443210203*^9}, {3.725273135847596*^9, 
  3.725273135847596*^9}, {3.725277443331046*^9, 3.725277452784663*^9}, {
  3.7252800593113036`*^9, 3.7252800857689505`*^9}, {3.7262131742699466`*^9, 
  3.7262131883411713`*^9}, {3.755846628887581*^9, 3.7558466300626483`*^9}, {
  3.7558519592314596`*^9, 3.7558519619216137`*^9}, {3.756103233960514*^9, 
  3.7561032434780583`*^9}, {3.756103839885171*^9, 3.7561038414742613`*^9}}],

Cell[BoxData[
 RowBox[{"L", ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", "Diff"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    SubscriptBox["A", "0"], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.7252660030741167`*^9, 3.7252660043845186`*^9}, 
   3.7262132038475986`*^9}],

Cell[TextData[{
 "Our goal is to construct a solution operator ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", " ", "=", " ", 
    RowBox[{
     SubscriptBox["H", "1"], "\[CenterDot]", 
     RowBox[{"\[Integral]", 
      RowBox[{"\[CenterDot]", " ", 
       SubscriptBox["H", "2"], " "}]}]}]}], TraditionalForm]]],
 " such that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.7252673870310354`*^9, 3.725267397249053*^9}, {
   3.725280098326972*^9, 3.725280117577406*^9}, 3.756103849445718*^9}],

Cell[BoxData[
 RowBox[{"HH", ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    SubscriptBox["H", "1"], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.725260850156021*^9, 3.7252608712472577`*^9}, 
   3.7252610169359136`*^9, 3.725261047964368*^9, {3.725261080474825*^9, 
   3.7252610994600587`*^9}, {3.7252634795052385`*^9, 3.72526350897369*^9}, 
   3.7252636071446624`*^9, 3.7252648589884615`*^9, 3.7252649051021423`*^9}],

Cell[TextData[{
 "We apply the reduction system to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"L", "\[CenterDot]", "H"}], TraditionalForm]]],
 " in order to derive conditions via comparing coefficients in normal forms."
}], "Text",
 CellChangeTimes->{{3.725267473836955*^9, 3.7252674876817465`*^9}, 
   3.725280122210614*^9, {3.756103865137615*^9, 3.7561038947243075`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"L", ",", "HH"}], "]"}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.725259110686346*^9, 3.7252591388911953`*^9}, {
   3.725259171713653*^9, 3.725259197219698*^9}, 3.725259307309091*^9, {
   3.7252596513036957`*^9, 3.725259657122506*^9}, 3.7252599908226924`*^9, 
   3.7252600912594876`*^9, 3.725260288429234*^9, {3.725260342639329*^9, 
   3.725260351078944*^9}, {3.7252604771905656`*^9, 3.7252604956609983`*^9}, 
   3.725260558232708*^9, {3.7252606603348875`*^9, 3.725260688165336*^9}, {
   3.725260755635455*^9, 3.7252607727174845`*^9}, 3.72526081552396*^9, {
   3.725260857768834*^9, 3.7252608783920703`*^9}, {3.7252609092645245`*^9, 
   3.7252609140381327`*^9}, {3.725260974176238*^9, 3.7252609941130733`*^9}, {
   3.7252611115032797`*^9, 3.725261136213723*^9}, {3.7252613789345493`*^9, 
   3.725261394768577*^9}, {3.7252635231541147`*^9, 3.7252635274753227`*^9}, {
   3.7252648453852377`*^9, 3.725264854339653*^9}, 3.7252649124497557`*^9, {
   3.7253398368175125`*^9, 3.7253398373167133`*^9}, {3.7262960947283773`*^9, 
   3.726296096370689*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{
     SubscriptBox["A", "1"], ",", 
     SubscriptBox["H", "1"], ",", 
     SubscriptBox["H", "2"]}], "]"}], "]"}], "-", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["A", "0"], ",", 
      SubscriptBox["H", "1"]}], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}], "+", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"mul", "[", 
     RowBox[{
      SubscriptBox["A", "1"], ",", 
      RowBox[{"Diff", "[", 
       SubscriptBox["H", "1"], "]"}]}], "]"}], ",", "Int", ",", 
    SubscriptBox["H", "2"]}], "]"}]}]], "Output",
 CellChangeTimes->{
  3.7252606890857377`*^9, {3.7252607281950064`*^9, 3.725260783512704*^9}, {
   3.7252608178795643`*^9, 3.7252608806696744`*^9}, {3.7252609247865515`*^9, 
   3.725260942476983*^9}, {3.725260985455058*^9, 3.725260994971075*^9}, {
   3.725261033534343*^9, 3.7252611371965246`*^9}, {3.72526138500296*^9, 
   3.725261426452233*^9}, 3.7252614660295024`*^9, 3.7252625082475324`*^9, 
   3.725263105338581*^9, 3.7252635564601736`*^9, {3.7252648363060217`*^9, 
   3.7252648749628897`*^9}, 3.725264928954584*^9, 3.725265100242885*^9, 
   3.7252651511301746`*^9, 3.7252660517306023`*^9, 3.7252664432142897`*^9, 
   3.7252750241111135`*^9, 3.7252765177336206`*^9, 3.725277149722931*^9, 
   3.7252803128273487`*^9, 3.725339674418227*^9, 3.7253398551787453`*^9, 
   3.7262063494529853`*^9, 3.7262063952078657`*^9, 3.726207770039281*^9, 
   3.726208115723288*^9, 3.7262081998230357`*^9, 3.726210366593727*^9, 
   3.726210531676217*^9, 3.72621061290556*^9, 3.7262108380295553`*^9, 
   3.7262127602432194`*^9, 3.7262128195877237`*^9, 3.7262128724874163`*^9, 
   3.726213088953397*^9, 3.7262132595552964`*^9, 3.7262133500978556`*^9, 
   3.7262133955407352`*^9, 3.726230136893217*^9, 3.726296148279265*^9, 
   3.746779150189045*^9, 3.7467793528356357`*^9, 3.7467794081307983`*^9, 
   3.746780546891932*^9, 3.746781734482858*^9, 3.7467821456303744`*^9, 
   3.74678275188105*^9, 3.7467843083380747`*^9, 3.7467845144408627`*^9, 
   3.746785293646431*^9, 3.7467857832724357`*^9, 3.7467861274341207`*^9, 
   3.746789482950045*^9, 3.7467897081609263`*^9, 3.7467908646090717`*^9, 
   3.7467909828678355`*^9, 3.746791025187256*^9, 3.746791509932982*^9, 
   3.746791690999338*^9, 3.7467918989602327`*^9, 3.7468536642452354`*^9, 
   3.7468552815417395`*^9, 3.7468554691944723`*^9, 3.746867985203347*^9, 
   3.746868813740737*^9, 3.7468689209358683`*^9, 3.74686985109207*^9, 
   3.7468698902853117`*^9, 3.7468699265363855`*^9, 3.7468699809674983`*^9, {
   3.7468701847531548`*^9, 3.7468701990579724`*^9}, 3.746870339117984*^9, 
   3.746870404593728*^9, 3.7468704907846584`*^9, 3.7468714812093077`*^9, 
   3.7468715834951577`*^9, 3.747114461927147*^9, 3.747114886849451*^9, 
   3.747114945629813*^9, 3.7473831119821663`*^9, 3.7493817931911154`*^9, 
   3.7494425066608458`*^9, 3.755839301088455*^9, 3.7558501397283897`*^9, 
   3.755850174731392*^9, 3.7558504748035555`*^9, 3.7558508226904535`*^9, 
   3.7558519966446*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"%", "//", "Coefficients"}], "//", "TableForm"}]], "Input",
 CellChangeTimes->{{3.722925187781501*^9, 3.7229252237895603`*^9}, {
   3.7229253310726967`*^9, 3.722925333485834*^9}, {3.7229254079500933`*^9, 
   3.7229254113412876`*^9}, 3.7229255318941827`*^9, 3.72292564303854*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"Prod", "[", "]"}], 
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["A", "1"], ",", 
       SubscriptBox["H", "1"], ",", 
       SubscriptBox["H", "2"]}], "]"}]},
    {
     RowBox[{"Prod", "[", 
      RowBox[{"Int", ",", 
       SubscriptBox["H", "2"]}], "]"}], 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"mul", "[", 
        RowBox[{
         SubscriptBox["A", "0"], ",", 
         SubscriptBox["H", "1"]}], "]"}]}], "+", 
      RowBox[{"mul", "[", 
       RowBox[{
        SubscriptBox["A", "1"], ",", 
        RowBox[{"Diff", "[", 
         SubscriptBox["H", "1"], "]"}]}], "]"}]}]}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.7229252268177333`*^9, 3.72292534250535*^9, 3.7229253792574525`*^9, {
   3.722925546929043*^9, 3.722925568855297*^9}, 3.722925644239609*^9, 
   3.7229262646670523`*^9, 3.722926681749385*^9, 3.7230149566391*^9, 
   3.723015240497198*^9, 3.7230155897662115`*^9, 3.7230158073625937`*^9, 
   3.7230159563996553`*^9, 3.7230160631506424`*^9, 3.7230161143187323`*^9, 
   3.7230191519979286`*^9, 3.723020276051216*^9, 3.723020768243905*^9, 
   3.7230245292847137`*^9, 3.723028508223179*^9, 3.723028539685979*^9, 
   3.7230288185109262`*^9, 3.7230289203897533`*^9, 3.723030147649949*^9, 
   3.7230335160448847`*^9, {3.7230335502401447`*^9, 3.7230335762297897`*^9}, 
   3.72303410022871*^9, 3.723034182550055*^9, 3.7230342197249203`*^9, 
   3.7230343354303236`*^9, 3.7230343757251945`*^9, {3.723893296612508*^9, 
   3.7238933515870037`*^9}, 3.7240822352308435`*^9, 3.724082270206105*^9, {
   3.724082438592801*^9, 3.724082493879298*^9}, 3.7243964798756733`*^9, 
   3.724396536185752*^9, {3.724399514645934*^9, 3.7243995406959705`*^9}, {
   3.7243996714971533`*^9, 3.724399692707183*^9}, {3.724399752677267*^9, 
   3.724399776787301*^9}, 3.724399874677438*^9, 3.72439991183749*^9, 
   3.725258513394853*^9, 3.7252586951829724`*^9, 3.725258962474386*^9, 
   3.7252590682542715`*^9, 3.725259246640585*^9, 3.725259529919883*^9, 
   3.7252596889465623`*^9, 3.725259853854452*^9, 3.72525992098137*^9, 
   3.7252600188569417`*^9, {3.7252601071871157`*^9, 3.7252601365629673`*^9}, 
   3.725260261519187*^9, 3.725260517891037*^9, 3.7252606466380634`*^9, 
   3.7252607835439034`*^9, 3.7252608353047943`*^9, {3.7252609248021517`*^9, 
   3.7252609425081825`*^9}, 3.7252609854862585`*^9, 3.725261033659143*^9, {
   3.725261074905616*^9, 3.7252611245293026`*^9}, {3.725261426514633*^9, 
   3.7252614660607023`*^9}, 3.725262508263132*^9, 3.7252631053541813`*^9, 
   3.7252635565069733`*^9, {3.7252648509700475`*^9, 3.7252648750096893`*^9}, 
   3.725264928954584*^9, 3.7252651002584853`*^9, 3.7252651511301746`*^9, 
   3.725266051746202*^9, 3.72526644322989*^9, 3.7252750241267133`*^9, 
   3.725276517749221*^9, 3.725277149738531*^9, 3.725280312842949*^9, 
   3.7253396744338274`*^9, 3.7253398551943455`*^9, 3.7262063494529853`*^9, 
   3.7262063952078657`*^9, 3.7262077700548806`*^9, 3.726208115723288*^9, 
   3.7262081998230357`*^9, 3.726210366593727*^9, 3.726210531676217*^9, 
   3.72621061290556*^9, 3.7262108380451555`*^9, 3.7262127602432194`*^9, 
   3.726212819603324*^9, 3.7262128724874163`*^9, 3.726213088968997*^9, 
   3.726213259570896*^9, 3.7262133500978556`*^9, 3.7262133955563354`*^9, 
   3.7262301369088173`*^9, 3.726296148309494*^9, 3.746779150315052*^9, 
   3.746779352927641*^9, 3.7467794081437993`*^9, 3.746780546906933*^9, 
   3.746781734497859*^9, 3.7467821456433754`*^9, 3.746782751895051*^9, 
   3.746784308352075*^9, 3.7467845144828653`*^9, 3.7467852936594315`*^9, 
   3.7467857832874365`*^9, 3.746786127448121*^9, 3.7467894829710464`*^9, 
   3.7467897081739273`*^9, 3.7467908646230726`*^9, 3.7467909828838367`*^9, 
   3.746791025202257*^9, 3.7467915099449825`*^9, 3.7467916910143394`*^9, 
   3.7467918989742336`*^9, 3.7468536642592363`*^9, 3.7468552815557404`*^9, 
   3.746855469205473*^9, 3.7468679852163477`*^9, 3.746868813754738*^9, 
   3.746868920951869*^9, 3.7468698511040707`*^9, 3.7468698902993126`*^9, 
   3.746869926550386*^9, 3.746869980981499*^9, {3.7468701847731557`*^9, 
   3.7468701990729733`*^9}, 3.7468703391319847`*^9, 3.7468704046087294`*^9, 
   3.7468704907986593`*^9, 3.746871481223308*^9, 3.7468715835091586`*^9, 
   3.7471144619401474`*^9, 3.747114886862452*^9, 3.747114945641814*^9, 
   3.747383112005168*^9, 3.749381793202116*^9, 3.7494425066858473`*^9, 
   3.755839301104456*^9, 3.7558501397463913`*^9, 3.7558501747473927`*^9, 
   3.7558504748275566`*^9, 3.755850822719455*^9, 3.7558519966676006`*^9}]
}, Open  ]],

Cell[TextData[{
 "Comparing coefficients in",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{"L", "\[CenterDot]", "H"}], "=", "1"}]}], TraditionalForm]]],
 " yields\n\n                                                     ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["A", "1"], 
     SubscriptBox["H", "1"], 
     SubscriptBox["H", "2"]}], "=", "1"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["A", "1"], 
      RowBox[{"\[PartialD]", 
       SubscriptBox["H", "1"]}]}], "-", " ", 
     RowBox[{
      SubscriptBox["A", "0"], " ", 
      SubscriptBox["H", "1"]}]}], "=", "0"}], TraditionalForm]]],
 ".\n \nA solution is obtained by choosing an invertible ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[CapitalTheta]", " "}], TraditionalForm]]],
 "and ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 " s.t\:200e. ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["A", "1"], "\[CapitalTheta]", 
    OverscriptBox["\[CapitalTheta]", "~"]}], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{"=", "1"}]}], TraditionalForm]]],
 "  and ",
 Cell[BoxData[
  FormBox[Cell[TextData[{
    Cell[BoxData[
     FormBox[
      SubscriptBox["A", "1"], TraditionalForm]]],
    "\[PartialD] \[CapitalTheta] - ",
    Cell[BoxData[
     FormBox[
      SubscriptBox["A", "0"], TraditionalForm]]],
    " \[CapitalTheta]",
    Cell[BoxData[
     FormBox[
      RowBox[{"=", "0"}], TraditionalForm]]]
   }]], TraditionalForm]]],
 " and letting ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "1"], TraditionalForm]]],
 Cell[BoxData[
  FormBox[
   RowBox[{"=", "\[CapitalTheta]"}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["H", "2"], TraditionalForm]]],
 "= ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 "\:200e, \:200ei.e\:200e. ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{"\[CapitalTheta]", "\[CenterDot]", 
     RowBox[{"\[Integral]", "\[CenterDot]"}]}]}], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[CapitalTheta]", "~"], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.7252675253459015`*^9, 3.725267583429223*^9}, {
   3.725267636537261*^9, 3.725267797106759*^9}, {3.7252678768473206`*^9, 
   3.7252679179466715`*^9}, 3.72527775275399*^9, 3.725279314323794*^9, {
   3.725280127748624*^9, 3.7252802655748663`*^9}, {3.7262132232072325`*^9, 
   3.7262132320524483`*^9}, {3.756035998123866*^9, 3.7560360397822485`*^9}, {
   3.756103925633075*^9, 3.7561040304450703`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    SubscriptBox["A", "1"], ",", "\[CapitalTheta]", ",", 
    "\[CapitalTheta]\[CapitalTheta]", ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7252775504116344`*^9, 3.725277580208687*^9}, {
  3.725277632454179*^9, 3.7252776582490244`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    SubscriptBox["A", "1"], ",", 
    RowBox[{"Diff", "[", "\[CapitalTheta]", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    SubscriptBox["A", "0"], ",", "\[CapitalTheta]", ",", "b"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.725277668825843*^9, 3.7252777307891517`*^9}, 
   3.726213382577112*^9}],

Cell["\<\
We also need to define consequences of these definitions. Such consequences \
are not automatically inferred by the package.\
\>", "Text",
 CellChangeTimes->{{3.725278857839992*^9, 3.7252789095072827`*^9}, {
   3.725278958023368*^9, 3.725279003779248*^9}, 3.756104243792273*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     SubscriptBox["A", "1"], "]"}], ",", 
    RowBox[{"Eval", "[", "\[CapitalTheta]", "]"}], ",", 
    RowBox[{"Eval", "[", "\[CapitalTheta]\[CapitalTheta]", "]"}], ",", 
    "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7251665889144287`*^9, 3.725166606688616*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    SubscriptBox["A", "1"], ",", "\[CapitalTheta]", ",", 
    RowBox[{"Diff", "[", "\[CapitalTheta]\[CapitalTheta]", "]"}], ",", 
    "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{
       SubscriptBox["A", "0"], ",", "\[CapitalTheta]", ",", 
       "\[CapitalTheta]\[CapitalTheta]"}], "]"}], "-", 
     RowBox[{"mul", "[", 
      RowBox[{
       RowBox[{"Diff", "[", 
        SubscriptBox["A", "1"], "]"}], ",", "\[CapitalTheta]", ",", 
       "\[CapitalTheta]\[CapitalTheta]"}], "]"}]}], ",", "b"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.7251160812328053`*^9, 3.72511612451825*^9}, {
  3.726213334497828*^9, 3.72621335824107*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HH", "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["H", "1"], "\[Rule]", " ", "\[CapitalTheta]"}], ",", 
    RowBox[{
     SubscriptBox["H", "2"], "\[Rule]", " ", 
     "\[CapitalTheta]\[CapitalTheta]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.7252679351456547`*^9, 3.7252679541297407`*^9}}],

Cell[BoxData[
 RowBox[{"Prod", "[", 
  RowBox[{
  "\[CapitalTheta]", ",", "Int", ",", "\[CapitalTheta]\[CapitalTheta]"}], 
  "]"}]], "Output",
 CellChangeTimes->{
  3.7252679569129*^9, 3.7252750241267133`*^9, 3.7252765177648206`*^9, 
   3.725277149738531*^9, 3.7252803128741493`*^9, 3.725339674465028*^9, 
   3.725339855225545*^9, 3.726206349484185*^9, 3.726206395239066*^9, 
   3.7262077700704803`*^9, 3.726208115754488*^9, 3.7262081998542356`*^9, 
   3.7262103666249275`*^9, 3.7262105317074175`*^9, 3.72621061293676*^9, 
   3.7262108380607557`*^9, 3.7262127602744193`*^9, 3.7262128196189237`*^9, 
   3.7262128725186167`*^9, 3.7262130889845967`*^9, 3.7262132595864964`*^9, 
   3.7262133501290555`*^9, 3.726213395571935*^9, 3.726230136971217*^9, 
   3.726296148394549*^9, 3.7467791503750553`*^9, 3.7467793529696436`*^9, 
   3.7467794081878014`*^9, 3.7467805469509354`*^9, 3.7467817345458617`*^9, 
   3.746782145687378*^9, 3.746782751942054*^9, 3.7467843083980775`*^9, 
   3.7467845145408683`*^9, 3.746785293701434*^9, 3.746785783333439*^9, 
   3.746786127492124*^9, 3.74678948303505*^9, 3.74678970822093*^9, 
   3.746790864671075*^9, 3.7467909829278393`*^9, 3.7467910252452593`*^9, 
   3.7467915099929857`*^9, 3.7467916910623417`*^9, 3.7467918990232363`*^9, 
   3.746853664303239*^9, 3.7468552815947423`*^9, 3.7468554692484756`*^9, 
   3.7468679852613506`*^9, 3.7468688138037405`*^9, 3.746868920998872*^9, 
   3.746869851150073*^9, 3.746869890345315*^9, 3.7468699265953884`*^9, 
   3.7468699810255017`*^9, {3.7468701848071575`*^9, 3.746870199116976*^9}, 
   3.746870339178987*^9, 3.746870404656732*^9, 3.746870490845662*^9, 
   3.7468714812683105`*^9, 3.7468715835551615`*^9, 3.7471144619841504`*^9, 
   3.747114886904454*^9, 3.7471149456798162`*^9, 3.747383112066171*^9, 
   3.749381793247119*^9, 3.7494425067548513`*^9, 3.75583930116346*^9, 
   3.7558501398133945`*^9, 3.7558501748083963`*^9, 3.755850474997566*^9, 
   3.7558508229604683`*^9, 3.7558519967526054`*^9}]
}, Open  ]],

Cell[TextData[{
 "We verify that ",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", " "}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is a right Inverse of ",
 Cell[BoxData[
  FormBox["L", TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{
  3.7561040717064304`*^9, {3.7561041628876457`*^9, 3.7561041814937096`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ApplyRules", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Prod", "[", 
     RowBox[{"L", ",", 
      RowBox[{"Prod", "[", 
       RowBox[{
       "\[CapitalTheta]", ",", "Int", ",", "\[CapitalTheta]\[CapitalTheta]"}],
        "]"}]}], "]"}], "-", 
    RowBox[{"Prod", "[", "]"}]}], ",", "RedSys"}], "]"}]], "Input",
 CellChangeTimes->{{3.7252778242333155`*^9, 3.7252778297713256`*^9}, {
  3.7253398426987233`*^9, 3.725339843135524*^9}, {3.726296104550228*^9, 
  3.726296106001169*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7252778325949306`*^9, 3.725277885494623*^9, 3.7252803128741493`*^9, 
   3.7253396744962273`*^9, 3.725339855225545*^9, 3.7262063494997854`*^9, 
   3.726206395254666*^9, 3.7262077700860806`*^9, 3.726208115770088*^9, 
   3.726208199869836*^9, 3.7262103666249275`*^9, 3.7262105317230177`*^9, 
   3.72621061295236*^9, 3.7262108380763555`*^9, 3.7262127602900195`*^9, 
   3.7262128196345234`*^9, 3.726212872534217*^9, 3.7262130890001965`*^9, 
   3.7262132596020966`*^9, 3.7262133501446557`*^9, 3.7262133955875354`*^9, 
   3.726230137002417*^9, 3.726296148416889*^9, 3.746779150412058*^9, 
   3.746779352996645*^9, 3.7467794081998024`*^9, 3.7467805469799366`*^9, 
   3.746781734580864*^9, 3.7467821457003784`*^9, 3.7467827519560547`*^9, 
   3.7467843084330797`*^9, 3.7467845145878716`*^9, 3.746785293713434*^9, 
   3.7467857833664412`*^9, 3.746786127526126*^9, 3.746789483074052*^9, 
   3.7467897082509317`*^9, 3.7467908647010765`*^9, 3.7467909829568405`*^9, 
   3.7467910252762613`*^9, 3.746791510005986*^9, 3.746791691097344*^9, 
   3.746791899064239*^9, 3.7468536643352404`*^9, 3.746855281622744*^9, 
   3.7468554692784777`*^9, 3.7468679852923527`*^9, 3.746868813829742*^9, 
   3.746868921037874*^9, 3.746869851178075*^9, 3.746869890357316*^9, 
   3.7468699266213903`*^9, 3.7468699810545034`*^9, {3.746870184825158*^9, 
   3.7468701991299767`*^9}, 3.7468703392099886`*^9, 3.746870404683734*^9, 
   3.7468704908796635`*^9, 3.7468714812973127`*^9, 3.7468715835841627`*^9, 
   3.7471144619951506`*^9, 3.747114886934456*^9, 3.7471149456898165`*^9, 
   3.747383112081172*^9, 3.74938179327612*^9, 3.7494425067718525`*^9, 
   3.7558393011794605`*^9, 3.755850139852397*^9, 3.755850174822397*^9, 
   3.755850475016567*^9, 3.75585082298347*^9, 3.7558519967716064`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1904, 998},
WindowMargins->{{-8, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
Magnification:>2. Inherited,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info-d97f53e1-020f-4eee-9e63-656f5e690c51"->{
  Cell[1757, 44, 290, 5, 84, "Print",
   CellTags->"Info-d97f53e1-020f-4eee-9e63-656f5e690c51"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info-d97f53e1-020f-4eee-9e63-656f5e690c51", 123251, 3193}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 405, 8, 60, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[852, 27, 902, 15, 112, "Print"],
Cell[1757, 44, 290, 5, 84, "Print",
 CellTags->"Info-d97f53e1-020f-4eee-9e63-656f5e690c51"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2096, 55, 231, 4, 127, "Section",
 InitializationCell->True],
Cell[2330, 61, 763, 22, 100, "Text"],
Cell[3096, 85, 1009, 23, 66, "Input"],
Cell[4108, 110, 798, 20, 60, "Input"],
Cell[CellGroupData[{
Cell[4931, 134, 105, 1, 85, "Subsection"],
Cell[5039, 137, 2405, 65, 175, "Input"],
Cell[7447, 204, 474, 14, 60, "Input"],
Cell[7924, 220, 397, 12, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8358, 237, 160, 2, 85, "Subsection"],
Cell[8521, 241, 102, 1, 120, "Text"],
Cell[8626, 244, 436, 10, 120, "Input"],
Cell[9065, 256, 1104, 29, 122, "Text"],
Cell[10172, 287, 1915, 49, 502, "Input"],
Cell[12090, 338, 205, 2, 120, "Text"],
Cell[12298, 342, 2210, 62, 654, "Input"],
Cell[14511, 406, 104, 1, 120, "Text"],
Cell[14618, 409, 570, 13, 198, "Input"],
Cell[15191, 424, 110, 1, 120, "Text"],
Cell[15304, 427, 545, 16, 198, "Input"],
Cell[15852, 445, 182, 2, 120, "Text"],
Cell[16037, 449, 205, 5, 120, "Input"],
Cell[16245, 456, 188, 5, 120, "Input"],
Cell[16436, 463, 264, 6, 120, "Input"],
Cell[16703, 471, 164, 5, 120, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16904, 481, 155, 2, 170, "Subsection"],
Cell[CellGroupData[{
Cell[17084, 487, 105, 1, 134, "Subsubsection"],
Cell[17192, 490, 1787, 44, 502, "Input"],
Cell[18982, 536, 1071, 30, 198, "Input"],
Cell[20056, 568, 717, 19, 198, "Input"],
Cell[20776, 589, 143, 3, 120, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20956, 597, 134, 2, 134, "Subsubsection"],
Cell[21093, 601, 2360, 48, 426, "Input"],
Cell[23456, 651, 260, 6, 120, "Input"],
Cell[23719, 659, 421, 12, 120, "Input"],
Cell[24143, 673, 417, 12, 120, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24597, 690, 134, 2, 134, "Subsubsection"],
Cell[24734, 694, 1481, 39, 274, "Input"],
Cell[26218, 735, 800, 23, 120, "Input"],
Cell[27021, 760, 391, 10, 120, "Input"],
Cell[27415, 772, 209, 5, 120, "Input"],
Cell[27627, 779, 364, 11, 120, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28028, 795, 137, 2, 134, "Subsubsection"],
Cell[28168, 799, 873, 20, 274, "Input"],
Cell[29044, 821, 211, 5, 120, "Input"],
Cell[29258, 828, 899, 26, 198, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30194, 859, 134, 2, 134, "Subsubsection"],
Cell[30331, 863, 550, 12, 198, "Input"],
Cell[30884, 877, 589, 12, 198, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31510, 894, 104, 1, 134, "Subsubsection"],
Cell[31617, 897, 3115, 103, 730, "Input"],
Cell[34735, 1002, 474, 14, 120, "Input"],
Cell[35212, 1018, 2535, 84, 480, "Input"],
Cell[37750, 1104, 468, 14, 120, "Input"],
Cell[38221, 1120, 625, 20, 120, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38895, 1146, 180, 2, 170, "Subsection"],
Cell[39078, 1150, 792, 20, 120, "Input"],
Cell[39873, 1172, 964, 28, 274, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[40886, 1206, 341, 5, 95, "Section",
 InitializationCell->True],
Cell[41230, 1213, 4818, 143, 555, "Input"],
Cell[46051, 1358, 2840, 88, 362, "Input"],
Cell[48894, 1448, 3465, 107, 350, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[52396, 1560, 107, 2, 95, "Section",
 InitializationCell->True],
Cell[52506, 1564, 2650, 74, 251, "Input"],
Cell[55159, 1640, 2112, 58, 251, "Input"],
Cell[57274, 1700, 421, 14, 60, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57732, 1719, 344, 4, 127, "Section"],
Cell[58079, 1725, 1466, 37, 105, "Text"],
Cell[59548, 1764, 873, 21, 137, "Input"],
Cell[CellGroupData[{
Cell[60446, 1789, 515, 8, 170, "Subsection"],
Cell[60964, 1799, 314, 4, 120, "Text"],
Cell[61281, 1805, 2596, 47, 130, "Text"],
Cell[63880, 1854, 1442, 47, 220, "Text"],
Cell[65325, 1903, 805, 19, 274, "Input"],
Cell[66133, 1924, 833, 20, 126, "Text"],
Cell[66969, 1946, 374, 8, 120, "Input"],
Cell[67346, 1956, 316, 6, 120, "Input"],
Cell[67665, 1964, 655, 14, 120, "Text"],
Cell[CellGroupData[{
Cell[68345, 1982, 1223, 19, 120, "Input"],
Cell[CellGroupData[{
Cell[69593, 2005, 403, 9, 86, "Print"],
Cell[69999, 2016, 382, 9, 86, "Print"],
Cell[70384, 2027, 384, 9, 86, "Print"],
Cell[70771, 2038, 384, 9, 86, "Print"],
Cell[71158, 2049, 401, 9, 86, "Print"],
Cell[71562, 2060, 356, 8, 86, "Print"]
}, Open  ]],
Cell[71933, 2071, 3884, 77, 194, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75854, 2153, 312, 5, 120, "Input"],
Cell[76169, 2160, 5909, 115, 298, "Output"]
}, Open  ]],
Cell[82093, 2278, 790, 19, 248, "Text"],
Cell[CellGroupData[{
Cell[82908, 2301, 483, 11, 240, "Input"],
Cell[83394, 2314, 4000, 59, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[87431, 2378, 556, 12, 240, "Input"],
Cell[87990, 2392, 3485, 47, 236, "Output"]
}, Open  ]],
Cell[91490, 2442, 1058, 32, 240, "Text"],
Cell[CellGroupData[{
Cell[92573, 2478, 227, 6, 240, "Input"],
Cell[92803, 2486, 2601, 43, 236, "Output"]
}, Open  ]],
Cell[95419, 2532, 424, 12, 240, "Text"],
Cell[CellGroupData[{
Cell[95868, 2548, 452, 13, 240, "Input"],
Cell[96323, 2563, 2131, 30, 236, "Output"]
}, Open  ]],
Cell[98469, 2596, 767, 21, 240, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[99273, 2622, 496, 8, 340, "Subsection"],
Cell[99772, 2632, 1664, 44, 848, "Text"],
Cell[101439, 2678, 312, 9, 240, "Input"],
Cell[101754, 2689, 595, 18, 268, "Text"],
Cell[102352, 2709, 459, 9, 240, "Input"],
Cell[102814, 2720, 370, 8, 240, "Text"],
Cell[CellGroupData[{
Cell[103209, 2732, 1152, 18, 240, "Input"],
Cell[104364, 2752, 3079, 56, 236, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107480, 2813, 312, 5, 240, "Input"],
Cell[107795, 2820, 4977, 89, 340, "Output"]
}, Open  ]],
Cell[112787, 2912, 2677, 92, 1044, "Text"],
Cell[115467, 3006, 385, 9, 240, "Input"],
Cell[115855, 3017, 411, 11, 240, "Input"],
Cell[116269, 3030, 288, 5, 240, "Text"],
Cell[116560, 3037, 434, 11, 240, "Input"],
Cell[116997, 3050, 786, 21, 240, "Input"],
Cell[CellGroupData[{
Cell[117808, 3075, 339, 9, 240, "Input"],
Cell[118150, 3086, 1969, 30, 236, "Output"]
}, Open  ]],
Cell[120134, 3119, 329, 12, 244, "Text"],
Cell[CellGroupData[{
Cell[120488, 3135, 506, 13, 240, "Input"],
Cell[120997, 3150, 1806, 25, 236, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

