(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    119716,       3468]
NotebookOptionsPosition[    109207,       3182]
NotebookOutlinePosition[    109787,       3204]
CellTagsIndexPosition[    109681,       3199]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"<<", 
  "\"\<C:\\\\Users\\\\Jamal\\\\Desktop\\\\main\\\\MyThesis\\\\Examples//\
TenReS.m\>\""}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.694167372350441*^9, 3.694167385792696*^9}, {
   3.6993427658432713`*^9, 3.6993428272217827`*^9}, {3.7262326477393084`*^9, 
   3.726232661647654*^9}, {3.7467793339755573`*^9, 3.7467793935119624`*^9}, 
   3.749442490010894*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Package TenReS version 0.2.4\\nwritten by Clemens G. \
Raab\\nCopyright 2016, RICAM, Austrian Academy of Sciences\"\>"], "Print",
 CellChangeTimes->CompressedData["
1:eJwdznlI03EYBvBtXqUuJpSW1dIas7Cahpiu0hYLPCIjiiLNY2XktLQc84hM
RtQ0tUVMZRmGBPmHlVpKOUuYk2amXSoo6yA8hj/yQMuhrfo+7x8vHx544HmD
VblHMwU8Hi+SHZR7PQpWT3GKk+fGyal4t2aYadhHWp/lK7OZelkzadWNFEDH
2dWFULq9oZuyy04uXQq7kcMcmFOTDWlj9VAtkzyAHZZT/AvMwX4jaRBVxsCh
373klcW7WfCN93vSo23GN5c5rQ8XwqjwkG1Q+SOT7FzT9hL6Xp0nP/npbLCH
6yQrDvX1Q/Oo5wA0CVTeeczl2vukXzw/GKpbY8ghFW8PbKrYS/r3PDxTxSx/
OklK4/p23IZi0U6YspR4EPrM3yQbv9oyjExdq6cKBlWf7jVSv5ZM/GUehiWC
JXIhwS2xGvurFGRGBJcEA91DjsDUQM0x6GhvJrWHY5OhKayYTPhi08A/sxYt
1Deu1MO1l5Xk/oXdBvh6LJ/UGl0mWFonvwe9pG/9a5hdQR4BMI+7swVOjAyQ
Pu3JZiHH/p6uI99Zimehs8BMSqT2RWgPCnBCTX2Vw4DetVGyaKv1c/oMpxCv
9xqEnnJLYQnzRPSmIvh4l6+jZZlT5HSrSdN8h/M58+I6F3ldNPEPug9v5rUx
UwJlIhjQlU1q7eII+EqRStokLQnwY+g0WS/nr/jGfKI+QDZFRUTD3p95pKwy
8jjcMKYhXyR9Pw//eouz4OgtQTEs1cWSG+M+lMGyNGE5dKaHuuBcVDaZo7Ty
Jpn+4wI+/A9Rcu63
  "]],

Cell[BoxData[
 StyleBox["\<\"A few definitions need to be made by the user. Type ?CoeffQ, \
?Specialization, and ?CyclicModules for more information.\"\>", 
  "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.755948040156468*^9},
 CellTags->"Info-534e4566-7628-4f69-b46a-fb1a18609de3"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic definitions", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.6400787807134733`*^9, 3.640078788888632*^9}, {
  3.659170131248847*^9, 3.659170137303594*^9}, {3.682830115630125*^9, 
  3.6828301266446743`*^9}}],

Cell[TextData[{
 "We want to compute in the tensor ring over ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodules. However, bimodules are not implemented, so the implementation \
uses the tensor algebra product over ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-modules. Consequently, the cyclic ",
 Cell[BoxData[
  FormBox["K", TraditionalForm]]],
 "-bimodule ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["M", "K"], TraditionalForm]]],
 " is not a cyclic ",
 Cell[BoxData[
  FormBox["\[DoubleStruckCapitalZ]", TraditionalForm]]],
 "-module."
}], "Text",
 CellChangeTimes->{{3.674799362782167*^9, 3.674799486021337*^9}, {
  3.674799838708332*^9, 3.674799892900877*^9}, {3.687079520040925*^9, 
  3.687079543347366*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Specialization", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"R", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"K", ",", 
        OverscriptBox["R", "~"]}], "}"}]}], ",", 
     RowBox[{"\[CapitalPhi]", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", 
        OverscriptBox["\[CapitalPhi]", "~"]}], "}"}]}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6398890163113747`*^9, 3.639889054043709*^9}, {
   3.639889737312602*^9, 3.639889744112504*^9}, {3.6398940881500607`*^9, 
   3.639894098174966*^9}, {3.659086827358851*^9, 3.659086831494749*^9}, {
   3.659088973275432*^9, 3.659088977842003*^9}, {3.6590976281633368`*^9, 
   3.659097642819615*^9}, {3.670244973878394*^9, 3.670245032387117*^9}, {
   3.670247219591683*^9, 3.670247222415421*^9}, 3.6871531306206007`*^9, {
   3.689592234536019*^9, 3.6895922372660227`*^9}, 3.755931738846939*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CyclicModules", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<E\>\"", ",", "Eval"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"D", ",", "Diff"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<I\>\"", ",", "Int"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.659096534797022*^9, 3.6590965352753773`*^9}, {
   3.659096673633688*^9, 3.659096675368188*^9}, {3.670245062107257*^9, 
   3.6702451117240057`*^9}, {3.670245295686005*^9, 3.67024532450555*^9}, {
   3.670247225231395*^9, 3.6702472253272943`*^9}, 3.687153154519842*^9, 
   3.75593174463027*^9}],

Cell[CellGroupData[{

Cell["Bimodule structure", "Subsection",
 CellChangeTimes->{{3.683001088920826*^9, 3.68300109299426*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b", ":", 
     RowBox[{"Diff", "|", "Int", "|", "Eval", "|", 
      RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}]}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", "b", ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"mul", "[", 
     RowBox[{"b", ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"b_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ")"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"b", ",", "c"}], "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "d"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", 
     RowBox[{
      RowBox[{"c_", "?", 
       SubscriptBox["MemberQ", "K"]}], ",", "f__"}], "]"}], ",", "b___"}], 
   "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"c", " ", 
     RowBox[{"Prod", "[", "]"}]}], ",", 
    RowBox[{"mul", "[", "f", "]"}], ",", "b"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Prod", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"b_", "*", "c_Plus"}], ",", "d___"}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"a", ",", 
    RowBox[{"Map", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"b", "*", "#"}], "&"}], ",", "c"}], "]"}], ",", "d"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.682838778862541*^9, 3.682838843044186*^9}, 
   3.68283887404455*^9, {3.682838905347752*^9, 3.682838945747851*^9}, {
   3.6828389863455553`*^9, 3.682839001603705*^9}, {3.682839064639946*^9, 
   3.682839067127886*^9}, {3.6829202148020077`*^9, 3.682920246908084*^9}, {
   3.6829202861393833`*^9, 3.682920383404994*^9}, {3.6829204540780697`*^9, 
   3.6829204543463497`*^9}, {3.682920550373654*^9, 3.682920568978134*^9}, {
   3.687153170837471*^9, 3.6871531990579205`*^9}, 3.6871532388223906`*^9, {
   3.6871532710520473`*^9, 3.687153299007296*^9}, {3.6871537992221746`*^9, 
   3.6871538033249817`*^9}, 3.6895922436960316`*^9, 3.755931754688845*^9, {
   3.755932176262958*^9, 3.7559321772710156`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Membership checks", "Subsection",
 CellChangeTimes->{{3.6591723429752007`*^9, 3.6591723786702147`*^9}, {
  3.670250652868689*^9, 3.6702506619234743`*^9}}],

Cell["Check for constants:", "Text",
 CellChangeTimes->{{3.659163098154707*^9, 3.659163115075246*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "K"], "[", "f_", "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Diff", "[", "f", "]"}], "===", "0"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.638682699993037*^9, 3.638682727301762*^9}, 
   3.67024541657796*^9, {3.68715821445373*^9, 3.6871582755278373`*^9}, {
   3.6871584196564903`*^9, 3.6871584226048956`*^9}, {3.6895922571560507`*^9, 
   3.6895922587360525`*^9}}],

Cell["Check for membership in the function algebra:", "Text",
 CellChangeTimes->{{3.6591631194512157`*^9, 3.6591631291876383`*^9}, 
   3.659163217493614*^9, {3.6591724206231956`*^9, 3.659172422789729*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"F", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", "f_mul", "]"}], ":=", 
  RowBox[{"And", "@@", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["MemberQ", "R"], "/@", 
     RowBox[{"(", 
      RowBox[{"List", "@@", "f"}], ")"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "[", "k_Integer", "]"}], ":=", 
  RowBox[{"F", "[", "k", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "R"], "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "True"}]}], "Input",
 CellChangeTimes->{{3.669455790328519*^9, 3.6694557970644712`*^9}, {
   3.669543619267727*^9, 3.669543632574329*^9}, {3.670245501045932*^9, 
   3.670245606567086*^9}, 3.670246245762525*^9, 3.682830172179517*^9, {
   3.6828355629428263`*^9, 3.682835600736021*^9}, {3.6871533509085875`*^9, 
   3.687153351704189*^9}, {3.689592274976075*^9, 3.689592324676145*^9}, {
   3.6895923885585527`*^9, 3.689592428534314*^9}, {3.698728886447846*^9, 
   3.698728918015327*^9}, {3.698730164873973*^9, 3.698730171312064*^9}, {
   3.698730495221025*^9, 3.6987304978995113`*^9}, {3.69873057212881*^9, 
   3.698730576040122*^9}, {3.7559321957820745`*^9, 3.755932196311105*^9}}],

Cell["Check for functionals:", "Text",
 CellChangeTimes->{{3.670245973081357*^9, 3.670245977713456*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", "Eval", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\[CapitalPhi]"], "[", 
   RowBox[{"\[CapitalPhi]", "[", "_Integer", "]"}], "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.6702459832458897`*^9, 3.670246019832996*^9}, {
   3.687103716685647*^9, 3.687103749558527*^9}, {3.6871039884201894`*^9, 
   3.6871039890202236`*^9}, 3.687153387038251*^9}],

Cell["Check for membership in the other cyclic modules:", "Text",
 CellChangeTimes->{{3.6702458564563427`*^9, 3.670245866975058*^9}, {
  3.670245946760453*^9, 3.670245947584765*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "D"], "[", "Diff", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<I\>\""], "[", "Int", "]"}], ":=", 
  "True"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["MemberQ", "\"\<E\>\""], "[", "Eval", "]"}], ":=", 
  "True"}]}], "Input",
 CellChangeTimes->{{3.669455877198039*^9, 3.669455894498609*^9}, 
   3.669543189868985*^9, {3.7559322391505547`*^9, 3.7559322400066037`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Function algebra", "Subsection",
 CellChangeTimes->{{3.638691610025188*^9, 3.638691614921186*^9}, {
  3.659165795915909*^9, 3.6591657979705772`*^9}}],

Cell[CellGroupData[{

Cell["Multiplication", "Subsubsection",
 CellChangeTimes->{{3.659165569776952*^9, 3.659165577588789*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Plus", ",", "c___"}], "]"}], ":=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"mul", "[", 
      RowBox[{"a", ",", "#", ",", "c"}], "]"}], "&"}], "/@", "b"}], 
   ")"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", "b_Integer", ",", "c__"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a__", ",", "b_Integer", ",", "c___"}], "]"}], ":=", 
  RowBox[{"b", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"d_Integer", "*", "b_"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"d", " ", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", "b", ",", "c"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"mul", "[", "b__", "]"}], ",", "c___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b", ",", "c"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", "a_", "]"}], ":=", "a"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"inv", "[", "f_", "]"}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", "]"}], ":=", "1"}]}], "Input",
 CellChangeTimes->{{3.638684986800296*^9, 3.638685023740603*^9}, {
   3.638685085399458*^9, 3.6386851016267347`*^9}, {3.6386852559617443`*^9, 
   3.638685292086501*^9}, {3.638685328564872*^9, 3.63868533076567*^9}, {
   3.638685453632114*^9, 3.638685456591627*^9}, {3.638685773732319*^9, 
   3.63868577618708*^9}, 3.6386858741418343`*^9, {3.63869290635741*^9, 
   3.6386929232045727`*^9}, {3.6387824422362843`*^9, 3.638782493065415*^9}, {
   3.6388722777325487`*^9, 3.6388722903501*^9}, {3.639212523253624*^9, 
   3.639212586876335*^9}, 3.639980360207717*^9, {3.7559325279740744`*^9, 
   3.755932528956131*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Differentiation", "Subsubsection",
 CellChangeTimes->{{3.659163141267557*^9, 3.6591631488521423`*^9}, 
   3.659165586346394*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"f_", "?", "NumericQ"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[CurlyPhi]_", "?", 
      SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ")"}], "[", "f_", "]"}], 
   "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "a_mul", "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{"MapAt", "[", 
     RowBox[{"Diff", ",", "a", ",", "i"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"Length", "[", "a", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Diff", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{"inv", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"-", 
   RowBox[{"mul", "[", 
    RowBox[{
     RowBox[{"inv", "[", "f", "]"}], ",", 
     RowBox[{"Diff", "[", "f", "]"}], ",", 
     RowBox[{"inv", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Diff", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Diff", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.638682746051725*^9, 3.638682788960909*^9}, {
   3.638682825870358*^9, 3.638682962118843*^9}, {3.6386831317951612`*^9, 
   3.638683190849043*^9}, {3.638683239496002*^9, 3.638683300736999*^9}, {
   3.638683391426631*^9, 3.6386834461159897`*^9}, {3.638782252717188*^9, 
   3.638782253282292*^9}, {3.638782504556032*^9, 3.6387825049058027`*^9}, {
   3.639212762878365*^9, 3.639212788512412*^9}, {3.640058908518703*^9, 
   3.640058989848414*^9}, {3.6400590763931026`*^9, 3.640059144710424*^9}, {
   3.659159838349127*^9, 3.659159839787879*^9}, {3.659701295933262*^9, 
   3.6597012991698523`*^9}, {3.659701749337516*^9, 3.6597017541360083`*^9}, {
   3.659701785652364*^9, 3.6597017880263767`*^9}, {3.659701846596245*^9, 
   3.6597018492038803`*^9}, {3.670246185189465*^9, 3.670246215676208*^9}, {
   3.670246254518935*^9, 3.670246256356043*^9}, {3.670246334717093*^9, 
   3.670246369529475*^9}, 3.670246738163018*^9, {3.670249771073493*^9, 
   3.6702497719200172`*^9}, {3.68283571585677*^9, 3.682835730684732*^9}, {
   3.6829379750055523`*^9, 3.682937975485763*^9}, {3.6829429368147717`*^9, 
   3.68294293771128*^9}, {3.6871559666597815`*^9, 3.687155983913412*^9}, {
   3.6871561575257173`*^9, 3.6871561891167727`*^9}, {3.6871583790964193`*^9, 
   3.687158413042079*^9}, 3.6895924605543594`*^9, {3.7262066801423664`*^9, 
   3.726206691530386*^9}, {3.7262067287676516`*^9, 3.726206739937271*^9}, {
   3.7559322809769473`*^9, 3.7559322847511635`*^9}, {3.755932534150428*^9, 
   3.755932558447818*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Integration", "Subsubsection",
 CellChangeTimes->{{3.6591631541798153`*^9, 3.6591631569643307`*^9}, 
   3.6591655902493143`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"f_", "?", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["MemberQ", "K"], "[", "#", "]"}], "&&", 
       RowBox[{"(", 
        RowBox[{"#", "=!=", "1"}], ")"}]}], "&"}], ")"}]}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"f", ",", " ", 
    RowBox[{"Int", "[", "1", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f__", ",", 
     RowBox[{"c_", "?", 
      SubscriptBox["MemberQ", "K"]}]}], "]"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{
    RowBox[{"Int", "[", 
     RowBox[{"mul", "[", "f", "]"}], "]"}], ",", "c"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{"Diff", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{"f", "-", 
   RowBox[{"Eval", "[", "f", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Int", "/:", 
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "f_", "]"}], ",", 
    RowBox[{"Int", "[", "g_", "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{
        RowBox[{"Int", "[", "f", "]"}], ",", "g"}], "]"}], "]"}], ",", "b"}], 
    "]"}], "+", 
   RowBox[{"mul", "[", 
    RowBox[{"a", ",", 
     RowBox[{"Int", "[", 
      RowBox[{"mul", "[", 
       RowBox[{"f", ",", 
        RowBox[{"Int", "[", "g", "]"}]}], "]"}], "]"}], ",", "b"}], 
    "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", 
    RowBox[{"c_", "?", 
     SubscriptBox["MemberQ", "K"]}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "c", ",", 
    RowBox[{"Int", "[", "1", "]"}], ",", "b"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Int", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"Int", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"c_", "?", "CoeffQ"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], ")"}]}], "]"}], ":=", 
  RowBox[{"c", " ", 
   RowBox[{"Int", "[", "f", "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.659162411432198*^9, 3.659162412408951*^9}, {
   3.659164197207127*^9, 3.659164197790752*^9}, {3.659171490362842*^9, 
   3.659171491487652*^9}, {3.6597013045303164`*^9, 3.6597013070497923`*^9}, {
   3.65970147718134*^9, 3.659701479851516*^9}, {3.670246390359516*^9, 
   3.670246410313141*^9}, {3.682835743292811*^9, 3.682835756499106*^9}, {
   3.682922363505677*^9, 3.6829223924145117`*^9}, {3.682926287313134*^9, 
   3.682926320109994*^9}, 3.6895924739343777`*^9, {3.723020749052878*^9, 
   3.723020756203888*^9}, {3.7559325694224453`*^9, 3.755932570262493*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Induced evaluation", "Subsubsection",
 CellChangeTimes->{{3.6591631661642323`*^9, 3.659163171220705*^9}, 
   3.659165594273448*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"f_", "?", 
    SubscriptBox["MemberQ", "K"]}], "]"}], ":=", "f"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", 
   RowBox[{"Int", "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Eval", "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{"Eval", ",", "f"}], "]"}]}], "\n", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mul", "[", 
   RowBox[{"a___", ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"inv", "[", 
      RowBox[{"f_", "?", 
       SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ",", 
    RowBox[{"Eval", "[", 
     RowBox[{"f_", "?", 
      SubscriptBox["MemberQ", "R"]}], "]"}], ",", "b___"}], "]"}], ":=", 
  RowBox[{"mul", "[", 
   RowBox[{"a", ",", "b"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.65916263319906*^9, 3.6591626335436068`*^9}, {
   3.670246424800674*^9, 3.670246429623632*^9}, {3.6828358313150043`*^9, 
   3.6828358410828857`*^9}, {3.6829210945837917`*^9, 3.682921099615996*^9}, {
   3.682922258911646*^9, 3.682922261329509*^9}, {3.6871018941824055`*^9, 
   3.687101922244011*^9}, 3.6871021395064373`*^9, 3.689592465414366*^9, {
   3.7468691954155674`*^9, 3.746869196190612*^9}, {3.7559325785899696`*^9, 
   3.7559325793570137`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functionals", "Subsubsection",
 CellChangeTimes->{{3.6591641415283527`*^9, 3.6591641443831253`*^9}, 
   3.6591656005776367`*^9}],

Cell[BoxData[{
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "1", "]"}], ":=", 
  "1"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_mul", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", "f_Plus", "]"}], ":=", 
  RowBox[{"Map", "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "i", "]"}], ",", "f"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalPhi]", "/:", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "i_Integer", "]"}], "[", 
   RowBox[{
    RowBox[{"\[CapitalPhi]", "[", "j_Integer", "]"}], "[", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], "]"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"\[CapitalPhi]", "[", "j", "]"}], "[", "f", "]"}]}]}], "Input",
 CellChangeTimes->{{3.6871017707413454`*^9, 3.6871017750975943`*^9}, {
   3.6871018476607447`*^9, 3.687101848025766*^9}, 3.687102142485608*^9, {
   3.755932585022338*^9, 3.755932585958391*^9}, {3.7559480254146247`*^9, 
   3.7559480260476613`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Reduction system for the ring of IDO", "Section",
 InitializationCell->True,
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.6895928521349087`*^9, 3.6895929344350233`*^9}, {3.6896046787532263`*^9, 
  3.689604682363433*^9}, {3.6941678932953777`*^9, 3.694167902694168*^9}, {
  3.7262066047006335`*^9, 3.726206607025038*^9}, {3.7559265782437696`*^9, 
  3.7559265828940353`*^9}, {3.7559327309576845`*^9, 3.7559327357819605`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["h", "K"], "[", "k_", "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"k", " ", 
    RowBox[{"Prod", "[", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "RR"], "[", 
   RowBox[{
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"g_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{"mul", "[", 
    RowBox[{"f", ",", "g"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]R"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"\[CurlyPhi]", "[", "f", "]"}], 
     RowBox[{"Prod", "[", "]"}]}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"], "[", 
   RowBox[{
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}], ",", 
    RowBox[{"\[Psi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", "\[Psi]", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "EI"], "[", 
   RowBox[{"Eval", ",", "Int"}], "]"}], ":=", "0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DR"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{"Diff", "[", "f", "]"}], "]"}], "+", 
   RowBox[{"Prod", "[", 
    RowBox[{"f", ",", "Diff"}], "]"}]}]}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "D\[CapitalPhi]"], "[", 
   RowBox[{"Diff", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", "0"}], "\n", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "DI"], "[", 
   RowBox[{"Diff", ",", "Int"}], "]"}], ":=", 
  RowBox[{"Prod", "[", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "I\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "1", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "ID"], "[", 
   RowBox[{"Int", ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "]"}], "-", 
   RowBox[{"Prod", "[", "Eval", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "II"], "[", 
   RowBox[{"Int", ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "1", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "1", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IR\[CapitalPhi]"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", 
    RowBox[{"\[CurlyPhi]_", "?", 
     SubscriptBox["MemberQ", "\[CapitalPhi]"]}]}], "]"}], ":=", 
  RowBox[{"Prod", "[", 
   RowBox[{
    RowBox[{"Int", "[", "f", "]"}], ",", "\[CurlyPhi]"}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRD"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Diff"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", "f", "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Eval", "[", "f", "]"}], " ", 
      RowBox[{"Prod", "[", "]"}]}], ",", "Eval"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Diff", "[", "f", "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["h", "IRI"], "[", 
   RowBox[{"Int", ",", 
    RowBox[{"f_", "?", 
     SubscriptBox["MemberQ", "R"]}], ",", "Int"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prod", "[", 
    RowBox[{
     RowBox[{"Int", "[", "f", "]"}], ",", "Int"}], "]"}], "-", 
   RowBox[{"Prod", "[", 
    RowBox[{"Int", ",", 
     RowBox[{"Int", "[", "f", "]"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.682830444156025*^9, 3.682830470225523*^9}, {
   3.682834198147834*^9, 3.682834214536252*^9}, {3.682851644402529*^9, 
   3.682851645428053*^9}, {3.6871003756050105`*^9, 3.68710039816265*^9}, {
   3.687151940149107*^9, 3.687151949961524*^9}, 3.6871521643059006`*^9, {
   3.687152270432887*^9, 3.687152272648091*^9}, {3.689592507214424*^9, 
   3.6895925166644373`*^9}, {3.6895925538644896`*^9, 3.689592565024505*^9}, {
   3.689592655624632*^9, 3.689592667544649*^9}, {3.6895927037147007`*^9, 
   3.6895928463249*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"RedSys", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "K", "}"}], ",", 
       SubscriptBox["h", "K"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "RR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<E\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "EI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "R"}], "}"}], ",", 
       SubscriptBox["h", "DR"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"D", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "DI"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "ID"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "II"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
       SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "D"}], "}"}], ",", 
       SubscriptBox["h", "IRD"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"\"\<I\>\"", ",", "R", ",", "\"\<I\>\""}], "}"}], ",", 
       SubscriptBox["h", "IRI"]}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{3.7558449384488935`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Check resolvability of ambiguities for the ring of IDO", "Section",
 CellChangeTimes->{{3.682830373294333*^9, 3.682830377957657*^9}, {
  3.6895792964155483`*^9, 3.6895793393312235`*^9}, {3.689579414982557*^9, 
  3.6895794381017976`*^9}, {3.7558555765203567`*^9, 3.7558555880400157`*^9}}],

Cell[TextData[{
 "Using the function ",
 StyleBox["CheckResolvability, ",
  FontWeight->"Bold"],
 "we can verify the confluence criterion for a given reduction system. The \
function generates  all the ambiguities and their S-polynomials. For each \
ambiguity, the function outputs those reduction rules applied for reducing \
the corresponding S-polynomials and checks whether the S-polynomials are \
reduced to zero. In the following, we apply this function to the reduction \
system ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    UnderscriptBox["\[Sum]", "IDO"],
    FontWeight->"Bold"], TraditionalForm]]],
 " as needed for the proof of ",
 StyleBox["Theorem 4.14",
  FontWeight->"Bold"],
 ". Some of these ",
 Cell[BoxData[
  FormBox[Cell["S"], TraditionalForm]]],
 "-polynomial reductions are given in ",
 StyleBox["Subsection 4.3.1",
  FontWeight->"Bold"],
 "."
}], "Text",
 CellChangeTimes->{{3.7558537226713223`*^9, 3.7558537274075937`*^9}, {
   3.7558537607345*^9, 3.7558537635836625`*^9}, {3.7558538198798823`*^9, 
   3.7558538437752495`*^9}, {3.755853897064297*^9, 3.755854030319919*^9}, {
   3.755854103152085*^9, 3.75585424607926*^9}, {3.755854296507144*^9, 
   3.7558546258319807`*^9}, {3.7558547399605083`*^9, 3.755854741080572*^9}, {
   3.7558547808798485`*^9, 3.755854788984312*^9}, {3.755854837448084*^9, 
   3.7558551813717556`*^9}, {3.755855222205091*^9, 3.75585528338359*^9}, {
   3.755855339920824*^9, 3.7558553637841887`*^9}, {3.755858575038862*^9, 
   3.7558585758849106`*^9}, {3.7558607748256826`*^9, 3.755860819936263*^9}, {
   3.7558608782565985`*^9, 3.7558608800246997`*^9}, {3.755860928072448*^9, 
   3.755860975094137*^9}, {3.755861008744062*^9, 3.755861053537624*^9}, {
   3.7558613975292993`*^9, 3.7558614022085667`*^9}, {3.755921478965108*^9, 
   3.75592151135796*^9}, {3.7559215473110166`*^9, 3.7559215498851643`*^9}, {
   3.755921627109581*^9, 3.7559216323498807`*^9}, 3.755921670990091*^9, {
   3.7559217220860133`*^9, 3.7559217530057817`*^9}, {3.755928557855997*^9, 
   3.755928567319538*^9}, {3.7559286049466906`*^9, 3.755928615978321*^9}, {
   3.755928685087274*^9, 3.7559287731023083`*^9}, {3.7559288072012587`*^9, 
   3.7559288371679726`*^9}, {3.7559319999018707`*^9, 3.755932001060937*^9}, 
   3.7559443531175814`*^9, 3.756104796953912*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CheckResolvability", "[", 
  RowBox[{"RedSys", ",", 
   RowBox[{"Count", "\[Rule]", " ", "True"}], ",", 
   RowBox[{"Print", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6877577093697076`*^9, 3.6877577214297247`*^9}, {
  3.6877764586098304`*^9, 3.687776471838587*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"52", "\[InvisibleSpace]", "\<\" ambiguities in total\"\>"}],
  SequenceForm[52, " ambiguities in total"],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480404984875`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
  "4", "\[InvisibleSpace]", "\<\" ambiguities have all S-polynomials equal to \
zero\"\>"}],
  SequenceForm[4, " ambiguities have all S-polynomials equal to zero"],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040525489*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"R", ",", "R", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "R", "}"}]}], "]"}]}],
  SequenceForm[1, ": ", 
   TenReS`Overlap[{$CellContext`R, $CellContext`R, $CellContext`R}, \
{$CellContext`R}, {$CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804053049*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804053249*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405344896`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"2", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalPhi]", ",", "R", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}]}],
  SequenceForm[2, ": ", 
   TenReS`Overlap[{$CellContext`\[CapitalPhi], $CellContext`R, \
$CellContext`R}, {$CellContext`R}, {$CellContext`\[CapitalPhi]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405364895`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405384903`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804054149*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"3", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}]}],
  SequenceForm[3, ": ", 
   TenReS`Overlap[{$CellContext`\[CapitalPhi], $CellContext`\[CapitalPhi], \
$CellContext`R}, {$CellContext`R}, {$CellContext`\[CapitalPhi]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405434904`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405454903`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804054749*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"4", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]", ",", "\[CapitalPhi]"}], 
      "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}]}],
  SequenceForm[4, ": ", 
   TenReS`Overlap[{$CellContext`\[CapitalPhi], $CellContext`\[CapitalPhi], \
$CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {$CellContext`\
\[CapitalPhi]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040549491*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040551491*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405534906`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"5", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], 
     ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[5, ": ", 
   TenReS`Overlap[{
    "E", "I", $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {
    "E"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040556491*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040558491*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"6", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[6, ": ", 
   TenReS`Overlap[{"E", "I", D}, {D}, {"E"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040561491*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405634913`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"7", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[7, ": ", 
   TenReS`Overlap[{"E", "I", "I"}, {"I"}, {"E"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405654917`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405674915`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405694914`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"8", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[8, ": ", 
   TenReS`Overlap[{
    "E", "I", $CellContext`R, $CellContext`\[CapitalPhi]}, {$CellContext`R, \
$CellContext`\[CapitalPhi]}, {"E"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405714917`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040574492*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"9", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[9, ": ", 
   TenReS`Overlap[{"E", "I", $CellContext`R, D}, {$CellContext`R, D}, {"E"}]],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405764923`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040578492*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405804925`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405824924`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"10", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"E\"\>", "}"}]}], "]"}]}],
  SequenceForm[10, ": ", 
   TenReS`Overlap[{"E", "I", $CellContext`R, "I"}, {$CellContext`R, "I"}, {
    "E"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405844927`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405864925`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040588493*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"11", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "R", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[11, ": ", 
   TenReS`Overlap[{D, $CellContext`R, $CellContext`R}, {$CellContext`R}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405914927`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040592493*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040594493*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405964932`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480405984936`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406004934`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"12", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\[CapitalPhi]", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[12, ": ", 
   TenReS`Overlap[{
    D, $CellContext`\[CapitalPhi], $CellContext`R}, {$CellContext`R}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406024933`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406044936`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"13", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[13, ": ", 
   TenReS`Overlap[{
    D, $CellContext`\[CapitalPhi], $CellContext`\[CapitalPhi]}, \
{$CellContext`\[CapitalPhi]}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040606494*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040608494*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"14", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[14, ": ", 
   TenReS`Overlap[{
    D, "I", $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406104937`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406124945`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040613494*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406154947`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"15", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[15, ": ", 
   TenReS`Overlap[{D, "I", D}, {D}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406174946`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406194944`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"16", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[16, ": ", 
   TenReS`Overlap[{D, "I", "I"}, {"I"}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040621495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "DI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040623495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040625495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040626495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "DI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040628495*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"17", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[17, ": ", 
   TenReS`Overlap[{
    D, "I", $CellContext`R, $CellContext`\[CapitalPhi]}, {$CellContext`R, \
$CellContext`\[CapitalPhi]}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040630495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040632495*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406344957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"18", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[18, ": ", 
   TenReS`Overlap[{D, "I", $CellContext`R, D}, {$CellContext`R, D}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406364956`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406384954`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "DI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040640496*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "D\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406414957`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"19", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[19, ": ", 
   TenReS`Overlap[{D, "I", $CellContext`R, "I"}, {$CellContext`R, "I"}, {D}]],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040644496*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "DI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040645496*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "DR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040647496*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"D", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "DI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040649496*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"20", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[20, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`\[CapitalPhi], $CellContext`R}, {$CellContext`R}, {
    "I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406514964`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406534967`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406554966`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"21", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]", ",", "\[CapitalPhi]"}], 
      "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[21, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`\[CapitalPhi], $CellContext`\[CapitalPhi]}, \
{$CellContext`\[CapitalPhi]}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406574965`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040658497*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406604967`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"22", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "D", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[22, ": ", 
   TenReS`Overlap[{"I", D, $CellContext`R}, {$CellContext`R}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040662497*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406644974`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040666497*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"23", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "D", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[23, ": ", 
   TenReS`Overlap[{
    "I", D, $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040668497*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040670498*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"24", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "D", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[24, ": ", 
   TenReS`Overlap[{"I", D, "I"}, {"I"}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406724977`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406744976`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"25", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], 
     ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[25, ": ", 
   TenReS`Overlap[{
    "I", "I", $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {
    "I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406764975`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040677498*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406794977`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040681498*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"26", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[26, ": ", 
   TenReS`Overlap[{"I", "I", D}, {D}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406834984`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040685498*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040687498*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "ID"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040689499*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040690499*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"27", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[27, ": ", 
   TenReS`Overlap[{"I", "I", "I"}, {"I"}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480406924987`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040694499*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040696499*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040698499*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040699499*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040701499*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"28", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[28, ": ", 
   TenReS`Overlap[{
    "I", "I", $CellContext`R, $CellContext`\[CapitalPhi]}, {$CellContext`R, \
$CellContext`\[CapitalPhi]}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407034993`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407054996`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407074995`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407094994`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407115*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407125*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"29", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[29, ": ", 
   TenReS`Overlap[{"I", "I", $CellContext`R, D}, {$CellContext`R, D}, {"I"}]],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407155*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407165003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407185*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407205005`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407225003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407235003`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040725501*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040727501*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"30", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[30, ": ", 
   TenReS`Overlap[{"I", "I", $CellContext`R, "I"}, {$CellContext`R, "I"}, {
    "I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040729501*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040731501*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407335014`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407355013`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040737501*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407385015`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407405014`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407425013`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"31", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]", ",", "R"}], "}"}], 
     ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[31, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, $CellContext`\[CapitalPhi], $CellContext`R}, \
{$CellContext`R}, {"I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407445016`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040746502*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040748502*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"32", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]", ",", 
       "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[32, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, $CellContext`\[CapitalPhi], $CellContext`\
\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {"I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040750502*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407525024`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407545023`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"33", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "D", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[33, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, D, $CellContext`R}, {$CellContext`R}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040756502*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407585025`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040760503*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407625027`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]R"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040763503*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040765503*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407675033`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"34", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "D", ",", "\[CapitalPhi]"}], "}"}], 
     ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[34, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, 
     D, $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040769503*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407715034`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalPhi]", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "\[CapitalPhi]\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407735033`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407755036`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"35", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "D", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[35, ": ", 
   TenReS`Overlap[{"I", $CellContext`R, D, "I"}, {"I"}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407775035`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040779504*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407805037`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040782504*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040784504*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"36", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "\[CapitalPhi]"}],
       "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[36, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, 
     "I", $CellContext`\[CapitalPhi]}, {$CellContext`\[CapitalPhi]}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040786504*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407885046`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407905045`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407925043`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480407945046`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040796505*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"37", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[37, ": ", 
   TenReS`Overlap[{"I", $CellContext`R, "I", D}, {D}, {"I", $CellContext`R}]],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040798505*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408005047`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408025055`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "ID"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040803505*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"38", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "\<\"I\"\>"}], 
      "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[38, ": ", 
   TenReS`Overlap[{"I", $CellContext`R, "I", "I"}, {"I"}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040806505*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040808505*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040810506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408125057`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408135056`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040815506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040817506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408195057`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"39", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "R", ",", 
       "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[39, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, 
     "I", $CellContext`R, $CellContext`\[CapitalPhi]}, {$CellContext`R, \
$CellContext`\[CapitalPhi]}, {"I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040821506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408235064`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040825506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040827506*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040829507*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040830507*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040832507*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"40", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "R", ",", "D"}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "D"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[40, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, "I", $CellContext`R, D}, {$CellContext`R, D}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040835507*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408375072`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "IR\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040838507*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408405075`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408425074`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408445077`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408465075`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408475075`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "IRD"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408495073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"41", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"Overlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>", ",", "R", 
       ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"R", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[41, ": ", 
   TenReS`Overlap[{
    "I", $CellContext`R, "I", $CellContext`R, "I"}, {$CellContext`R, "I"}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040852508*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040854508*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408565083`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040857508*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408595085`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408615084`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040863508*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "IRI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040865509*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"R", ",", "R"}], "}"}], ",", 
   SubscriptBox["h", "RR"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408665085`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"42", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialOverlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalPhi]", ",", "\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], 
     ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}]}],
  SequenceForm[42, ": ", 
   TenReS`SpecialOverlap[{$CellContext`\[CapitalPhi], "E", "I"}, {
    "I"}, {$CellContext`\[CapitalPhi]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408695087`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040871509*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"43", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialOverlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[43, ": ", 
   TenReS`SpecialOverlap[{D, "E", "I"}, {"I"}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408735094`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"44", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialOverlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[44, ": ", 
   TenReS`SpecialOverlap[{"I", "E", "I"}, {"I"}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408755093`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040877509*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"45", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialOverlap", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R", ",", "\<\"E\"\>", ",", "\<\"I\"\>"}], 
      "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "R"}], "}"}]}], "]"}]}],
  SequenceForm[45, ": ", 
   TenReS`SpecialOverlap[{"I", $CellContext`R, "E", "I"}, {"I"}, {
    "I", $CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408805094`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"E\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "EI"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804088151*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"46", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"K", ",", "R"}], "}"}], ",", 
     RowBox[{"{", "}"}], ",", 
     RowBox[{"{", "R", "}"}]}], "]"}]}],
  SequenceForm[46, ": ", 
   TenReS`SpecialInclusion[{K, $CellContext`R}, {}, {$CellContext`R}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408845096`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"47", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"R", ",", "K"}], "}"}], ",", 
     RowBox[{"{", "R", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}],
  SequenceForm[47, ": ", 
   TenReS`SpecialInclusion[{$CellContext`R, K}, {$CellContext`R}, {}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804088651*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"48", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[CapitalPhi]", ",", "K"}], "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}],
  SequenceForm[48, ": ", 
   TenReS`SpecialInclusion[{$CellContext`\[CapitalPhi], 
     K}, {$CellContext`\[CapitalPhi]}, {}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408885098`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"49", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"D", ",", "K"}], "}"}], ",", 
     RowBox[{"{", "D", "}"}], ",", 
     RowBox[{"{", "}"}]}], "]"}]}],
  SequenceForm[49, ": ", 
   TenReS`SpecialInclusion[{D, K}, {D}, {}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804089051*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408925104`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"50", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "K", ",", "\[CapitalPhi]"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\[CapitalPhi]", "}"}]}], "]"}]}],
  SequenceForm[50, ": ", 
   TenReS`SpecialInclusion[{"I", K, $CellContext`\[CapitalPhi]}, {
    "I"}, {$CellContext`\[CapitalPhi]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408945103`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\[CapitalPhi]"}], "}"}], ",", 
   SubscriptBox["h", "I\[CapitalPhi]"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.75594804089651*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"51", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "K", ",", "D"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "D", "}"}]}], "]"}]}],
  SequenceForm[51, ": ", 
   TenReS`SpecialInclusion[{"I", K, D}, {"I"}, {D}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480408985105`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "K", "}"}], ",", 
   SubscriptBox["h", "K"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040900511*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "D"}], "}"}], ",", 
   SubscriptBox["h", "ID"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480409025106`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"52", "\[InvisibleSpace]", "\<\": \"\>", "\[InvisibleSpace]", 
   RowBox[{"SpecialInclusion", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\"I\"\>", ",", "K", ",", "\<\"I\"\>"}], "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}], ",", 
     RowBox[{"{", "\<\"I\"\>", "}"}]}], "]"}]}],
  SequenceForm[52, ": ", 
   TenReS`SpecialInclusion[{"I", K, "I"}, {"I"}, {"I"}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480409045105`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"I\"\>", ",", "\<\"I\"\>"}], "}"}], ",", 
   SubscriptBox["h", "II"]}], "}"}]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.7559480409065113`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"52", "\[InvisibleSpace]", "\<\" ambiguities are resolvable\"\>"}],
  SequenceForm[52, " ambiguities are resolvable"],
  Editable->False]], "Print",
 CellChangeTimes->{3.749442319162122*^9, 3.7559327528109345`*^9, 
  3.7559336758697305`*^9, 3.755948040908511*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmVkYGDQAeJfc6I9iwteO8YHiv+fC6Q/bLTTXQCk102cmr8USKdv
n1UDollWuUwC0QlaBttAtOdu43Mg+lBldPgyIJ3GEdgLoh1DHl0D0csiI5dM
rQDqk+f3ngakZylerQfRwk9f94PoIGHx2yDaJ0vuG4heMuvlbxDNxFi2fDqQ
9g9Ivg6iV92b8w5EX2bpZJwBpLOmNfGA6AaWKdrrgbTF2+NmIHpZyAM3EN1x
2S8ERHe6Zn65Vvna8V3PF/EHQNryBpshiLbKYXEE0Xf6c4+C6C+JbhyBta8d
j8UxKoHoe1FBeiBa8FFtSRiQ/jOLpRpEb/NkaQLRMxx/74wA0pd0F0fWvX/t
mHnvSyKIDjqm3nX/92vHlbPb/4LoF0qyjM+BNADQaLpv
  "]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1904, 982},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>2. Inherited,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 29, 2015)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info-534e4566-7628-4f69-b46a-fb1a18609de3"->{
  Cell[2013, 53, 288, 5, 84, "Print",
   CellTags->"Info-534e4566-7628-4f69-b46a-fb1a18609de3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info-534e4566-7628-4f69-b46a-fb1a18609de3", 109560, 3193}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 405, 8, 60, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1010, 34, 1000, 17, 112, "Print"],
Cell[2013, 53, 288, 5, 84, "Print",
 CellTags->"Info-534e4566-7628-4f69-b46a-fb1a18609de3"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2350, 64, 231, 4, 127, "Section",
 InitializationCell->True],
Cell[2584, 70, 763, 22, 100, "Text"],
Cell[3350, 94, 908, 20, 66, "Input"],
Cell[4261, 116, 698, 17, 60, "Input"],
Cell[CellGroupData[{
Cell[4984, 137, 105, 1, 85, "Subsection"],
Cell[5092, 140, 3023, 85, 213, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8152, 230, 160, 2, 85, "Subsection"],
Cell[8315, 234, 102, 1, 60, "Text"],
Cell[8420, 237, 436, 10, 60, "Input"],
Cell[8859, 249, 205, 2, 60, "Text"],
Cell[9067, 253, 1979, 53, 289, "Input"],
Cell[11049, 308, 104, 1, 60, "Text"],
Cell[11156, 311, 570, 13, 99, "Input"],
Cell[11729, 326, 182, 2, 60, "Text"],
Cell[11914, 330, 509, 14, 137, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12460, 349, 155, 2, 85, "Subsection"],
Cell[CellGroupData[{
Cell[12640, 355, 105, 1, 67, "Subsubsection"],
Cell[12748, 358, 2448, 63, 365, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15233, 426, 134, 2, 67, "Subsubsection"],
Cell[15370, 430, 3126, 72, 289, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18533, 507, 134, 2, 67, "Subsubsection"],
Cell[18670, 511, 2878, 82, 289, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21585, 598, 137, 2, 67, "Subsubsection"],
Cell[21725, 602, 1862, 49, 251, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23624, 656, 134, 2, 67, "Subsubsection"],
Cell[23761, 660, 1270, 31, 175, "Input"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25092, 698, 454, 6, 127, "Section",
 InitializationCell->True],
Cell[25549, 706, 4818, 143, 555, "Input"],
Cell[30370, 851, 2452, 74, 137, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32859, 930, 293, 3, 127, "Section"],
Cell[33155, 935, 2282, 44, 177, "Text"],
Cell[CellGroupData[{
Cell[35462, 983, 314, 6, 60, "Input"],
Cell[CellGroupData[{
Cell[35801, 993, 297, 6, 43, "Print"],
Cell[36101, 1001, 354, 8, 43, "Print"],
Cell[36458, 1011, 573, 14, 43, "Print"],
Cell[37034, 1027, 259, 7, 43, "Print"],
Cell[37296, 1036, 262, 7, 43, "Print"],
Cell[37561, 1045, 624, 14, 43, "Print"],
Cell[38188, 1061, 286, 7, 43, "Print"],
Cell[38477, 1070, 283, 7, 43, "Print"],
Cell[38763, 1079, 648, 14, 43, "Print"],
Cell[39414, 1095, 286, 7, 43, "Print"],
Cell[39703, 1104, 307, 7, 43, "Print"],
Cell[40013, 1113, 703, 16, 43, "Print"],
Cell[40719, 1131, 308, 7, 43, "Print"],
Cell[41030, 1140, 310, 7, 43, "Print"],
Cell[41343, 1149, 627, 16, 43, "Print"],
Cell[41973, 1167, 284, 7, 43, "Print"],
Cell[42260, 1176, 537, 13, 43, "Print"],
Cell[42800, 1191, 310, 7, 43, "Print"],
Cell[43113, 1200, 559, 13, 43, "Print"],
Cell[43675, 1215, 278, 7, 43, "Print"],
Cell[43956, 1224, 286, 7, 43, "Print"],
Cell[44245, 1233, 696, 17, 43, "Print"],
Cell[44944, 1252, 284, 7, 43, "Print"],
Cell[45231, 1261, 611, 15, 43, "Print"],
Cell[45845, 1278, 284, 7, 43, "Print"],
Cell[46132, 1287, 278, 7, 43, "Print"],
Cell[46413, 1296, 310, 7, 43, "Print"],
Cell[46726, 1305, 642, 16, 43, "Print"],
Cell[47371, 1323, 278, 7, 43, "Print"],
Cell[47652, 1332, 284, 7, 43, "Print"],
Cell[47939, 1341, 550, 13, 43, "Print"],
Cell[48492, 1356, 260, 7, 43, "Print"],
Cell[48755, 1365, 260, 7, 43, "Print"],
Cell[49018, 1374, 262, 7, 86, "Print"],
Cell[49283, 1383, 262, 7, 86, "Print"],
Cell[49548, 1392, 262, 7, 86, "Print"],
Cell[49813, 1401, 579, 14, 86, "Print"],
Cell[50395, 1417, 286, 7, 86, "Print"],
Cell[50684, 1426, 627, 15, 86, "Print"],
Cell[51314, 1443, 284, 7, 86, "Print"],
Cell[51601, 1452, 600, 14, 86, "Print"],
Cell[52204, 1468, 262, 7, 86, "Print"],
Cell[52469, 1477, 234, 6, 86, "Print"],
Cell[52706, 1485, 286, 7, 86, "Print"],
Cell[52995, 1494, 521, 13, 86, "Print"],
Cell[53519, 1509, 286, 7, 86, "Print"],
Cell[53808, 1518, 539, 13, 86, "Print"],
Cell[54350, 1533, 268, 7, 86, "Print"],
Cell[54621, 1542, 260, 7, 86, "Print"],
Cell[54884, 1551, 234, 6, 86, "Print"],
Cell[55121, 1559, 268, 7, 86, "Print"],
Cell[55392, 1568, 675, 17, 86, "Print"],
Cell[56070, 1587, 260, 7, 86, "Print"],
Cell[56333, 1596, 286, 7, 86, "Print"],
Cell[56622, 1605, 590, 14, 86, "Print"],
Cell[57215, 1621, 262, 7, 86, "Print"],
Cell[57480, 1630, 268, 7, 86, "Print"],
Cell[57751, 1639, 286, 7, 86, "Print"],
Cell[58040, 1648, 611, 15, 86, "Print"],
Cell[58654, 1665, 268, 7, 86, "Print"],
Cell[58925, 1674, 260, 7, 86, "Print"],
Cell[59188, 1683, 268, 7, 86, "Print"],
Cell[59459, 1692, 604, 15, 86, "Print"],
Cell[60066, 1709, 286, 7, 86, "Print"],
Cell[60355, 1718, 294, 7, 86, "Print"],
Cell[60652, 1727, 656, 16, 86, "Print"],
Cell[61311, 1745, 292, 7, 86, "Print"],
Cell[61606, 1754, 310, 7, 86, "Print"],
Cell[61919, 1763, 555, 13, 86, "Print"],
Cell[62477, 1778, 286, 7, 86, "Print"],
Cell[62766, 1787, 279, 7, 86, "Print"],
Cell[63048, 1796, 608, 14, 86, "Print"],
Cell[63659, 1812, 308, 7, 86, "Print"],
Cell[63970, 1821, 551, 13, 86, "Print"],
Cell[64524, 1836, 278, 7, 86, "Print"],
Cell[64805, 1845, 631, 16, 86, "Print"],
Cell[65439, 1863, 303, 7, 86, "Print"],
Cell[65745, 1872, 294, 7, 86, "Print"],
Cell[66042, 1881, 260, 7, 86, "Print"],
Cell[66305, 1890, 541, 13, 86, "Print"],
Cell[66849, 1905, 292, 7, 86, "Print"],
Cell[67144, 1914, 279, 7, 86, "Print"],
Cell[67426, 1923, 268, 7, 86, "Print"],
Cell[67697, 1932, 234, 6, 86, "Print"],
Cell[67934, 1940, 561, 13, 86, "Print"],
Cell[68498, 1955, 276, 7, 86, "Print"],
Cell[68777, 1964, 287, 7, 86, "Print"],
Cell[69067, 1973, 276, 7, 86, "Print"],
Cell[69346, 1982, 260, 7, 86, "Print"],
Cell[69609, 1991, 260, 7, 86, "Print"],
Cell[69872, 2000, 698, 17, 86, "Print"],
Cell[70573, 2019, 305, 7, 86, "Print"],
Cell[70881, 2028, 262, 7, 86, "Print"],
Cell[71146, 2037, 305, 7, 86, "Print"],
Cell[71454, 2046, 301, 7, 86, "Print"],
Cell[71758, 2055, 258, 7, 86, "Print"],
Cell[72019, 2064, 609, 15, 86, "Print"],
Cell[72631, 2081, 278, 7, 86, "Print"],
Cell[72912, 2090, 290, 7, 86, "Print"],
Cell[73205, 2099, 262, 7, 86, "Print"],
Cell[73470, 2108, 281, 7, 86, "Print"],
Cell[73754, 2117, 262, 7, 86, "Print"],
Cell[74019, 2126, 260, 7, 86, "Print"],
Cell[74282, 2135, 279, 7, 86, "Print"],
Cell[74564, 2144, 640, 16, 86, "Print"],
Cell[75207, 2162, 276, 7, 86, "Print"],
Cell[75486, 2171, 289, 7, 86, "Print"],
Cell[75778, 2180, 262, 7, 86, "Print"],
Cell[76043, 2189, 287, 7, 86, "Print"],
Cell[76333, 2198, 262, 7, 86, "Print"],
Cell[76598, 2207, 289, 7, 86, "Print"],
Cell[76890, 2216, 262, 7, 86, "Print"],
Cell[77155, 2225, 676, 17, 86, "Print"],
Cell[77834, 2244, 303, 7, 86, "Print"],
Cell[78140, 2253, 284, 7, 86, "Print"],
Cell[78427, 2262, 724, 17, 86, "Print"],
Cell[79154, 2281, 305, 7, 86, "Print"],
Cell[79462, 2290, 310, 7, 86, "Print"],
Cell[79775, 2299, 634, 16, 86, "Print"],
Cell[80412, 2317, 262, 7, 86, "Print"],
Cell[80677, 2326, 260, 7, 86, "Print"],
Cell[80940, 2335, 262, 7, 86, "Print"],
Cell[81205, 2344, 284, 7, 86, "Print"],
Cell[81492, 2353, 260, 7, 86, "Print"],
Cell[81755, 2362, 281, 7, 86, "Print"],
Cell[82039, 2371, 694, 18, 86, "Print"],
Cell[82736, 2391, 305, 7, 86, "Print"],
Cell[83044, 2400, 310, 7, 86, "Print"],
Cell[83357, 2409, 236, 6, 86, "Print"],
Cell[83596, 2417, 625, 15, 86, "Print"],
Cell[84224, 2434, 287, 7, 86, "Print"],
Cell[84514, 2443, 278, 7, 86, "Print"],
Cell[84795, 2452, 234, 6, 86, "Print"],
Cell[85032, 2460, 234, 6, 86, "Print"],
Cell[85269, 2468, 705, 18, 86, "Print"],
Cell[85977, 2488, 305, 7, 86, "Print"],
Cell[86285, 2497, 294, 7, 86, "Print"],
Cell[86582, 2506, 262, 7, 86, "Print"],
Cell[86847, 2515, 305, 7, 86, "Print"],
Cell[87155, 2524, 260, 7, 86, "Print"],
Cell[87418, 2533, 611, 15, 86, "Print"],
Cell[88032, 2550, 305, 7, 86, "Print"],
Cell[88340, 2559, 281, 7, 86, "Print"],
Cell[88624, 2568, 268, 7, 86, "Print"],
Cell[88895, 2577, 640, 16, 86, "Print"],
Cell[89538, 2595, 287, 7, 86, "Print"],
Cell[89828, 2604, 276, 7, 86, "Print"],
Cell[90107, 2613, 289, 7, 86, "Print"],
Cell[90399, 2622, 262, 7, 86, "Print"],
Cell[90664, 2631, 260, 7, 86, "Print"],
Cell[90927, 2640, 287, 7, 86, "Print"],
Cell[91217, 2649, 262, 7, 86, "Print"],
Cell[91482, 2658, 772, 19, 86, "Print"],
Cell[92257, 2679, 262, 7, 86, "Print"],
Cell[92522, 2688, 260, 7, 86, "Print"],
Cell[92785, 2697, 303, 7, 86, "Print"],
Cell[93091, 2706, 303, 7, 86, "Print"],
Cell[93397, 2715, 303, 7, 86, "Print"],
Cell[93703, 2724, 260, 7, 86, "Print"],
Cell[93966, 2733, 694, 18, 86, "Print"],
Cell[94663, 2753, 262, 7, 86, "Print"],
Cell[94928, 2762, 303, 7, 86, "Print"],
Cell[95234, 2771, 289, 7, 86, "Print"],
Cell[95526, 2780, 262, 7, 86, "Print"],
Cell[95791, 2789, 281, 7, 86, "Print"],
Cell[96075, 2798, 262, 7, 86, "Print"],
Cell[96340, 2807, 262, 7, 86, "Print"],
Cell[96605, 2816, 281, 7, 86, "Print"],
Cell[96889, 2825, 715, 18, 86, "Print"],
Cell[97607, 2845, 287, 7, 86, "Print"],
Cell[97897, 2854, 262, 7, 86, "Print"],
Cell[98162, 2863, 260, 7, 86, "Print"],
Cell[98425, 2872, 289, 7, 86, "Print"],
Cell[98717, 2881, 262, 7, 86, "Print"],
Cell[98982, 2890, 287, 7, 86, "Print"],
Cell[99272, 2899, 287, 7, 86, "Print"],
Cell[99562, 2908, 262, 7, 86, "Print"],
Cell[99827, 2917, 640, 15, 86, "Print"],
Cell[100470, 2934, 276, 7, 86, "Print"],
Cell[100749, 2943, 555, 13, 86, "Print"],
Cell[101307, 2958, 575, 13, 86, "Print"],
Cell[101885, 2973, 276, 7, 86, "Print"],
Cell[102164, 2982, 656, 16, 86, "Print"],
Cell[102823, 3000, 275, 7, 86, "Print"],
Cell[103101, 3009, 536, 13, 86, "Print"],
Cell[103640, 3024, 533, 13, 86, "Print"],
Cell[104176, 3039, 590, 14, 86, "Print"],
Cell[104769, 3055, 507, 13, 86, "Print"],
Cell[105279, 3070, 236, 6, 86, "Print"],
Cell[105518, 3078, 628, 14, 86, "Print"],
Cell[106149, 3094, 291, 7, 86, "Print"],
Cell[106443, 3103, 549, 13, 86, "Print"],
Cell[106995, 3118, 234, 6, 86, "Print"],
Cell[107232, 3126, 270, 7, 86, "Print"],
Cell[107505, 3135, 569, 13, 86, "Print"],
Cell[108077, 3150, 278, 7, 86, "Print"],
Cell[108358, 3159, 307, 6, 86, "Print"]
}, Open  ]],
Cell[108680, 3168, 499, 10, 168, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
